

/*
 * Copyright 1999 Finn Bock.
 * Permission to use, copy and distribute this software is hereby granted, 
 * provided that the above copyright notice appear in all copies and that 
 * both that copyright notice and this permission notice appear.
 * 
 * No Warranty
 * The software is provided "as is" without warranty of any kind.
 * 
 * If you have questions regarding this software, contact:
 *    Finn Bock, bckfnn@pipmail.dknet.dk
 * 
 * This program contains material copyrighted by:
 * Copyright 1991-1995 by Stichting Mathematisch Centrum, Amsterdam,
 * The Netherlands.
 *
 */

#include "posixmodule.h"

#include "pyutil.h"
#include "jnios_posix.h"

#define _PACKAGE(f) Java_jnios_posix_##f


//
// Stolen from Python.h
//
#include <stdio.h>
#include <string.h>
#include <errno.h>
#ifdef HAVE_STDLIB_H
#include <stdlib.h>
#endif



jthrowable _TypeErrorStringExpected;
jobject OSError;


#ifdef Darwin
	//nk add 07/12/26 This global variable needs to compile on Mac OS 10.4 Tiger
	char **environ;
#endif









// ̃\[XłgpȂ[JȊ֐̐錾

jint	addrArrToSockaddr( jlong* addrArr, struct sockaddr_in* );
//ǂaddrArrAstruct sockaddrXXXɕϊ. ߂l͍\̂̃TCY.AA2ɂ͏\傫ȋԂȂ΂ȂȂ.

jint	sockaddrToAddrArr( struct sockaddr* addr, int addrlen, jlong* addrArr);

jint	bindIPv4(JNIEnv *env, jclass jcls, jint fd, jlongArray addrArr);

jint	bindIPv6(JNIEnv *env, jclass jcls, jint fd, jlongArray addrArr);

jint	bindUN(JNIEnv *env, jclass jcls, jint fd, jlongArray addrArr);








//
// Return a Hashtable corresponding to the POSIX environment table 
//

JNIEXPORT jobject JNICALL _PACKAGE(convertenviron)(JNIEnv* env, jclass jcls)
{
    jclass jclshashtable = env->FindClass("java/util/Hashtable");
    CHECK(jclshashtable, return NULL, "FindClass(java/util/Hashtable) failed");

    jmethodID jinit = env->GetMethodID(jclshashtable, "<init>", "()V");
    CHECK(jinit, return NULL, "Hashtable.<init> failed");

    jobject d = env->NewObject(jclshashtable, jinit);
    CHECK(d, return NULL, "new Hashtable() failed");

    jmethodID jput = env->GetMethodID(jclshashtable, "put",
		"(Ljava/lang/Object;Ljava/lang/Object;)Ljava/lang/Object;");
    CHECK(jput, return NULL, "Hashtable.put failed");

    if (environ == NULL)
	return d;
    /* XXX This part ignores errors */
    for (char** e = environ; *e != NULL; e++) {
	char *p = strchr(*e, '=');
	if (p == NULL)
	    continue;
	jstring v = env->NewStringUTF(p+1);
	if (v == NULL)
	    continue;
	*p = '\0';
	jstring k = env->NewStringUTF(*e);
	*p = '=';
	if (k == NULL)
	    continue;
	env->CallObjectMethod(d, jput, k, v);
    }
#if defined(PYOS_OS2)
    {
        APIRET rc;
        char   buffer[1024]; /* OS/2 Provides a Documented Max of 1024 Chars */

        rc = DosQueryExtLIBPATH(buffer, BEGIN_LIBPATH);
        if (rc == NO_ERROR) { /* (not a type, envname is NOT 'BEGIN_LIBPATH') */
	    jstring k = env->NewStringUTF("BEGINLIBPATH");
	    jstring v = env->NewStringUTF(buffer);
	    env->CallObjectMethod(d, jput, k, v);
        }
        rc = DosQueryExtLIBPATH(buffer, END_LIBPATH);
        if (rc == NO_ERROR) { /* (not a typo, envname is NOT 'END_LIBPATH') */
	    jstring k = env->NewStringUTF("ENDLIBPATH");
	    jstring v = env->NewStringUTF(buffer);
	    env->CallObjectMethod(d, jput, k, v);
        }
    }
#endif
    return d;
}





JNIEXPORT jint JNICALL _PACKAGE(chdir)(JNIEnv *env, jclass jcls, 
    jstring jpath) 
{
    StringUTFChars path(env, jpath);
    int	ret = EFAULT;
    if (path.throwIfNull(_TypeErrorStringExpected))
    	return ret;
    if ( ( ret = chdir(path) ) < 0)
	throwFromErrno(env, OSError, path);
	return ret;
}


JNIEXPORT jint JNICALL _PACKAGE(chmod)(JNIEnv *env, jclass jcls, 
    jstring jpath, jint jmode) 
{
	//߂lvoidintɕύX
	
	int ret = EFAULT;
    StringUTFChars path(env, jpath);
    if (path.throwIfNull(_TypeErrorStringExpected))
    	return EFAULT;

    if ( ( ret = chmod(path, jmode) ) < 0)
		throwFromErrno(env, OSError, path);
		
	return ret;
}


#ifdef HAVE_FSYNC
JNIEXPORT void JNICALL _PACKAGE(chown)(JNIEnv *env, jclass jcls, 
    jint jfd) 
{
    if (fsync(jfd) < 0)
	throwFromErrno(env, OSError);
}
#endif /* HAVE_FSYNC */



#ifdef HAVE_FDATASYNC
extern int fdatasync(int); /* Prototype just in case */

JNIEXPORT void JNICALL _PACKAGE(chown)(JNIEnv *env, jclass jcls, 
    jint jfd) 
{
    if (fdatasync(jfd) < 0)
	throwFromErrno(env, OSError);
}
#endif /* HAVE_FDATASYNC */



#ifdef HAVE_CHOWN
JNIEXPORT void JNICALL _PACKAGE(chown)(JNIEnv *env, jclass jcls, 
    jstring jpath, jint uid, jint gid) 
{
    StringUTFChars path(env, jpath);
    if (path.throwIfNull(_TypeErrorStringExpected))
    	return;

    if (chown(path, (int)uid, (int)gid) < 0)
	throwFromErrno(env, OSError, path);
}
#endif /* HAVE_CHOWN */



#ifdef HAVE_GETCWD
JNIEXPORT jstring JNICALL _PACKAGE(getcwd)(JNIEnv *env, jclass jcls)
{
    char buf[1026];
    if (getcwd(buf, sizeof buf) == NULL)
	throwFromErrno(env, OSError);
    return env->NewStringUTF(buf);
}
#endif


#ifdef HAVE_LINK
JNIEXPORT int JNICALL _PACKAGE(link)(JNIEnv *env, jclass jcls,
    jstring jsrc, jstring jdst)
{
/*
	int^Ԃ悤ɎύX
*/
	int ret = -1;

    StringUTFChars src(env, jsrc);
    if (src.throwIfNull(_TypeErrorStringExpected))
    	return ret;
    StringUTFChars dst(env, jdst);
    if (dst.throwIfNull(_TypeErrorStringExpected))
    	return ret;

    if ( (ret = link(src, dst) ) < 0)
	{
		throwFromErrno(env, OSError);
	}
	
	return ret;
}
#endif /* HAVE_LINK */



JNIEXPORT jint JNICALL _PACKAGE(mkdir)(JNIEnv *env, jclass jcls,
    jstring jpath, jint jmode)
{
	int ret = EFAULT;
	
    StringUTFChars path(env, jpath);
    if (path.throwIfNull(_TypeErrorStringExpected))
    	return ret;

#if ( defined(__WATCOMC__) || defined(_MSC_VER) || defined(PYCC_VACPP) ) && !defined(__QNX__)
    int res = mkdir(path);
#else
    int res = mkdir(path, jmode);
#endif
    if (res < 0)
	throwFromErrno(env, OSError, path);
	
	ret = res;
	return ret;
}


JNIEXPORT jint JNICALL _PACKAGE(rmdir)(JNIEnv *env, jclass jcls,
    jstring jpath)
{
	int ret = EFAULT;
	
    StringUTFChars path(env, jpath);
    if (path.throwIfNull(_TypeErrorStringExpected))
    	return ret;
    if ( ( ret = rmdir(path) ) < 0)
	throwFromErrno(env, OSError, path);
	
	return ret;
}



#ifdef HAVE_NICE
JNIEXPORT jint JNICALL _PACKAGE(nice)(JNIEnv *env, jclass jcls,
    jint jincr)
{
    int value = nice((int) jincr);
    if (value == -1)
	throwFromErrno(env, OSError);
    return (jint) value;
}
#endif /* HAVE_NICE */



   
jobject statTuple(JNIEnv *env, struct stat *st) {
#if !defined(HAVE_LARGEFILE_SUPPORT)
    return NewPyTuple(env, 10,
		NewPyInteger(env, st->st_mode),
		NewPyInteger(env, st->st_ino),
		NewPyInteger(env, st->st_dev),
		NewPyInteger(env, st->st_nlink),
		NewPyInteger(env, st->st_uid),
		NewPyInteger(env, st->st_gid),
		NewPyInteger(env, st->st_size),
		NewPyInteger(env, st->st_atime),
		NewPyInteger(env, st->st_mtime),
		NewPyInteger(env, st->st_ctime));
#else
    return NewPyTuple(env, 10,
		NewPyInteger(env, st->st_mode),
		NewPyLong(env, st->st_ino),
		NewPyInteger(env, st->st_dev),
		NewPyInteger(env, st->st_nlink),
		NewPyInteger(env, st->st_uid),
		NewPyInteger(env, st->st_gid),
		NewPyLong(env, st->st_size),
		NewPyInteger(env, st->st_atime),
		NewPyInteger(env, st->st_mtime),
		NewPyInteger(env, st->st_ctime));
#endif
}


JNIEXPORT jobject JNICALL _PACKAGE(stat)(JNIEnv *env, jclass jcls,
    jstring jpath)
{
    StringUTFChars path(env, jpath);
    if (path.throwIfNull(_TypeErrorStringExpected))
    	return NULL;

    struct stat st;
    if (stat(path, &st) < 0) {
	throwFromErrno(env, OSError, path);
	return NULL;
    }
    return statTuple(env, &st);
}



JNIEXPORT jobject JNICALL _PACKAGE(lstat)(JNIEnv *env, jclass jcls,
    jstring jpath)
{
    StringUTFChars path(env, jpath);
    if (path.throwIfNull(_TypeErrorStringExpected))
    	return NULL;

    struct stat st;
#ifdef HAVE_LSTAT
    if (lstat(path, &st) < 0) {
#else
    if (stat(path, &st) < 0) {
#endif
	throwFromErrno(env, OSError, path);
	return NULL;
    }
    return statTuple(env, &st);
}



JNIEXPORT jlong JNICALL _PACKAGE(access)(JNIEnv *env, jclass jcls,
    jstring jpath, jint jmode)
{

	nkprintf("posix.cpp access() called\n");
	
	jboolean isCopy = false;
	const char* path =  env->GetStringUTFChars( jpath, &isCopy);
	if ( isCopy == false )
	{
		nkprintf("posix.cpp access() ERROR. can not convert String to chars\n");
    		return -1;
	}

	jlong ret = access(path, jmode);

	nkprintf("posix.cpp access(\"%s\", %d) = %d\n", path, jmode, (int)ret );


	env->ReleaseStringUTFChars( jpath, path);

	return ret;
}


#ifndef F_OK
#define F_OK 0
#endif
#ifndef R_OK
#define R_OK 4
#endif
#ifndef W_OK
#define W_OK 2
#endif
#ifndef X_OK
#define X_OK 1
#endif


#ifdef HAVE_TTYNAME
JNIEXPORT jstring JNICALL _PACKAGE(ttyname)(JNIEnv *env, jclass jcls,
    jint jfd)
{
    char* ret = ttyname(jfd);
    if (ret == NULL) {
	throwFromErrno(env, OSError);
	return NULL;
    }
    return env->NewStringUTF(ret);
}
#endif



#ifdef HAVE_SYSTEM
JNIEXPORT jint JNICALL _PACKAGE(system)(JNIEnv *env, jclass jcls,
    jstring jcommand)
{
    StringUTFChars command(env, jcommand);
    if (command.throwIfNull(_TypeErrorStringExpected))
    	return 0;
    return system(command);
}
#endif



JNIEXPORT jint JNICALL _PACKAGE(umask)(JNIEnv *env, jclass jcls,
    jint jmask)
{
    if ((jmask = umask((int)jmask)) < 0) {
	throwFromErrno(env, OSError);
    	return 0;
    }
    return jmask;
}



JNIEXPORT jint JNICALL _PACKAGE(unlink)(JNIEnv *env, jclass jcls,
    jstring jpath)
{
	int ret = -1;
	
    StringUTFChars path(env, jpath);
    if (path.throwIfNull(_TypeErrorStringExpected))
    	return ret;
    
    if ( (ret = unlink(path) ) < 0)
    {
		throwFromErrno(env, OSError, path);
	}
	
	return ret;
}



#ifdef HAVE_UNAME
/*
//08/02/04 N.K delete
JNIEXPORT jobject JNICALL _PACKAGE(uname)(JNIEnv *env, jclass jcls)
{
    struct utsname u;
    if (uname(&u) < 0) {
	throwFromErrno(env, OSError);
	return NULL;
    }

    return NewPyTuple(env, 5,
		NewPyString(env, u.sysname),
		NewPyString(env, u.nodename),
		NewPyString(env, u.release),
		NewPyString(env, u.version),
		NewPyString(env, u.machine));
}
*/
#endif /* HAVE_UNAME */




JNIEXPORT jint JNICALL _PACKAGE(utime)(JNIEnv *env, jclass jcls,
    jstring jpath, jintArray jtimes)
{
	int ret = EFAULT;
	
    StringUTFChars path(env, jpath);
    if (path.throwIfNull(_TypeErrorStringExpected))
    	return ret;

    if (env->GetArrayLength(jtimes) != 2) {
	throwPyException(env, excType(env, "TypeError"), "2-tuple expected");
	return ret;
    }

    IntArray times = IntArray(env, jtimes);

/* XXX should define struct utimbuf instead, above */
#ifdef HAVE_UTIME_H
    struct utimbuf buf;
#define ATIME buf.actime
#define MTIME buf.modtime
#define UTIME_ARG &buf
#else /* HAVE_UTIME_H */
    time_t buf[2];
#define ATIME buf[0]
#define MTIME buf[1]
#define UTIME_ARG buf
#endif /* HAVE_UTIME_H */

    ATIME = times[0];
    MTIME = times[1];
    if ( ( ret = utime(path, UTIME_ARG) ) < 0)
    {
		throwFromErrno(env, OSError, path);
	}
	
#undef UTIME_ARG
#undef ATIME
#undef MTIME


	return ret;
}



JNIEXPORT void JNICALL _PACKAGE(_1exit)(JNIEnv *env, jclass jcls,
    jint jstatus)
{
    _exit(jstatus);
}


static char** getStringArray(JNIEnv* env, jobjectArray jarr) {
    int arrc = env->GetArrayLength(jarr);

    char **arrlist = (char **) malloc(sizeof(char*) * (arrc+1));
    if (arrlist == NULL) {
	throwPyException(env, excType(env, "MemoryError"), "malloc arrlist");
	return NULL;
    }
    int i;
    for (i = 0; i < arrc; i++) {
	jstring jstr = (jstring) env->GetObjectArrayElement(jarr, i);
	if (jstr != NULL)
	    arrlist[i] = (char*)env->GetStringUTFChars(jstr, NULL);
    }
    arrlist[arrc] = NULL;

    return arrlist;
}


static void freeStringArray(JNIEnv* env, char **list, jobjectArray jarr) {
    int arrc = env->GetArrayLength(jarr);

    int i;
    for (i = 0; i < arrc; i++) {
	jstring jstr = (jstring) env->GetObjectArrayElement(jarr, i);
	env->ReleaseStringUTFChars(jstr, list[i]);
    }
    free(list);
}



#ifdef HAVE_EXECV
JNIEXPORT void JNICALL _PACKAGE(execv)(JNIEnv *env, jclass jcls,
    jstring jpath, jobjectArray jargs)
{
    StringUTFChars path(env, jpath);
    if (path.throwIfNull(_TypeErrorStringExpected))
    	return;

    int argc = env->GetArrayLength(jargs);

    char **argvlist = getStringArray(env, jargs);

#ifdef BAD_EXEC_PROTOTYPES
    execv(path, (const char **) argvlist);
#else /* BAD_EXEC_PROTOTYPES */
    execv(path, argvlist);
#endif /* BAD_EXEC_PROTOTYPES */

    freeStringArray(env, argvlist, jargs);

    throwFromErrno(env, OSError);
}




JNIEXPORT jint JNICALL _PACKAGE(execve0)(JNIEnv *env, jclass jcls,
    jstring jpath, jobjectArray jargs, jobjectArray jenv)
{
    StringUTFChars path(env, jpath);
    
    int ret = EFAULT;
    
    if (path.throwIfNull(_TypeErrorStringExpected))
    	return ret;

    char **argvlist = getStringArray(env, jargs);
    char **envlist = getStringArray(env, jenv);


#ifdef BAD_EXEC_PROTOTYPES
	ret = execve(path, (const char **)argvlist, (const char **)envlist);
#else /* BAD_EXEC_PROTOTYPES */
	ret = execve(path, argvlist, envlist);
#endif /* BAD_EXEC_PROTOTYPES */


    freeStringArray(env, argvlist, jargs);
    freeStringArray(env, envlist, jenv);

    throwFromErrno(env, OSError);
    
    return ret;
}
#endif /* HAVE_EXECV */



#ifdef HAVE_SPAWNV
JNIEXPORT jint JNICALL _PACKAGE(spawnv)(JNIEnv *env, jclass jcls,
    jint jmode, jstring jpath, jobjectArray jargs)
{
    StringUTFChars path(env, jpath);
    if (path.throwIfNull(_TypeErrorStringExpected))
    	return 0;

    char **argvlist = getStringArray(env, jargs);

    if (jmode == _OLD_P_OVERLAY)
	jmode = _P_OVERLAY;

    int i = _spawnv(jmode, path, argvlist);

    freeStringArray(env, argvlist, jargs);

    if (i == -1)
	throwFromErrno(env, OSError);
    return i;
}



JNIEXPORT jint JNICALL _PACKAGE(spawnve)(JNIEnv *env, jclass jcls,
    jint jmode, jstring jpath, jobjectArray jargs, jobjectArray jenv)
{
    StringUTFChars path(env, jpath);
    if (path.throwIfNull(_TypeErrorStringExpected))
    	return 0;

    char **argvlist = getStringArray(env, jargs);
    char **envlist = getStringArray(env, jenv);

    if (jmode == _OLD_P_OVERLAY)
	jmode = _P_OVERLAY;
    int i = _spawnve(jmode, path, argvlist, envlist);

    freeStringArray(env, argvlist, jargs);
    freeStringArray(env, envlist, jenv);

    if (i == -1)
	throwFromErrno(env, OSError);
    return i;
}
#endif /* HAVE_SPAWNV */



#ifdef HAVE_FORK
JNIEXPORT jint JNICALL _PACKAGE(fork)(JNIEnv *env, jclass jcls)
{
    int pid = fork();
    if (pid == -1) {
	throwFromErrno(env, OSError);
	return 0;
    }
    //PyOS_AfterFork();
    return pid;
}
#endif




#ifdef HAVE_GETEGID
JNIEXPORT jint JNICALL _PACKAGE(getegid)(JNIEnv *env, jclass jcls)
{
    return getegid();
}
#endif



#ifdef HAVE_GETEUID
JNIEXPORT jint JNICALL _PACKAGE(geteuid)(JNIEnv *env, jclass jcls)
{
    return geteuid();
}
#endif


#ifdef HAVE_GETGID
JNIEXPORT jint JNICALL _PACKAGE(getgid)(JNIEnv *env, jclass jcls)
{
    return getgid();
}
#endif



#ifdef HAVE_GETPID
JNIEXPORT jint JNICALL _PACKAGE(getpid)(JNIEnv *env, jclass jcls)
{
    return getpid();
}
#endif



#ifdef HAVE_GETPGRP
JNIEXPORT jint JNICALL _PACKAGE(getpgrp)(JNIEnv *env, jclass jcls)
{
#ifdef GETPGRP_HAVE_ARG
    return getpgrp(0);
#else /* GETPGRP_HAVE_ARG */
    return getpgrp();
#endif /* GETPGRP_HAVE_ARG */
}
#endif




#ifdef HAVE_SETPGRP
JNIEXPORT void JNICALL _PACKAGE(setpgrp)(JNIEnv *env, jclass jcls)
{
#ifdef SETPGRP_HAVE_ARG
    if (setpgrp(0, 0) < 0)
#else /* SETPGRP_HAVE_ARG */
    if (setpgrp() < 0)
#endif /* SETPGRP_HAVE_ARG */
	throwFromErrno(env, OSError);
}
#endif


#ifdef HAVE_GETPPID
JNIEXPORT jint JNICALL _PACKAGE(getppid)(JNIEnv *env, jclass jcls)
{
    return getppid();
}
#endif



#ifdef HAVE_GETUID
JNIEXPORT jint JNICALL _PACKAGE(getuid)(JNIEnv *env, jclass jcls)
{
    return getuid();
}
#endif



#ifdef HAVE_KILL
JNIEXPORT jint JNICALL _PACKAGE(kill)(JNIEnv *env, jclass jcls,
    jint jpid, jint jsig)
{
	int ret = 0;

#if defined(PYOS_OS2)
    if (jsig == XCPT_SIGNAL_INTR || jsig == XCPT_SIGNAL_BREAK) {
        APIRET rc;
        if ((rc = DosSendSignalException(jpid, jsig)) != NO_ERROR)
            os2_error(rc);
    } else if (jsig == XCPT_SIGNAL_KILLPROC) {
        APIRET rc;
        if ((rc = DosKillProcess(DKP_PROCESS, jpid)) != NO_ERROR)
            os2_error(rc);
    } else
        return (int)rc; /* Unrecognized Signal Requested */
#else
	if ( ( ret = kill(jpid, jsig) ) == -1)
	    throwFromErrno(env, OSError);
#endif

	return ret;
}
#endif



#ifdef HAVE_PLOCK

#ifdef HAVE_SYS_LOCK_H
#include <sys/lock.h>
#endif
JNIEXPORT void JNICALL _PACKAGE(plock)(JNIEnv *env, jclass jcls,
    jint jop)
{
    if (plock(jop) == -1)
	throwFromErrno(env, OSError);
}
#endif




#ifdef HAVE_POPEN
#if defined(PYOS_OS2)
static int
async_system(const char *command)
{
    char        *p, errormsg[256], args[1024];
    RESULTCODES  rcodes;
    APIRET       rc;
    char        *shell = getenv("COMSPEC");
    if (!shell)
        shell = "cmd";

    strcpy(args, shell);
    p = &args[ strlen(args)+1 ];
    strcpy(p, "/c ");
    strcat(p, command);
    p += strlen(p) + 1;
    *p = '\0';

    rc = DosExecPgm(errormsg, sizeof(errormsg),
                    EXEC_ASYNC, /* Execute Async w/o Wait for Results */
                    args,
                    NULL,       /* Inherit Parent's Environment */
                    &rcodes, shell);
    return rc;
}

static FILE *
popen(const char *command, const char *mode, int pipesize, int *err)
{
    HFILE    rhan, whan;
    FILE    *retfd = NULL;
    APIRET   rc = DosCreatePipe(&rhan, &whan, pipesize);

    if (rc != NO_ERROR) {
	*err = rc;
        return NULL; /* ERROR - Unable to Create Anon Pipe */
    }

    if (strchr(mode, 'r') != NULL) { /* Treat Command as a Data Source */
        int oldfd = dup(1);      /* Save STDOUT Handle in Another Handle */

        DosEnterCritSec();      /* Stop Other Threads While Changing Handles */
        close(1);                /* Make STDOUT Available for Reallocation */

        if (dup2(whan, 1) == 0) {      /* Connect STDOUT to Pipe Write Side */
            DosClose(whan);            /* Close Now-Unused Pipe Write Handle */

            if (async_system(command) == NO_ERROR)
                retfd = fdopen(rhan, mode); /* And Return Pipe Read Handle */
        }

        dup2(oldfd, 1);          /* Reconnect STDOUT to Original Handle */
        DosExitCritSec();        /* Now Allow Other Threads to Run */

        close(oldfd);            /* And Close Saved STDOUT Handle */
        return retfd;            /* Return fd of Pipe or NULL if Error */

    } else if (strchr(mode, 'w')) { /* Treat Command as a Data Sink */
        int oldfd = dup(0);      /* Save STDIN Handle in Another Handle */

        DosEnterCritSec();      /* Stop Other Threads While Changing Handles */
        close(0);                /* Make STDIN Available for Reallocation */

        if (dup2(rhan, 0) == 0)     { /* Connect STDIN to Pipe Read Side */
            DosClose(rhan);           /* Close Now-Unused Pipe Read Handle */

            if (async_system(command) == NO_ERROR)
                retfd = fdopen(whan, mode); /* And Return Pipe Write Handle */
        }

        dup2(oldfd, 0);          /* Reconnect STDIN to Original Handle */
        DosExitCritSec();        /* Now Allow Other Threads to Run */

        close(oldfd);            /* And Close Saved STDIN Handle */
        return retfd;            /* Return fd of Pipe or NULL if Error */

    } else {
	*err = ERROR_INVALID_ACCESS;
        return NULL; /* ERROR - Invalid Mode (Neither Read nor Write) */
    }
}

JNIEXPORT jlong JNICALL _PACKAGE(popen0)(JNIEnv *env, jclass jcls,
    jstring jname, jstring jmode, jint jbufsize)
{
    StringUTFChars name(env, jname);
    if (name.throwIfNull(_TypeErrorStringExpected))
    	return 0;

    StringUTFChars mode(env, jmode);
    if (mode.throwIfNull(_TypeErrorStringExpected))
    	return 0;

    FILE* fp = popen(name, mode, (bufsize > 0) ? bufsize : 4096, &err);
    if (fp == NULL)
	return os2_error(err);

    return (jlong)fp;
}

#else
JNIEXPORT jlong JNICALL _PACKAGE(popen0)(JNIEnv *env, jclass jcls,
    jstring jname, jstring jmode, jint jbufsize)
{
    StringUTFChars name(env, jname);
    if (name.throwIfNull(_TypeErrorStringExpected))
    	return 0;

    StringUTFChars mode(env, jmode);
    if (mode.throwIfNull(_TypeErrorStringExpected))
    	return 0;

    FILE *fp = popen((const char*)name, (const char*)mode);
    if (fp == NULL)
	throwFromErrno(env, OSError);

    return (jlong)fp;
}
#endif


JNIEXPORT jlong JNICALL _PACKAGE(pclose0)(JNIEnv *env, jclass jcls)
{
    return (jlong)pclose;
}

#endif /* HAVE_POPEN */



// #ifdef HAVE_SETUID
JNIEXPORT jint JNICALL _PACKAGE(setuid)(JNIEnv *env, jclass jcls,
    jint juid)
{
	// 09/01/09 C.
	int ret = 0;
	ret = setuid(juid);
		
	return ret;
}
// #endif /* HAVE_SETUID */


//#ifdef HAVE_SETGID
JNIEXPORT jint JNICALL _PACKAGE(setgid)(JNIEnv *env, jclass jcls,
    jint jgid)
{
	// 09/01/09C.
	int ret = 0;
    	ret = setgid(jgid);
	
	return ret;
}
//#endif /* HAVE_SETGID */



#ifdef HAVE_WAITPID
JNIEXPORT jobject JNICALL _PACKAGE(waitpid)(JNIEnv *env, jclass jcls,
    jint jpid, jint joptions)
{
#ifdef UNION_WAIT
    union wait status;
#define status_i (status.w_status)
#else
    int status;
#define status_i status
#endif
    status_i = 0;

#ifdef NeXT
    jpid = wait4(jpid, &status, joptions, NULL);
#else
    jpid = waitpid(jpid, &status, joptions);
#endif
    if (jpid == -1) {
	throwFromErrno(env, OSError);
	return 0;
    }

    return NewPyTuple(env, 2, 
		NewPyInteger(env, jpid), 
		NewPyInteger(env, status_i));
}
#endif /* HAVE_WAITPID */


#ifdef HAVE_WAIT
JNIEXPORT jobject JNICALL _PACKAGE(wait)(JNIEnv *env, jclass jcls)
{
#ifdef UNION_WAIT
    union wait status;
#define status_i (status.w_status)
#else
    int status;
#define status_i status
#endif
    status_i = 0;

    jint jpid = wait(&status);

    return NewPyTuple(env, 2, 
		NewPyInteger(env, jpid), 
		NewPyInteger(env, status_i));
}
#endif


#ifdef HAVE_READLINK
JNIEXPORT jstring JNICALL _PACKAGE(readlink)(JNIEnv *env, jclass jcls, 
    jstring jpath)
{
    char buf[MAXPATHLEN];

    StringUTFChars path(env, jpath);
    if (path.throwIfNull(_TypeErrorStringExpected))
    	return NULL;

    if (readlink(path, buf, (int) sizeof buf) < 0) {
	throwFromErrno(env, OSError, path);
	return NULL;
    }
    return env->NewStringUTF(buf);
}
#endif /* HAVE_READLINE */




JNIEXPORT jint JNICALL _PACKAGE(rename)(JNIEnv *env, jclass jcls, 
    jstring jsrc, jstring jdst)
{
	int ret = EFAULT;
	
    StringUTFChars src(env, jsrc);
    if (src.throwIfNull(_TypeErrorStringExpected))
    	return ret;
    StringUTFChars dst(env, jdst);
    if (dst.throwIfNull(_TypeErrorStringExpected))
    	return ret;

    if ( ( ret = rename(src, dst) ) < 0)
	throwFromErrno(env, OSError);
	
	return ret;
}




#ifdef HAVE_SYMLINK
JNIEXPORT void JNICALL _PACKAGE(symlink)(JNIEnv *env, jclass jcls, 
    jstring jsrc, jstring jdst)
{
    StringUTFChars src(env, jsrc);
    if (src.throwIfNull(_TypeErrorStringExpected))
    	return;
    StringUTFChars dst(env, jdst);
    if (dst.throwIfNull(_TypeErrorStringExpected))
    	return;

    if (symlink(src, dst) < 0)
	throwFromErrno(env, OSError);
}
#endif /* HAVE_SYMLINK */




/*
#ifdef HAVE_TIMES
#ifndef HZ
#define HZ 60 // Universal constant :-) //
#endif // HZ //
	
#if defined(PYCC_VACPP) && defined(PYOS_OS2)
static long system_uptime()
{
    ULONG value = 0;

    DosQuerySysInfo(QSV_MS_COUNT, QSV_MS_COUNT, &value, sizeof(value));

    return value;
}


JNIEXPORT jdoubleArray JNICALL _PACKAGE(times)(JNIEnv *env, jclass jcls)
{
	
    return NewPyTuple(env, 5,
		NewPyFloat(env, (double)0), // t.tms_utime / HZ //
		NewPyFloat(env, (double)0), // t.tms_stime / HZ //
		NewPyFloat(env, (double)0), // t.tms_cutime / HZ //
		NewPyFloat(env, (double)0), // t.tms_cstime / HZ //
		NewPyFloat(env, (double)system_uptime() / 1000));

}
#else // not OS2 //
JNIEXPORT jobject JNICALL _PACKAGE(times)(JNIEnv *env, jclass jcls)
{
    struct tms t;
    clock_t c;
    errno = 0;
    c = times(&t);
    if (c == (clock_t) -1) {
	throwFromErrno(env, OSError);
	return NULL;
    }

    return NewPyTuple(env, 5,
		NewPyFloat(env, (double)t.tms_utime / HZ),
		NewPyFloat(env, (double)t.tms_stime / HZ),
		NewPyFloat(env, (double)t.tms_cutime / HZ),
		NewPyFloat(env, (double)t.tms_cstime / HZ),
		NewPyFloat(env, (double)c / HZ));
}
#endif // not OS2 //
#endif // HAVE_TIMES //



#ifdef MS_WIN32
#define HAVE_TIMES	// so the method table will pick it up //
JNIEXPORT jobject JNICALL _PACKAGE(times)(JNIEnv *env, jclass jcls)
{
    FILETIME create, exit, kernel, user;
    HANDLE hProc;
    hProc = GetCurrentProcess();
    GetProcessTimes(hProc,&create, &exit, &kernel, &user);
    // The fields of a FILETIME structure are the hi and lo part
    //  of a 64-bit value expressed in 100 nanosecond units.
    //   1e7 is one second in such units; 1e-7 the inverse.
    //   429.4967296 is 2**32 / 1e7 or 2**32 * 1e-7.
    //

    return NewPyTuple(env, 5,
	NewPyFloat(env, (double)(kernel.dwHighDateTime*429.4967296 +
				kernel.dwLowDateTime*1e-7)),
	NewPyFloat(env, (double)(user.dwHighDateTime*429.4967296 +
				user.dwLowDateTime*1e-7)),
	NewPyFloat(env, (double)0),
	NewPyFloat(env, (double)0),
	NewPyFloat(env, (double)0));
}
#endif // MS_WIN32 //
*/



#ifdef HAVE_SETSID
JNIEXPORT void JNICALL _PACKAGE(setsid)(JNIEnv *env, jclass jcls)
{
    if (setsid() < 0)
	throwFromErrno(env, OSError);
}
#endif // HAVE_SETSID //



#ifdef HAVE_SETPGID
JNIEXPORT void JNICALL _PACKAGE(setpgid)(JNIEnv *env, jclass jcls,
    jint jpid, jint jpgrp)
{
    if (setpgid(jpid, jpgrp) < 0)
	throwFromErrno(env, OSError);
}
#endif /* HAVE_SETPGID */


#ifdef HAVE_TCGETPGRP
JNIEXPORT jint JNICALL _PACKAGE(tcgetpgrp)(JNIEnv *env, jclass jcls,
    jint jfd)
{
    int pgid = tcgetpgrp(jfd);
    if (pgid < 0) {
	throwFromErrno(env, OSError);
	return 0;
    }
    return pgid;
}
#endif /* HAVE_TCGETPGRP */




#ifdef HAVE_TCSETPGRP
JNIEXPORT void JNICALL _PACKAGE(tcsetpgrp)(JNIEnv *env, jclass jcls,
    jint jfd, jint jpgid)
{
    if (tcsetpgrp(jfd, jpgid) < 0)
	throwFromErrno(env, OSError);
}
#endif /* HAVE_TCSETPGRP */





JNIEXPORT jint JNICALL _PACKAGE(open)(JNIEnv *env, jclass jcls,
    jstring jpath, jint jflag, jint jmode)
{
    StringUTFChars path(env, jpath);
    if (path.throwIfNull(_TypeErrorStringExpected))
    	return -1;

    int fd = open(path, jflag, jmode);
    
    /*
    if (fd < 0)
    {
		throwFromErrno(env, OSError, path);
		//JythonpɗOԂĂ邪ł͕sv
	}	
	*/
    return fd;
}



JNIEXPORT jlong JNICALL _PACKAGE(close)(JNIEnv *env, jclass jcls,
    jint jfd)
{
	jlong ret = close( jfd );
	

	return ret;

}



JNIEXPORT jint JNICALL _PACKAGE(dup)(JNIEnv *env, jclass jcls,
    jint jfd)
{
    jfd = dup(jfd);
    if (jfd < 0)
	throwFromErrno(env, OSError);
    return jfd;
}



/*
JNIEXPORT void JNICALL _PACKAGE(dup2)(JNIEnv *env, jclass jcls,
    jint jfd, jint jfd2)
{
    if (dup2(jfd, jfd2) < 0)
	throwFromErrno(env, OSError);
}
*/

JNIEXPORT jlong JNICALL _PACKAGE(dup2)(JNIEnv *env, jclass jcls,
    jint jfd, jint jfd2)
{
	// 09/01/09 ύX.
	jlong ret = dup2(jfd, jfd2);
	return ret;
}




JNIEXPORT jlong JNICALL _PACKAGE(lseek)(JNIEnv *env, jclass jcls,
    jint jfd, jlong jpos, jint jhow)
{
#ifdef SEEK_SET
    /* Turn 0, 1, 2 into SEEK_{SET,CUR,END} */
    switch (jhow) {
    case 0: jhow = SEEK_SET; break;
    case 1: jhow = SEEK_CUR; break;
    case 2: jhow = SEEK_END; break;
    }
#endif /* SEEK_END */
    off_t res = lseek(jfd, (off_t)jpos, jhow);
    if (res < 0)
	throwFromErrno(env, OSError);
    return res;
}






/*

//08/06/09 Stringx[X̓ǂ݂݂͔p~
JNIEXPORT jstring JNICALL _PACKAGE(read)(JNIEnv *env, jclass jcls,
    jint jfd, jint jsize)
{
    unsigned char* buf = (unsigned char*)malloc(jsize);
    if (buf == NULL) {
	throwPyException(env, excType(env, "MemoryError"), "malloc buffer");
	return NULL;
    }

    int n = read(jfd, buf, jsize);
    if (n < 0) {
	free(buf);
	throwFromErrno(env, OSError);
	return NULL;
    }

    jcharArray jbuffer = env->NewCharArray(n);
    jchar* jbuf = env->GetCharArrayElements(jbuffer, NULL);
    for (int i = 0; i < n; i++)
	jbuf[i] = buf[i];

    free(buf);

    jstring ret = env->NewString(jbuf, n);

    env->ReleaseCharArrayElements(jbuffer, jbuf, 0);

    return ret;
}
*/


JNIEXPORT jint JNICALL Java_jnios_posix_read(JNIEnv *env, jclass jcls, jint fd, jbyteArray jbuffer)
{

	int size = env->GetArrayLength(jbuffer);
	jbyte* buf = env->GetByteArrayElements(jbuffer, NULL);


	jint ret = read( fd, buf, size);

	if ( ret < 0)
	{
		nkprintf("JNI DLL side : fd = %d, buf=%p, size=%d, read() = %d, errno=%d\n", fd, buf, size, ret, errno);
	}


	env->ReleaseByteArrayElements( jbuffer, buf, NULL);

	return ret;
}





JNIEXPORT jint JNICALL _PACKAGE(write)(JNIEnv *env, jclass jcls,
    jint jfd, jbyteArray jbuffer)
{
    int size = env->GetArrayLength(jbuffer); 
    int n = 0;

    jbyte* jbuf = env->GetByteArrayElements(jbuffer, NULL);
    
	n = write(jfd, jbuf, size);
    
	env->ReleaseByteArrayElements(jbuffer, jbuf, 0);

	//nkprintf("JNIOS.DLLside : write() called\n"); //eXgp̕Wo


	if (n < 0)
	{
		throwFromErrno(env, OSError);
	}


    return n;
}



JNIEXPORT jobject JNICALL _PACKAGE(fstat)(JNIEnv *env, jclass jcls,
    jint jfd)
{
    struct stat st;
    int res = fstat(jfd, &st);

    if (res != 0)
	throwFromErrno(env, OSError);

    return statTuple(env, &st);
}


JNIEXPORT jlong JNICALL _PACKAGE(fdopen0)(JNIEnv *env, jclass jcls,
    jint jfd, jstring jmode)
{
    StringUTFChars mode(env, jmode);
    if (mode.throwIfNull(_TypeErrorStringExpected))
    	return 0;

    FILE* fp = fdopen(jfd, mode);
    return (jlong)fp;
}


JNIEXPORT jlong JNICALL _PACKAGE(fclose0)(JNIEnv *env, jclass jcls)
{
    return (jlong)fclose;
}



/*
#ifdef HAVE_PIPE
JNIEXPORT jobject JNICALL _PACKAGE(pipe)(JNIEnv *env, jclass jcls)
{
#if defined(PYOS_OS2)
    HFILE read, write;
    APIRET rc;
    rc = DosCreatePipe( &read, &write, 4096);
    if (rc != NO_ERROR)
        return os2_error(rc);

    return NewPyTuple(env, 2,
		NewPyInteger(env, read),
		NewPyInteger(env, write));
#else
#if !defined(MS_WIN32)
    int fds[2];

    int res = pipe(fds);
    if (res != 0)
	throwFromErrno(env, OSError);
    return NewPyTuple(env, 2, 
		NewPyInteger(env, fds[0]),
		NewPyInteger(env, fds[1]));
#else // MS_WIN32 
    HANDLE read, write;
    BOOL ok = CreatePipe(&read, &write, NULL, 0);
    if (!ok)
	throwFromErrno(env, OSError);
    int read_fd = _open_osfhandle((long)read, 0);
    int write_fd = _open_osfhandle((long)write, 1);
    return NewPyTuple(env, 2, 
		NewPyInteger(env, read_fd),
		NewPyInteger(env, write_fd));
#endif // MS_WIN32 
#endif
}
#endif  // HAVE_PIPE 
*/


#ifdef HAVE_MKFIFO
JNIEXPORT void JNICALL _PACKAGE(mkfifo)(JNIEnv *env, jclass jcls,
    jstring jpath, jint jmode)
{
    StringUTFChars path(env, jpath);
    if (path.throwIfNull(_TypeErrorStringExpected))
    	return;

    int res = mkfifo(path, jmode);
    if (res < 0)
	throwFromErrno(env, OSError);
}
#endif



#ifdef HAVE_FTRUNCATE
JNIEXPORT void JNICALL _PACKAGE(ftruncate)(JNIEnv *env, jclass jcls,
    jint jfd, jlong jlength)
{
    if (ftruncate(jfd, (off_t)jlength) < 0)
	throwFromErrno(env, excType(env, "IOError"));

}
#endif




#ifdef NeXT
#define HAVE_PUTENV
/* Steve Spicklemire got this putenv from NeXTAnswers */
static int
putenv(char *newval)
{
	extern char **environ;

	static int firstTime = 1;
	char **ep;
	char *cp;
	int esiz;
	char *np;

	if (!(np = strchr(newval, '=')))
		return 1;
	*np = '\0';

	/* look it up */
	for (ep=environ ; *ep ; ep++)
	{
		/* this should always be true... */
		if (cp = strchr(*ep, '='))
		{
			*cp = '\0';
			if (!strcmp(*ep, newval))
			{
				/* got it! */
				*cp = '=';
				break;
			}
			*cp = '=';
		}
		else
		{
			*np = '=';
			return 1;
		}
	}

	*np = '=';
	if (*ep)
	{
		/* the string was already there:
		   just replace it with the new one */
		*ep = newval;
		return 0;
	}

	/* expand environ by one */
	for (esiz=2, ep=environ ; *ep ; ep++)
		esiz++;
	if (firstTime)
	{
		char **epp;
		char **newenv;
		if (!(newenv = malloc(esiz * sizeof(char *))))
			return 1;
   
		for (ep=environ, epp=newenv ; *ep ;)
			*epp++ = *ep++;
		*epp++ = newval;
		*epp = (char *) 0;
		environ = newenv;
	}
	else
	{
		if (!(environ = realloc(environ, esiz * sizeof(char *))))
			return 1;
		environ[esiz - 2] = newval;
		environ[esiz - 1] = (char *) 0;
		firstTime = 0;
	}

	return 0;
}
#endif /* NeXT */


#ifdef HAVE_PUTENV

#ifdef __BEOS__
/* We have putenv(), but not in the headers (as of PR2). - [cjh] */
int putenv( const char *str );
#endif


JNIEXPORT void JNICALL _PACKAGE(putenv)(JNIEnv *env, jclass jcls,
    jstring jkey, jstring jvalue)
{
    char *newval;

    StringUTFChars s1(env, jkey);
    if (s1.throwIfNull(_TypeErrorStringExpected))
    	return;
    StringUTFChars s2(env, jvalue);
    if (s2.throwIfNull(_TypeErrorStringExpected))
    	return;

#if defined(PYOS_OS2)
    if (stricmp(s1, "BEGINLIBPATH") == 0) {
        APIRET rc;

        if (strlen(s2) == 0)  /* If New Value is an Empty String */
            s2 = NULL;        /* Then OS/2 API Wants a NULL to Undefine It */

        rc = DosSetExtLIBPATH(s2, BEGIN_LIBPATH);
        if (rc != NO_ERROR)
            return os2_error(rc);

    } else if (stricmp(s1, "ENDLIBPATH") == 0) {
        APIRET rc;

        if (strlen(s2) == 0)  /* If New Value is an Empty String */
            s2 = NULL;        /* Then OS/2 API Wants a NULL to Undefine It */

        rc = DosSetExtLIBPATH(s2, END_LIBPATH);
        if (rc != NO_ERROR)
            return os2_error(rc);
    } else {
#endif
	/* XXX This leaks memory -- not easy to fix :-( */
	if ((newval = (char*) malloc(strlen(s1) + strlen(s2) + 2)) == NULL) {
	    throwPyException(env, excType(env, "MemoryError"), "malloc env");
	    return;
	}

	(void) sprintf(newval, "%s=%s", (const char *)s1, (const char *)s2);
	if (putenv(newval)) {
	    throwFromErrno(env, OSError);
	    return;
	}
#if defined(PYOS_OS2)
    }
#endif
}
#endif /* putenv */



#ifdef HAVE_STRERROR
JNIEXPORT jstring JNICALL _PACKAGE(strerror)(JNIEnv *env, jclass jcls,
    jint jcode)
{
    char *message = strerror(jcode);
    if (message == NULL) {
	throwPyException(env, excType(env, "ValueError"), "strerror code out of range");
	return NULL;
    }
    return env->NewStringUTF(message);
}
#endif /* strerror */


#ifdef HAVE_SYS_WAIT_H

#ifdef WIFSTOPPED
JNIEXPORT jint JNICALL _PACKAGE(WIFSTOPPED)(JNIEnv *env, jclass jcls,
    jint jstatus)
{
#ifdef UNION_WAIT
    union wait status;
#define status_i (status.w_status)
#else
    int status;
#define status_i status
#endif
    status_i = jstatus;

    return WIFSTOPPED(status);
}
#endif /* WIFSTOPPED */

#ifdef WIFSIGNALED
JNIEXPORT jint JNICALL _PACKAGE(WIFSIGNALED)(JNIEnv *env, jclass jcls,
    jint jstatus)
{
#ifdef UNION_WAIT
    union wait status;
#define status_i (status.w_status)
#else
    int status;
#define status_i status
#endif
    status_i = jstatus;

    return WIFSIGNALED(status);
}
#endif /* WIFSIGNALED */




#ifdef WIFEXITED
JNIEXPORT jint JNICALL _PACKAGE(WIFEXITED)(JNIEnv *env, jclass jcls,
    jint jstatus)
{
#ifdef UNION_WAIT
    union wait status;
#define status_i (status.w_status)
#else
    int status;
#define status_i status
#endif
    status_i = jstatus;

    return WIFEXITED(status);
}
#endif // WIFEXITED 



#ifdef WEXITSTATUS
JNIEXPORT jint JNICALL _PACKAGE(WEXITSTATUS)(JNIEnv *env, jclass jcls,
    jint jstatus)
{
#ifdef UNION_WAIT
    union wait status;
#define status_i (status.w_status)
#else
    int status;
#define status_i status
#endif
    status_i = jstatus;

    return WEXITSTATUS(status);
}
#endif /* WEXITSTATUS */

#ifdef WTERMSIG
JNIEXPORT jint JNICALL _PACKAGE(WTERMSIG)(JNIEnv *env, jclass jcls,
    jint jstatus)
{
#ifdef UNION_WAIT
    union wait status;
#define status_i (status.w_status)
#else
    int status;
#define status_i status
#endif
    status_i = jstatus;

    return WTERMSIG(status);
}
#endif /* WTERMSIG */

#ifdef WSTOPSIG
JNIEXPORT jint JNICALL _PACKAGE(WSTOPSIG)(JNIEnv *env, jclass jcls,
    jint jstatus)
{
#ifdef UNION_WAIT
    union wait status;
#define status_i (status.w_status)
#else
    int status;
#define status_i status
#endif
    status_i = jstatus;

    return WSTOPSIG(status);
}
#endif /* WSTOPSIG */

#endif /* HAVE_SYS_WAIT_H */


#if defined(HAVE_FSTATVFS)
#include <sys/statvfs.h>

JNIEXPORT jobject JNICALL _PACKAGE(fstatvfs)(JNIEnv *env, jclass jcls,
    jint jfd)
{
    struct statvfs st;

    int res = fstatvfs((int) jfd, &st);
    if (res != 0) {
	throwFromErrno(env, OSError);
	return NULL;
    }
#if !defined(HAVE_LARGEFILE_SUPPORT)
    return NewPyTuple(env, 10,
		NewPyInteger(env, (long) st.f_bsize),
		NewPyInteger(env, (long) st.f_frsize),
		NewPyInteger(env, (long) st.f_blocks),
		NewPyInteger(env, (long) st.f_bfree),
		NewPyInteger(env, (long) st.f_bavail),
		NewPyInteger(env, (long) st.f_files),
		NewPyInteger(env, (long) st.f_ffree),
		NewPyInteger(env, (long) st.f_favail),
		NewPyInteger(env, (long) st.f_flag),
		NewPyInteger(env, (long) st.f_namemax));
#else
    return NewPyTuple(env, 10,
		NewPyInteger(env, (long) st.f_bsize),
		NewPyInteger(env, (long) st.f_frsize),
		NewPyLong(env, (LONG_LONG) st.f_blocks),
		NewPyLong(env, (LONG_LONG) st.f_bfree),
		NewPyLong(env, (LONG_LONG) st.f_bavail),
		NewPyLong(env, (LONG_LONG) st.f_files),
		NewPyLong(env, (LONG_LONG) st.f_ffree),
		NewPyLong(env, (LONG_LONG) st.f_favail),
		NewPyInteger(env, (long) st.f_flag),
		NewPyInteger(env, (long) st.f_namemax));
#endif
}
#endif /* HAVE_FSTATVFS */


#if defined(HAVE_STATVFS)
#include <sys/statvfs.h>


JNIEXPORT jobject JNICALL _PACKAGE(statvfs)(JNIEnv *env, jclass jcls,
    jstring jpath)
{
    struct statvfs st;

    StringUTFChars path(env, jpath);
    if (path.throwIfNull(_TypeErrorStringExpected))
    	return;

    int res = statvfs(path, &st);
    if (res != 0) {
	throwFromErrno(env, OSError, path);
	return NULL;
    }
#if !defined(HAVE_LARGEFILE_SUPPORT)
    return NewPyTuple(env, 10,
		NewPyInteger(env, (long) st.f_bsize),
		NewPyInteger(env, (long) st.f_frsize),
		NewPyInteger(env, (long) st.f_blocks),
		NewPyInteger(env, (long) st.f_bfree),
		NewPyInteger(env, (long) st.f_bavail),
		NewPyInteger(env, (long) st.f_files),
		NewPyInteger(env, (long) st.f_ffree),
		NewPyInteger(env, (long) st.f_favail),
		NewPyInteger(env, (long) st.f_flag),
		NewPyInteger(env, (long) st.f_namemax));
#else
    return NewPyTuple(env, 10,
		NewPyInteger(env, (long) st.f_bsize),
		NewPyInteger(env, (long) st.f_frsize),
		NewPyLong(env, (LONG_LONG) st.f_blocks),
		NewPyLong(env, (LONG_LONG) st.f_bfree),
		NewPyLong(env, (LONG_LONG) st.f_bavail),
		NewPyLong(env, (LONG_LONG) st.f_files),
		NewPyLong(env, (LONG_LONG) st.f_ffree),
		NewPyLong(env, (LONG_LONG) st.f_favail),
		NewPyInteger(env, (long) st.f_flag),
		NewPyInteger(env, (long) st.f_namemax));
#endif
}
#endif /* HAVE_STATVFS */









static char* posix_names[] = {
	"access",
#ifdef HAVE_TTYNAME
	"ttyname",
#endif
	"chdir",
	"chmod",
#ifdef HAVE_CHOWN
	"chown",
#endif /* HAVE_CHOWN */
#ifdef HAVE_GETCWD
	"getcwd",
#endif
#ifdef HAVE_LINK
	"link",
#endif /* HAVE_LINK */
	"listdir",
	"lstat",
	"mkdir",
#ifdef HAVE_NICE
	"nice",
#endif /* HAVE_NICE */
#ifdef HAVE_READLINK
	"readlink",
#endif /* HAVE_READLINK */
	"rename",
	"rmdir",
	"stat",
#ifdef HAVE_SYMLINK
	"symlink",
#endif /* HAVE_SYMLINK */
#ifdef HAVE_SYSTEM
	"system",
#endif
	"umask",
#ifdef HAVE_UNAME
	"uname",
#endif /* HAVE_UNAME */
	"unlink",
	"remove",
	"utime",
#ifdef HAVE_TIMES
	"times",
#endif /* HAVE_TIMES */
	"_exit",
#ifdef HAVE_EXECV 
	"execv",
	"execve",
#endif /* HAVE_EXECV */
#ifdef HAVE_SPAWNV
	"spawnv",
	"spawnve",
#endif /* HAVE_SPAWNV */
#ifdef HAVE_FORK
	"fork",
#endif /* HAVE_FORK */
#ifdef HAVE_GETEGID
	"getegid",
#endif /* HAVE_GETEGID */
#ifdef HAVE_GETEUID
	"geteuid",
#endif /* HAVE_GETEUID */
#ifdef HAVE_GETGID
	"getgid",
#endif /* HAVE_GETGID */
	"getpid",
#ifdef HAVE_GETPGRP
	"getpgrp",
#endif /* HAVE_GETPGRP */
#ifdef HAVE_GETPPID
	"getppid",
#endif /* HAVE_GETPPID */
#ifdef HAVE_GETUID
	"getuid",
#endif /* HAVE_GETUID */
#ifdef HAVE_KILL
	"kill",
#endif /* HAVE_KILL */
#ifdef HAVE_PLOCK
	"plock",
#endif /* HAVE_PLOCK */
#ifdef HAVE_POPEN 
	"popen",
#endif /* HAVE_POPEN */
#ifdef HAVE_SETUID
	"setuid",
#endif /* HAVE_SETUID */
#ifdef HAVE_SETGID
	"setgid",
#endif /* HAVE_SETGID */
#ifdef HAVE_SETPGRP
	"setpgrp",
#endif /* HAVE_SETPGRP */
#ifdef HAVE_WAIT
	"wait",
#endif /* HAVE_WAIT */
#ifdef HAVE_WAITPID
	"waitpid",
#endif /* HAVE_WAITPID */
#ifdef HAVE_SETSID
	"setsid",
#endif /* HAVE_SETSID */
#ifdef HAVE_SETPGID
	"setpgid",
#endif /* HAVE_SETPGID */
#ifdef HAVE_TCGETPGRP
	"tcgetpgrp",
#endif /* HAVE_TCGETPGRP */
#ifdef HAVE_TCSETPGRP
	"tcsetpgrp",
#endif /* HAVE_TCSETPGRP */
	"open",
	"close",
	"dup",
	"dup2",
	"lseek",
	"read",
	"write",
	"fstat",
	"fdopen",
#ifdef HAVE_PIPE
	"pipe",
#endif
#ifdef HAVE_MKFIFO
	"mkfifo",
#endif
#ifdef HAVE_FTRUNCATE
	"ftruncate",
#endif
#ifdef HAVE_PUTENV
	"putenv",
#endif
#ifdef HAVE_STRERROR
	"strerror",
#endif
#ifdef HAVE_FSYNC
	"fsync",
#endif
#ifdef HAVE_FDATASYNC
	"fdatasync",
#endif
#ifdef HAVE_SYS_WAIT_H
#ifdef WIFSTOPPED
        "WIFSTOPPED",
#endif /* WIFSTOPPED */
#ifdef WIFSIGNALED
        "WIFSIGNALED",
#endif /* WIFSIGNALED */
#ifdef WIFEXITED
        "WIFEXITED",
#endif /* WIFEXITED */
#ifdef WEXITSTATUS
        "WEXITSTATUS",
#endif /* WEXITSTATUS */
#ifdef WTERMSIG
        "WTERMSIG",
#endif /* WTERMSIG */
#ifdef WSTOPSIG
        "WSTOPSIG",
#endif /* WSTOPSIG */
#endif /* HAVE_SYS_WAIT_H */

	"error",

#ifdef HAVE_FSTATVFS
	"fstatvfs",
#endif
#ifdef HAVE_STATVFS
	"statvfs",
#endif

};




JNIEXPORT jobjectArray JNICALL _PACKAGE(getNames)(JNIEnv *env, jclass jcls)
{
    int len = sizeof(posix_names) / sizeof(*posix_names);

    jclass jstrcls = env->FindClass("java/lang/String");
    CHECK(jstrcls, return NULL, "FindClass(java/lang/String) failed");

    jobjectArray jnames = env->NewObjectArray(len, jstrcls, NULL);
    for (int i = 0; i < len; i++) {
	env->SetObjectArrayElement(jnames, i, env->NewStringUTF(posix_names[i]));
    }
    return jnames;
}


#if ( defined(_MSC_VER) || defined(__WATCOMC__) ) && !defined(__QNX__)
#define MODNAME "nt"
#else
#if defined(PYOS_OS2)
#define MODNAME "os2"
#else
#define MODNAME "posix"
#endif
#endif

JNIEXPORT jstring JNICALL _PACKAGE(getName)(JNIEnv *env, jclass jcls)
{
     return env->NewStringUTF(MODNAME);
}



static int insInt(JNIEnv *env, jobject jdict, char *symbol, jint value)
{
    jobject u = NewPyString(env, symbol);
    CHECK(u, return -1, NULL);
    jobject v = NewPyInteger(env, value);
    CHECK(v, return -1, NULL);

    PyObject_setitem(env, jdict, u, v);
    return 0;
}


static int insString(JNIEnv *env, jobject jdict, char *symbol, char *value)
{
    jobject u = NewPyString(env, symbol);
    CHECK(u, return -1, NULL);
    jobject v = NewPyString(env, value);
    CHECK(v, return -1, NULL);

    PyObject_setitem(env, jdict, u, v);
    return 0;
}


#if defined(PYOS_OS2)
/* Insert Platform-Specific Constant Values (Strings & Numbers) of Common Use */
static int insertvalues(JNIEnv *env, jobject jdict)
{
    APIRET    rc;
    ULONG     values[QSV_MAX+1];
    PyObject *v;
    char     *ver, tmp[10];

    Py_BEGIN_ALLOW_THREADS
    rc = DosQuerySysInfo(1, QSV_MAX, &values[1], sizeof(values));
    Py_END_ALLOW_THREADS

    if (rc != NO_ERROR) {
        os2_error(rc);
        return -1;
    }

    if (insInt(env, jdict, "meminstalled", values[QSV_TOTPHYSMEM])) return -1;
    if (insInt(env, jdict, "memkernel",    values[QSV_TOTRESMEM])) return -1;
    if (insInt(env, jdict, "memvirtual",   values[QSV_TOTAVAILMEM])) return -1;
    if (insInt(env, jdict, "maxpathlen",   values[QSV_MAX_PATH_LENGTH])) return -1;
    if (insInt(env, jdict, "maxnamelen",   values[QSV_MAX_COMP_LENGTH])) return -1;
    if (insInt(env, jdict, "revision",     values[QSV_VERSION_REVISION])) return -1;
    if (insInt(env, jdict, "timeslice",    values[QSV_MIN_SLICE])) return -1;

    switch (values[QSV_VERSION_MINOR]) {
    case 0:  ver = "2.00"; break;
    case 10: ver = "2.10"; break;
    case 11: ver = "2.11"; break;
    case 30: ver = "3.00"; break;
    case 40: ver = "4.00"; break;
    case 50: ver = "5.00"; break;
    default:
        sprintf(tmp, "%d-%d", values[QSV_VERSION_MAJOR],
                              values[QSV_VERSION_MINOR]);
        ver = &tmp[0];
    }

    /* Add Indicator of the Version of the Operating System */
    if (insString(env, jdict, "version", ver)) return -1;

    /* Add Indicator of Which Drive was Used to Boot the System */
    tmp[0] = 'A' + values[QSV_BOOT_DRIVE] - 1;
    tmp[1] = ':';
    tmp[2] = '\0';

    if (insString(env, jdict, "bootdrive", tmp)) return -1;
    return 0;
}
#endif

static int all_ins(JNIEnv *env, jobject jdict)
{
#ifdef F_OK
    if (insInt(env, jdict, "F_OK", (long)F_OK)) return -1;
#endif        
#ifdef R_OK
    if (insInt(env, jdict, "R_OK", (long)R_OK)) return -1;
#endif        
#ifdef W_OK
    if (insInt(env, jdict, "W_OK", (long)W_OK)) return -1;
#endif        
#ifdef X_OK
    if (insInt(env, jdict, "X_OK", (long)X_OK)) return -1;
#endif        

#ifdef WNOHANG
    if (insInt(env, jdict, "WNOHANG", (long)WNOHANG)) return -1;
#endif        
#ifdef O_RDONLY
    if (insInt(env, jdict, "O_RDONLY", (long)O_RDONLY)) return -1;
#endif
#ifdef O_WRONLY
    if (insInt(env, jdict, "O_WRONLY", (long)O_WRONLY)) return -1;
#endif
#ifdef O_RDWR
    if (insInt(env, jdict, "O_RDWR", (long)O_RDWR)) return -1;
#endif
#ifdef O_NDELAY
    if (insInt(env, jdict, "O_NDELAY", (long)O_NDELAY)) return -1;
#endif
#ifdef O_NONBLOCK
    if (insInt(env, jdict, "O_NONBLOCK", (long)O_NONBLOCK)) return -1;
#endif
#ifdef O_APPEND
    if (insInt(env, jdict, "O_APPEND", (long)O_APPEND)) return -1;
#endif
#ifdef O_DSYNC
    if (insInt(env, jdict, "O_DSYNC", (long)O_DSYNC)) return -1;
#endif
#ifdef O_RSYNC
    if (insInt(env, jdict, "O_RSYNC", (long)O_RSYNC)) return -1;
#endif
#ifdef O_SYNC
    if (insInt(env, jdict, "O_SYNC", (long)O_SYNC)) return -1;
#endif
#ifdef O_NOCTTY
    if (insInt(env, jdict, "O_NOCTTY", (long)O_NOCTTY)) return -1;
#endif
#ifdef O_CREAT
    if (insInt(env, jdict, "O_CREAT", (long)O_CREAT)) return -1;
#endif
#ifdef O_EXCL
    if (insInt(env, jdict, "O_EXCL", (long)O_EXCL)) return -1;
#endif
#ifdef O_TRUNC
    if (insInt(env, jdict, "O_TRUNC", (long)O_TRUNC)) return -1;
#endif
#ifdef O_BINARY
    if (insInt(env, jdict, "O_BINARY", (long)O_BINARY)) return -1;
#endif
#ifdef O_TEXT
    if (insInt(env, jdict, "O_TEXT", (long)O_TEXT)) return -1;
#endif

#ifdef HAVE_SPAWNV
    if (insInt(env, jdict, "P_WAIT", (long)_P_WAIT)) return -1;
    if (insInt(env, jdict, "P_NOWAIT", (long)_P_NOWAIT)) return -1;
    if (insInt(env, jdict, "P_OVERLAY", (long)_OLD_P_OVERLAY)) return -1;
    if (insInt(env, jdict, "P_NOWAITO", (long)_P_NOWAITO)) return -1;
    if (insInt(env, jdict, "P_DETACH", (long)_P_DETACH)) return -1;
#endif

#if defined(PYOS_OS2)
    if (insertvalues(env, jdict)) return -1;
#endif
    return 0;
}


JNIEXPORT void JNICALL _PACKAGE(init)(JNIEnv *env, jobject jobj,
    jobject jdict, jobject jOSError)
{
    _TypeErrorStringExpected = PyException(env, excType(env, "TypeError"),
		"String expected");
    all_ins(env, jdict);

    OSError = env->NewGlobalRef(jOSError);
}

















/********************************07/08/25@Naoya Kawaguchi Append*****************************************************/



JNIEXPORT jint JNICALL _PACKAGE(creat)(JNIEnv *env, jclass jcls,
    jstring jpath, jint jmode)
{


    StringUTFChars path(env, jpath);
    if (path.throwIfNull(_TypeErrorStringExpected))
    	return -1;


    int fd = creat(path, jmode);
    if (fd < 0)
    {
    	throwFromErrno(env, OSError, path);
	}
	
    return fd;
}


JNIEXPORT jint JNICALL _PACKAGE(time)(JNIEnv *env, jclass jcls,
   	jlongArray p_time)
{

	int ret = EFAULT;
	time_t t_data;


	// nkprintf("posix.dll native code time() called\n");
	
	ret = time( &t_data );
	
	if ( p_time != NULL)
	{
		
		env->SetLongArrayRegion( p_time, 0, sizeof( time_t ) / sizeof( jlong ) , (jlong *)&t_data);
	}
	
	return ret;
}

#ifdef HAVE_MKNOD
JNIEXPORT jint JNICALL _PACKAGE(mknod)(JNIEnv *env, jclass jcls,
   	jstring jpath, jint mode, jint dev)
{

    StringUTFChars path(env, jpath);
    if (path.throwIfNull(_TypeErrorStringExpected))
    	return EFAULT;


    int fd = mknod(path, mode, dev);
    if (fd < 0)
    {
    	throwFromErrno(env, OSError, path);
	}
	
    return fd;
}
#endif

#ifdef HAVE_LCHOWN
JNIEXPORT jint JNICALL _PACKAGE(lchown16)(JNIEnv *env, jclass jcls,
   	jstring jpath, jint user, jint group)
{

	int ret = EFAULT;
    StringUTFChars path(env, jpath);
    if (path.throwIfNull(_TypeErrorStringExpected))
    	return ret;

	ret = lchown16( path, user, group);
	
	
    return ret;
}
#endif


#ifdef HAVE_STIME
JNIEXPORT jint JNICALL _PACKAGE(stime)(JNIEnv *env, jclass jcls,
   	jlongArray p_time)
{
	time_t time_dat;
	
	env->GetLongArrayRegion( p_time, 0, sizeof( time_t) / sizeof(jlong), (jlong *)&time_dat);
	
	int ret = stime( &time_dat );
	
	
	
	return ret;
}
#endif

#ifdef HAVE_PTRACE
JNIEXPORT jint JNICALL _PACKAGE(ptrace)(JNIEnv *env, jclass jcls,
   	jint request, jint pid, jbyteArray address, jbyteArray data)
{
	int ret = ptrace( request, pid, address, data);
	
	return ret;
}
#endif

//#ifdef HAVE_ALARM
JNIEXPORT jint JNICALL _PACKAGE(alarm)(JNIEnv *env, jclass jcls,
 	jint seconds)

{

	nkprintf("posix.cpp alarm() called\n");

	int ret = alarm( seconds );
	
	return ret;
}
//#endif

#ifdef HAVE_PAUSE
JNIEXPORT jint JNICALL _PACKAGE(pause)(JNIEnv *env, jclass jcls)
{
	int ret = pause();
	
	return ret;
}
#endif

#ifdef HAVE_SYNC
JNIEXPORT void JNICALL _PACKAGE(pause)(JNIEnv *env, jclass jcls)
{
	sync();
	
	return ;
}
#endif

#ifdef HAVE_PIPE
JNIEXPORT int JNICALL _PACKAGE(pause)(JNIEnv *env, jclass jcls, jintArray pipes)
{
#if defined(PYOS_OS2)
    HFILE read, write;
    APIRET rc;
    rc = DosCreatePipe( &read, &write, 4096);
    
    pipes[0] = read;
    pipes[1] = write;
    if (rc != NO_ERROR)
        return os2_error(rc);

    return (int)rc
#else
#if !defined(MS_WIN32)

    int	int_pipes[2];

    int res = pipe( int_pipes);
 
    //pipes[0] = int_pipes[0];
    //pipes[1] = int_pipes[1];
	//07/11/28 Ƃ肠RpC邽߁AɃRgAEg

    if (res != 0)
	throwFromErrno(env, OSError);
    return res;
#else /* MS_WIN32 */
    HANDLE read, write;
    BOOL ok = CreatePipe(&read, &write, NULL, 0);
    if (!ok)
	throwFromErrno(env, OSError);
    int read_fd = _open_osfhandle((long)read, 0);
    int write_fd = _open_osfhandle((long)write, 1);
    
   	env->SetIntArrayRegion( pipes, 0, 1, (jint *)&read_fd);
   	env->SetIntArrayRegion( pipes, 1, 1, (jint *)&write_fd);
    
    return (int)ok;
#endif /* MS_WIN32 */
#endif
}
#endif



#ifdef HAVE_TIMES
JNIEXPORT jlongArray JNICALL _PACKAGE(pause)(JNIEnv *env, jclass jcls)
{
	
	struct tms t;
	
	clock_t ret_t = times( &t );
	
	jlong_arr = new jlongArray( env, 5, 
					(long long)t.tms_utime, 
					(long long)t.tms_stime,
					(long long)t.tms_cutime,
					(long long)t.tms_cstime,
					(long long)t.tms_cstime,
					(long long) ( ret_t / 60 ) );
	
	return jlong_arr;
}
#endif





/*
	ȉAԂ[܂ĕKvȂ̂
*/


#if !defined MS_WIN32

JNIEXPORT jint JNICALL _PACKAGE(writev)(JNIEnv *env, jclass jcls, jint fd, jbyteArray jbuffer, jint size)
{

		struct iovec	iovec;

		jbyte* cbuf = env->GetByteArrayElements(jbuffer, NULL);
		
		
		iovec.iov_base = cbuf;
		iovec.iov_len = env->GetArrayLength(jbuffer);
		
		jint ret = (jint)writev( fd, &iovec, size);
		
		return ret;
}

#endif


#if !defined MS_WIN32
JNIEXPORT jint JNICALL _PACKAGE(uname)(JNIEnv *env, jclass jcls, jobjectArray jarr)
{

	struct utsname name;
	memset( &name, 0x00, sizeof( struct utsname) );
	
	jint ret = uname( &name );
	jstring elems[6];
	
	if ( ret >= 0)
	{
		
		elems[0] = env->NewStringUTF( name.sysname );
		elems[1] = env->NewStringUTF( name.nodename );
		elems[2] = env->NewStringUTF( name.release );
		elems[3] = env->NewStringUTF( name.version );
		elems[4] = env->NewStringUTF( name.machine );
		
		#ifdef _GNU_SOURCE
		elems[5] = env->NewStringUTF( name.domainname);
		#else
		elems[5] = env->NewStringUTF("\0");
		#endif
		
		for(int i = 0 ; i < 6; i++)
		{
			env->SetObjectArrayElement( jarr, i, elems[i] );
		}
	}
	
	
	return ret;
}
#endif
			

















/*
	\Pbg֘Å֐ MS_WIN32ł͘b₱Ȃ̂ŁAł͎Ȃ
	
*/



jint	addrArrToSockaddr( jlong* p_addrArr, struct sockaddr* sockaddr)
{
	//struct sockaddr_inXXX\̂addrArrϊ. ߂l͍\̂̃TCY. 2̃|C^̎QƐ͏\ɑ傫ȋԂmۂ邱.


	nkprintf("JNI DLL side() addrArrToSockaddr() called\n");

	unsigned int addrlen = p_addrArr[0];
	
	addrlen = ntohl( addrlen );	//lbg[NoCgI[_[œn.


	nkprintf("JNI DLL side() addrArrToSockaddr() addrlen = %u\n", (unsigned int)addrlen );

	if ( addrlen == sizeof(struct sockaddr_in ) )
	{
		struct sockaddr_in*	addr_in = (struct sockaddr_in*)sockaddr;

		addr_in->sin_family	= p_addrArr[1];
		addr_in->sin_addr.s_addr	= p_addrArr[2];
		addr_in->sin_port	= p_addrArr[3];

		return addrlen;
	}

	#ifdef Linux
	else if ( addrlen == sizeof(struct sockaddr_in6) )
	{
		struct sockaddr_in6*	addr_in = (struct sockaddr_in6*)sockaddr;
		
		addr_in->sin6_family	= p_addrArr[1];
		addr_in->sin6_port	= p_addrArr[2];
		addr_in->sin6_flowinfo	= p_addrArr[3];

		memcpy( &( addr_in->sin6_addr) + 0, &p_addrArr[4], sizeof(jlong) );
		memcpy( &( addr_in->sin6_addr) + sizeof(jlong), &p_addrArr[5], sizeof(jlong) );
		
		addr_in->sin6_scope_id	= p_addrArr[6];

		return addrlen;
	}
	#endif

	else if ( addrlen == sizeof(struct sockaddr_un) )
	{
		struct sockaddr_un*	addr_un = (struct sockaddr_un*)sockaddr;
		unsigned char			sun_path[ sizeof(struct sockaddr_un) ];

		memset( sun_path, 0x00, sizeof(sun_path) );

		addr_un->sun_family	= (u_char)p_addrArr[1];


		//sun_path̍ő咷͂炭106
		int max_sun_path = 106;
		int arr_sun_path_index = 2;
		for( int i=0; i < max_sun_path; i++)
		{
			sun_path[i] = (unsigned char)p_addrArr[ arr_sun_path_index + i ];
		}

		if ( max_sun_path > sizeof( addr_un->sun_path ) )
		{
			nkprintf("JNI DLL side() : addrArrToSockaddr() warning: max_sun_path=%d > sizeof( addr_un->sun_path)=%d\n", max_sun_path, sizeof( addr_un->sun_path) );
		}


		// strcpy( addr_un->sun_path, (char*)sun_path );
		strncpy( addr_un->sun_path, (char*)sun_path, sizeof( addr_un->sun_path ) );

		// nkprintf("JNI DLL side() : addrArrToSockaddr() addr_un->sun_family = %d, addr_un->sun_path = \"%s\" \n", addr_un->sun_family, addr_un->sun_path);
		nkprintf("JNI DLL side() : addrArrToSockaddr() addr_un->sun_family = %\n", addr_un->sun_family );
		if ( strlen( (char*)sun_path ) <= sizeof( addr_un->sun_path ) )
		{
			nkprintf("addr_un->sun_path = \"%s\" \n", addr_un->sun_path);
		}


		return addrlen;
	}


	nkprintf("JNI DLL side() : addrArrToSockaddr() addrlen %d is not support \n");

	return -1;
}


jint	sockaddrToAddrArr( struct sockaddr* addr, int addrlen, jlong* addrArr)
{
	//sockaddr\̂YaddrArrɕϊ.addrlen͂̊̃zXgoCgI[_[
	//߂l͐ƂɁAzXgoCgI[_[addrlen, sƂ-1

	if ( addrlen == sizeof(struct sockaddr_in) )
	{
		struct sockaddr_in* addr_in = (struct sockaddr_in*)addr;

		addrArr[0] = htonl( addrlen );
		addrArr[1] = addr_in->sin_family;
		addrArr[2] = addr_in->sin_addr.s_addr;
		addrArr[3] = addr_in->sin_port;


		nkprintf("JNI DLL side.( posix.cpp ) sockaddrToAddrArr() addr_in->sin_family = %d\n", addr_in->sin_family );
		
		return 0;
	}

	#ifdef Linux
	else if ( addrlen == sizeof(struct sockaddr_in6))
	{
		struct sockaddr_in6* addr_in = (struct sockaddr_in6*)addr;
		addrArr[0] = htonl( addrlen );
		addrArr[1] = addr_in->sin6_family;
		addrArr[2] = addr_in->sin6_port;
		addrArr[3] = addr_in->sin6_flowinfo;

		memcpy( &addrArr[4], &addr_in->sin6_addr, 8);
		memcpy( &addrArr[5], &addr_in->sin6_addr + 8, 8);

		addrArr[6] = addr_in->sin6_scope_id;
		return 0;
	}
	#endif

	else if ( addrlen == sizeof( struct sockaddr_un) )
	{

		nkprintf("JNI DLL side : sockaddrToAddrArr() sockaddr_un convert\n");

		sockaddr_un* addr_un = (sockaddr_un*)addr;

		addrArr[0] = htonl( addrlen );
		addrArr[1] = addr_un->sun_family;

		int arr_sun_path_index	= 2;
		int max_sun_path_len	= 106;
		for( int i=0; i < max_sun_path_len; i++)
		{
			addrArr[ arr_sun_path_index + i] = addr_un->sun_path[i];
		}

		nkprintf("JNI DLL side : sockaddrToAddrArr() sockaddr_un return\n");

		return 0;
	}

	#ifdef Linux
	else if ( ( ( sockaddr_un*)addr )->sun_family == AF_FILE )
	{
		// 09/03/14 ǉ.
		// AF_FILEȂvgR炵.̂UNIXhC\Pbg.

		nkprintf("JNI DLL side : sockaddrToAddrArr() type AF_FILE\n" );

		jint un_ret = sockaddrToAddrArr( addr, sizeof( struct sockaddr_un ), addrArr );
		// UNIXhC\Pbg̍\̂Ƃď.
		return un_ret;
	}
	#endif

	else if ( ( ( sockaddr_un*)addr )->sun_family == AF_UNIX )
	{
		// 09/03/14 ǉ.
		// UNIXhC\Pbg,getpeername()Ȃǂ̃TCYsȏꍇɓKp.

		nkprintf("JNI DLL side : sockaddrToAddrArr() type AF_FILE\n" );

		jint un_ret = sockaddrToAddrArr( addr, sizeof( struct sockaddr_un ), addrArr );
		// UNIXhC\Pbg̍\̂Ƃď.
		return un_ret;
	}
	



	nkprintf("JNI DLL side : sockaddrToAddrArr() failed. invalid size addrlen=%d\n", addrlen );


	return -1;
} 
		


#if !defined MS_WIN32

JNIEXPORT jint JNICALL _PACKAGE(socket)(JNIEnv *env, jclass jcls, jint family, jint type, jint protocol)
{

	

	jint fd = socket( family, type, protocol);

	nkprintf("JNI DLL side. socket() = %d\n", fd);

	nkprintf("JNI DLL side : socket() family=%d type=%d protocol=%d\n", family, type, protocol);

	nkprintf("JNI DLL side : socket() this architecture AF_INET= %d, PF_UNIX=%d\n", AF_INET, PF_UNIX );

	return fd;
}


//JNIEXPORT jint JNICALL _PACKAGE(bind)(JNIEnv *env, jclass jcls, jint family, jint fd, jlong address, jint port, jint addrlen)

JNIEXPORT jint JNICALL _PACKAGE(bind)(JNIEnv *env, jclass jcls, jint fd, jlongArray addrArr)
{

	jint ret = -1;
	int addrlen_support = -1;

	jlong* p_addrArr = env->GetLongArrayElements( addrArr, NULL);

	int addrlen = p_addrArr[0];

	addrlen = ntohl( addrlen );

	env->ReleaseLongArrayElements( addrArr, p_addrArr, 0);


	if ( addrlen == sizeof( struct sockaddr_in) )
	{
		//IPv4p
		addrlen_support = 0;
		ret = bindIPv4( env, jcls, fd, addrArr);
	}
	#ifdef Linux
	else if ( addrlen == sizeof( struct sockaddr_in6 ) )
	{
		addrlen_support = 0;
		ret = bindIPv6( env, jcls, fd, addrArr );
	}
	#endif
	else if ( addrlen == sizeof( struct sockaddr_un ) )
	{
		addrlen_support = 0;
		ret = bindUN( env, jcls, fd, addrArr );
	}


	nkprintf("JNI DLL side : bind() ret = %d\n", ret);
	if ( ret < 0)
	{
		nkprintf("JNI DLL side : bind() errno = %d , addrlen_support = %d, addrlen = %d\n", errno, addrlen_support, addrlen);
	}



	return ret;
}




/*
jint	bindIPv4(JNIEnv *env, jclass jcls, jint fd, jlongArray addrArr)
{
	//struct sockaddr_in\̂16oCgƂ(IPv4)̍ۂɌĂ΂.

	struct sockaddr_in addr_in;
	jint ret = 0;
	jlong* p_addrArr;
	int addrlen = 0;

	memset( &addr_in, 0x00, sizeof(struct sockaddr_in));

	p_addrArr = env->GetLongArrayElements( addrArr, NULL);

	addrlen			= p_addrArr[0];//n鐔l̓lbg[NoCgI[_[ł.
	addr_in.sin_family	= p_addrArr[1];
	addr_in.sin_addr.s_addr	= p_addrArr[2];
	addr_in.sin_port	= p_addrArr[3];

	addrlen = ntohl( addrlen );

	if ( addrlen != sizeof(struct sockaddr) )
	{
		// address̃p[^͎ۂɂsockaddr\̂̃TCYƂȂ邽߁AlCeBuR[hŒĂKvB
		nkprintf("JNI DLL side : bind() addrlen is changed from %d to %d\n", addrlen, sizeof( struct sockaddr) );
		addrlen = sizeof( struct sockaddr );
	}

	
	//eXgp
	//addr_in.sin_family = AF_INET;
	//addr_in.sin_addr.s_addr = inet_addr("0.0.0.0");
	//addr_in.sin_port = htons(8888);
	//addrlen = sizeof( struct sockaddr );
	


	ret = bind( fd, (struct sockaddr*)&addr_in, addrlen);

	
	p_addrArr[0] = htonl( addrlen );
	p_addrArr[1] = addr_in.sin_family;
	p_addrArr[2] = addr_in.sin_addr.s_addr;
	p_addrArr[3] = addr_in.sin_port;

	nkprintf("JNI DLL side. bind(%s:%d) = %d\n", inet_ntoa( addr_in.sin_addr ), ntohs((short)p_addrArr[3]), ret);


	nkprintf("JNI DLL side : bind() sin_family = %d addrlen = %d\n", (int)addr_in.sin_family, addrlen );
	nkprintf("JNI DLL side : bind() this architecture AF_INET= %d, PF_UNIX=%d\n", AF_INET, PF_UNIX );
	if ( ret < 0)
	{
		nkprintf("JNI DLL side : bind() ERRNO=%d\n", errno );

	}


	env->ReleaseLongArrayElements( addrArr, p_addrArr, 0);


	return ret;
}
*/


jint	bindIPv4(JNIEnv *env, jclass jcls, jint fd, jlongArray addrArr)
{
	
	struct sockaddr_in	addr_in;
	int ret = -1;
	int addrlen = 0;


	jlong *p_addrArr = env->GetLongArrayElements( addrArr, NULL);
	addrlen = addrArrToSockaddr( p_addrArr, (struct sockaddr*)&addr_in);

	ret = bind( fd, (struct sockaddr*)&addr_in, addrlen);

	env->ReleaseLongArrayElements( addrArr, p_addrArr, 0);

	return ret;
}



#ifdef Linux
jint	bindIPv6(JNIEnv *env, jclass jcls, jint fd, jlongArray addrArr)
{
	//struct sockaddr_in\̂16oCgƂ(IPv4)̍ۂɌĂ΂.

	struct sockaddr_in6 addr_in6;
	jint ret = 0;
	jlong* p_addrArr;
	int addrlen = 0;

	memset( &addr_in6, 0x00, sizeof(struct sockaddr_in6));

	p_addrArr = env->GetLongArrayElements( addrArr, NULL);

	addrlen = addrArrToSockaddr( p_addrArr, (struct sockaddr*)&addr_in6);

	ret = bind( fd, (struct sockaddr*)&addr_in6, addrlen );

	env->ReleaseLongArrayElements( addrArr, p_addrArr, 0);


	return ret;
}
#endif


jint	bindUN(JNIEnv *env, jclass jcls, jint fd, jlongArray addrArr)
{
	//struct sockaddr_in\̂16oCgƂ(IPv4)̍ۂɌĂ΂.

	struct sockaddr_un addr_un;
	jint ret = 0;
	jlong* p_addrArr;
	int addrlen = 0;

	memset( &addr_un, 0x00, sizeof(struct sockaddr_un));

	p_addrArr = env->GetLongArrayElements( addrArr, NULL);

	addrlen = addrArrToSockaddr( p_addrArr, (struct sockaddr*)&addr_un);

	ret = bind( fd, (struct sockaddr*)&addr_un, addrlen );


	nkprintf("JNI DLL side : bindUN() ret = %d errno = %d, addrlen = %d\n", ret, errno, addrlen );

	env->ReleaseLongArrayElements( addrArr, p_addrArr, 0);


	return ret;
}





JNIEXPORT jint JNICALL _PACKAGE(connect)(JNIEnv *env, jclass jcls, jint fd, jlongArray addrArr)
{
	
	nkprintf("JNI DLL side : connect() called\n", 0);

	jint ret = -1;
	int  addrlen_support = -1;
	int  addrlen = 0;
	unsigned char	sockaddr[1024];

	nkprintf("JNI DLl side : connect() GetLongArrayElements() call\n");
	jlong *p_addrArr = env->GetLongArrayElements( addrArr, NULL);

	addrlen = addrArrToSockaddr( p_addrArr, (struct sockaddr*)sockaddr);

	nkprintf("JNI DLL side : connect() addrlen = %d\n", addrlen);

	ret = connect( fd, (struct sockaddr*)sockaddr, addrlen);


	nkprintf("JNI DLL side : connect() = %d\n", ret);



	sockaddrToAddrArr( (struct sockaddr*)sockaddr, addrlen, p_addrArr);




	env->ReleaseLongArrayElements( addrArr, p_addrArr, 0);


	return ret;
}



/*
JNIEXPORT jint JNICALL _PACKAGE(connect)(JNIEnv *env, jclass jcls, jint fd, jlongArray addrArr)
{


	struct sockaddr_in addr_in;
	jint ret = 0;
	jlong* p_addrArr = NULL;
	int addrlen = 0;

	memset( &addr_in, 0x00, sizeof(struct sockaddr_in));

	p_addrArr = env->GetLongArrayElements( addrArr, NULL);


	addrlen			= p_addrArr[0];
	addr_in.sin_family	= p_addrArr[1];
	addr_in.sin_addr.s_addr	= p_addrArr[2];
	addr_in.sin_port	= p_addrArr[3];


	addrlen	= ntohl( addrlen );	//naddrlen̓lbg[NoCgI[_[̐lł.

	nkprintf("JNI DLL side. connect sin_addr.s_arr = %x\n", addr_in.sin_addr.s_addr );



	nkprintf("JNI DLL side. connect(%s:%d)\n", inet_ntoa( addr_in.sin_addr ), ntohs((short)p_addrArr[3]) );


	nkprintf("JNI DLL side : connect() sin_family = %d addrlen = %d\n", (int)addr_in.sin_family, addrlen );
	nkprintf("JNI DLL side : connect() this architecture AF_INET= %d, PF_UNIX=%d\n", AF_INET, PF_UNIX );
	


	if ( addrlen != sizeof(struct sockaddr_in) )
	{
		//AhXK؂ȒɕύX

		nkprintf("JNI DLL side : connect() addrlen is defferent size of struct sockaddr_in :%d ...So change this value to %d\n", 
														addrlen, sizeof(struct sockaddr_in) );
	
		addrlen = sizeof(struct sockaddr_in);
	}



	//eXgp
	//addr_in.sin_family = AF_INET;
	//addr_in.sin_addr.s_addr = inet_addr("127.0.0.1");
	//addr_in.sin_port = htons( 8888 );
	//addrlen = sizeof( struct sockaddr );

	ret = connect( fd, (struct sockaddr *)&addr_in, addrlen);


	p_addrArr[0] = htonl( addrlen );	//Ԃaddrlen̓lbg[NoCgI[_[ł.
	p_addrArr[1] = addr_in.sin_family;
	p_addrArr[2] = addr_in.sin_addr.s_addr;
	p_addrArr[3] = addr_in.sin_port;

	env->ReleaseLongArrayElements( addrArr, p_addrArr, 0);

	

	nkprintf("JNI DLL side. connect(%s:%d) = %d\n", inet_ntoa( addr_in.sin_addr ), ntohs((short)p_addrArr[3]), ret);

	if ( ret < 0)
	{
		nkprintf("JNI DLL side. connect() ERROR errno=%d\n", errno);
	}


	return ret;
}
*/





JNIEXPORT jint JNICALL _PACKAGE(listen)(JNIEnv *env, jclass jcls, jint fd, jint backlog)
{

	int ret = 0;

	ret = listen(fd, backlog);

	nkprintf("JNI DLL side, listen() = %d\n", ret);

	return ret;
}




JNIEXPORT jint JNICALL _PACKAGE(accept)(JNIEnv *env, jclass jcls, jint fd, jlongArray addrArr)
{
	char	sockaddr[1024];
	jint	ret = -1;
	int	addrlen = 0;


	jlong*	p_addrArr = env->GetLongArrayElements( addrArr, NULL);


	addrlen = addrArrToSockaddr( p_addrArr, (struct sockaddr*)sockaddr);
	
	ret = accept( fd, (struct sockaddr*)sockaddr, (socklen_t*)&addrlen);

	sockaddrToAddrArr( (struct sockaddr*)sockaddr, addrlen, p_addrArr);

	nkprintf("JNI DLL side : accept() ret = %d, addrlen = %d\n", ret, addrlen);

	env->ReleaseLongArrayElements( addrArr, p_addrArr, 0);

	return ret;
}


/*
JNIEXPORT jint JNICALL _PACKAGE(accept)(JNIEnv *env, jclass jcls, jint fd, jlongArray addrArr)
{
	
	struct sockaddr_in addr_in;


	int ret;
	socklen_t addrlen = sizeof(struct sockaddr );

	jlong* p_addrArr;

	p_addrArr = env->GetLongArrayElements( addrArr, NULL);


	addrlen			= p_addrArr[0];
	addr_in.sin_family	= p_addrArr[1];
	addr_in.sin_addr.s_addr	= p_addrArr[2];
	addr_in.sin_port	= p_addrArr[3];

	addrlen	= ntohl( addrlen );	//nAhX̓lbg[NoCgI[_[

	if ( addrlen != sizeof(struct sockaddr ) )
	{
		addrlen = sizeof( struct sockaddr );
	}
	
	ret = accept(fd, (struct sockaddr *)&addr_in, &addrlen);

	p_addrArr[0] = htonl( addrlen );	//ԂAhX̓lbg[NoCgI[_[
	p_addrArr[1] = addr_in.sin_family;
	p_addrArr[2] = addr_in.sin_addr.s_addr;
	p_addrArr[3] = addr_in.sin_port;

	env->ReleaseLongArrayElements( addrArr, p_addrArr, 0);

	nkprintf("JNI DLL side. accept() = %d\n", ret);

	if ( ret < 0)
	{
		nkprintf("JNI DLL side. accept() failed. ErrCode =%d\n", errno );

	}



	return ret;
}
*/





JNIEXPORT jint JNICALL _PACKAGE(send)(JNIEnv *env, jclass jcls, jint fd, jbyteArray jbuffer, jint size, jlong flag)
{

	jint ret = 0;

    	jbyte* cbuf = env->GetByteArrayElements(jbuffer, NULL);

	ret = send( fd, (char *)cbuf, size, flag);

	nkprintf("JNI DLL side, send() = %d\n", ret);

	return ret;
}

JNIEXPORT jint JNICALL _PACKAGE(recv)(JNIEnv *env, jclass jcls, jint fd, jbyteArray jbuffer, jint size, jlong flag)
{

	jint ret = 0;

	jbyte* cbuf = env->GetByteArrayElements(jbuffer, NULL);

	ret = recv( fd, (char *)cbuf, size, flag);

	env->ReleaseByteArrayElements( jbuffer, cbuf, 0);


	nkprintf("JNI DLL side, recv() = %d\n", ret);

	if ( ret < 0)
	{
		nkprintf("JNI DLL side. recv() failed. ErrCode =%d\n", errno );

	}

	return ret;
}


JNIEXPORT jint JNICALL _PACKAGE(sendto)(JNIEnv *env, jclass jcls, jint fd, jbyteArray jbuffer, jint size, jlong flag, jlongArray addrArr)
{


	char	sockaddr[1024];

	int	addrlen = 0;
	
	jlong* p_addrArr = env->GetLongArrayElements(addrArr, NULL);
	jbyte* cbuf	= env->GetByteArrayElements( jbuffer, NULL);

	jint ret = 0;

	int param_addrlen = addrlen = addrArrToSockaddr( p_addrArr, (struct sockaddr*)sockaddr );


	struct sockaddr*	p_sockaddr = (struct sockaddr*)sockaddr;

	if ( addrlen < 0)
	{
		p_sockaddr = NULL;
		addrlen = 0;
	}

	ret = sendto(fd, (char *)cbuf, size, flag, (struct sockaddr*)p_sockaddr, addrlen);


	nkprintf("JNI DLL side : sendto() ret = %d, size = %d\n", ret, size );


	env->ReleaseByteArrayElements( jbuffer, cbuf, 0);
	env->ReleaseLongArrayElements( addrArr, p_addrArr, 0);
	
	return ret;

}


JNIEXPORT jint JNICALL _PACKAGE(recvfrom)(JNIEnv *env, jclass jcls, jint fd, jbyteArray jbuffer, jint size, jlong flag, jlongArray addrArr)
{


	// recvfrom  sockaddraddrlen̈NULLwł.

	nkprintf("JNI DLL side : recvfrom() called : fd = %d, size = %d flag = %d\n", fd, size, flag);


	char	sockaddr[1024];

	jint ret = 0;
	int addrlen = 0;

	jlong* caddrArr = env->GetLongArrayElements(addrArr, NULL);

	jbyte* cbuf = env->GetByteArrayElements(jbuffer, NULL);


	int param_addrlen = addrlen = addrArrToSockaddr( caddrArr, (struct sockaddr*)sockaddr );

	struct sockaddr* p_sockaddr = (struct sockaddr*)sockaddr;

	if ( addrlen < 0)
	{
		p_sockaddr = NULL;
		addrlen = 0;
	}
	
	if ( addrlen > 0)
	{
		nkprintf("JNI DLL side : recvfrom() sockaddr NOT NULL params, addrlen = %d\n", addrlen);
		ret = recvfrom( fd, (char*)cbuf, size, flag, (struct sockaddr*)p_sockaddr, (socklen_t*)&addrlen );
	}
	else
	{
		nkprintf("JNI DLL side : recvfrom() sockaddr NULL parames\n");
		ret = recvfrom( fd, (char*)cbuf, size, flag, NULL, NULL);
	}


	nkprintf("JNI DLL side : recfrom() = %d errno =%d\n", ret, errno);


	if ( param_addrlen > 0)
	{
		//NULLȂǂłȂ.
		sockaddrToAddrArr( (struct sockaddr*)sockaddr, addrlen, caddrArr);
	}


	env->ReleaseByteArrayElements( jbuffer, cbuf, 0);
	env->ReleaseLongArrayElements( addrArr, caddrArr, 0);
	
	return ret;

}



JNIEXPORT jlong JNICALL _PACKAGE(getsockname)(JNIEnv *env, jclass jcls, jint fd, jlongArray addrArr)
{

	char sockaddr[1024];
	int  addrlen = 1024;

	memset( sockaddr, 0x00, addrlen );
	int ret = getsockname( fd, (struct sockaddr*)sockaddr, (socklen_t*)&addrlen );

	jlong* c_addrArr = env->GetLongArrayElements( addrArr, NULL);
	sockaddrToAddrArr( (struct sockaddr*)sockaddr, addrlen,  c_addrArr);

	env->ReleaseLongArrayElements( addrArr, c_addrArr, 0);

	nkprintf("JNI DLL side.(posix.cpp) getsockaname() = %d\n", ret );

	return ret;
}


JNIEXPORT jlong JNICALL _PACKAGE(getpeername)(JNIEnv *env, jclass jcls, jint fd, jlongArray addrArr)
{

	char sockaddr[1024];
	int  addrlen = 1024;

	memset( sockaddr, 0x00, addrlen );
	int ret = getpeername( fd, (struct sockaddr*)sockaddr, (socklen_t*)&addrlen );

	jlong* c_addrArr = env->GetLongArrayElements( addrArr, NULL);
	sockaddrToAddrArr( (struct sockaddr*)sockaddr, addrlen,  c_addrArr);


	nkprintf("JNI DLL side.(posix.cpp) getpeeraname() c_addrArr[0]=%llu\n",  c_addrArr[0] );


	env->ReleaseLongArrayElements( addrArr, c_addrArr, 0);

	nkprintf("JNI DLL side.(posix.cpp) getpeeraname() = %d\n", ret );
	nkprintf("JNI DLL side.(posix.cpp) getpeeraname() addrlen=%d\n", addrlen );

	return ret;
}


JNIEXPORT jlong JNICALL _PACKAGE(setsockopt)(JNIEnv *env, jclass jcls, jint fd, jint level, jint optname, jbyteArray optval, jint optlen)
{
	//setsockopt()
	//optlen4oCg܂2oCgłꍇɂ́AޯރGfBAœnĂ̂ƂăzXgoCgI[_[ւ̕ϊs.
	//ȊÕTCYł̓GfBAϊsȂ.


	nkprintf("JNI DLL side.(posix.cpp) setsockopt() called. optlen=%d\n", optlen );


	char buf[1024];
	memset(buf, 0x00, 1024);

	jbyte* c_optval = env->GetByteArrayElements( optval, NULL);
	

	if ( optlen == sizeof(int) )
	{
		unsigned int tmp = ntohl( *( (unsigned int*)c_optval) );
		memcpy( buf, &tmp, sizeof(int) );
	}
	else if ( optlen == sizeof(short) )
	{
		unsigned short tmp = ntohs( *( (unsigned short*)c_optval) );
		memcpy( buf, &tmp, sizeof(short) );
	}
	else
	{
		memcpy( buf, c_optval, optlen );
	}

	jlong ret = setsockopt(fd, level, optname, buf, optlen );


	if ( optlen == sizeof(int) )
	{
		unsigned int tmp = htonl( *( (unsigned int*)buf) );
		memcpy( c_optval, &tmp, sizeof(int) );
	}
	else if (optlen == sizeof(short) )
	{
		unsigned short tmp = htons( *( (unsigned short*)buf) );
		memcpy( c_optval, &tmp, sizeof(short) );
	}
	else
	{
		memcpy( c_optval, buf, optlen );
	}

	
	env->ReleaseByteArrayElements( optval, c_optval, 0);


	nkprintf("JNI DLL side.(posix.cpp) setsockopt() return\n");

	return ret;

}


JNIEXPORT jlong JNICALL _PACKAGE(getsockopt)(JNIEnv *env, jclass jcls, jint fd, jint level, jint optname, jbyteArray optval, jintArray optlen_arr)
{
	//getsockopt()
	//optlen4oCg܂2oCgłꍇɂ́AޯރGfBAœnĂ̂ƂăzXgoCgI[_[ւ̕ϊs.
	//ȊÕTCYł̓GfBAϊsȂ.


	char buf[1024];
	memset(buf, 0x00, 1024);

	jbyte* c_optval = env->GetByteArrayElements( optval, NULL);
	
	jint* p_optlen = env->GetIntArrayElements( optlen_arr, NULL );


	nkprintf("JNI DLL side.(posix.cpp) getsockopt() called. optlen=%d\n", *p_optlen );

	if ( *p_optlen == sizeof(int) )
	{
		unsigned int tmp = ntohl( *( (unsigned int*)c_optval) );
		memcpy( buf, &tmp, sizeof(int) );
	}
	else if ( *p_optlen == sizeof(short) )
	{
		unsigned short tmp = ntohs( *( (unsigned short*)c_optval) );
		memcpy( buf, &tmp, sizeof(short) );
	}
	else
	{
		memcpy( buf, c_optval, *p_optlen );
	}

	jlong ret = getsockopt(fd, level, optname, buf, (socklen_t*)p_optlen );


	if ( *p_optlen == sizeof(int) )
	{
		unsigned int tmp = htonl( *( (unsigned int*)buf) );
		memcpy( c_optval, &tmp, sizeof(int) );
	}
	else if (*p_optlen == sizeof(short) )
	{
		unsigned short tmp = htons( *( (unsigned short*)buf) );
		memcpy( c_optval, &tmp, sizeof(short) );
	}
	else
	{
		memcpy( c_optval, buf, *p_optlen );
	}

	env->ReleaseIntArrayElements( optlen_arr, p_optlen, 0 );

	
	env->ReleaseByteArrayElements( optval, c_optval, 0);


	nkprintf("JNI DLL side.(posix.cpp) getsockopt() return\n");

	return ret;

}





JNIEXPORT jlong JNICALL _PACKAGE(inetaddr)(JNIEnv *env, jclass jcls, jstring addrstr)
{

	//posix-APIł͂ȂA̓s֗Ȃ̂Œǉ

	const char* utf_addrstr;
	jboolean isCopy;
	jlong addr_long;

	

	utf_addrstr = env->GetStringUTFChars(addrstr, &isCopy);
	

	addr_long = (jlong)inet_addr(utf_addrstr);

	nkprintf("posix DLL side inetaddr():%s to %d\n", utf_addrstr, addr_long);

	env->ReleaseStringUTFChars(addrstr, utf_addrstr);

	return addr_long;

}



JNIEXPORT jstring JNICALL _PACKAGE(inetntoa)(JNIEnv *env, jclass jcls, jlong addr_long)
{
	//posix-APIł͂ȂA̓s֗Ȃ̂Œǉ

	struct in_addr inaddr;
	const char* addr_utf;

	inaddr.s_addr = addr_long;

	addr_utf = inet_ntoa(inaddr);

	return env->NewStringUTF( addr_utf);
}


JNIEXPORT jlong JNICALL _PACKAGE(htons)(JNIEnv *env, jclass jcls, jlong host_endian_port)
{
	//posix-APIł͂ȂA̓s֗Ȃ̂Œǉ

	jlong net_endian_port = 0;

	net_endian_port = (jlong)htons( (unsigned short)host_endian_port);

	return net_endian_port;
}



JNIEXPORT jlong JNICALL _PACKAGE(getErrno)(JNIEnv *env, jclass jcls )
{
	
	return errno;
}



unsigned long long global_cycle_upper = 0;
unsigned long long global_cycle_lower = 0;


JNIEXPORT jlong JNICALL _PACKAGE(getCycleCounter)(JNIEnv *env, jclass jcls )
{
	//Ǝ.lCeBu̃TCNJE^擾.
	//AAx86/Linuxł̂ݓ삷.
	
	unsigned long long cycle;	//-8(%ebp)
	unsigned long long cycle_upper;	//-16(%ebp)
	unsigned long long cycle_lower;	//-24(%ebp)

	cycle = cycle_upper = cycle_lower = 0;

	
	#if ( defined(Linux) && defined(x86) )


		//asm("pushl %eax");
		//asm("pushl %edx");
		
		asm("rdtsc");
		asm("movl %eax,-24(%ebp)");
		asm("movl %edx,-16(%ebp)");

		asm("movl %edx,global_cycle_upper");
		asm("movl %eax,global_cycle_lower");
		
		//asm("popl %edx");
		//asm("popl %eax");

	//nkprintf("JNI DLL side : getCycleCounter() cycle_upper = %llu\n", cycle_upper);
	//nkprintf("JNI DLL side : getCycleCounter() cycle_lower = %llu\n", cycle_lower);

	//nkprintf("JNI DLL side : getCycleCounter() global_cycle_upper = %llu\n", global_cycle_upper);
	//nkprintf("JNI DLL side : getCycleCounter() global_cycle_lower = %llu\n", global_cycle_lower);

		cycle = cycle_upper << 32 | cycle_lower;

		cycle = global_cycle_upper << 32 | global_cycle_lower;

	#endif
	


	// nkprintf("JNI DLL side : getCycleCounter() %llu\n", cycle);




	return (jlong)cycle;

}




JNIEXPORT jlong JNICALL _PACKAGE(getSocketConstValue)(JNIEnv *env, jclass jcls, jstring constValueName)
{
	//Ǝ֐.AF_INETSOCK_STREAM,IPPROT_TCP Ȃǂ̒萔lԂ
	//萔l݂Ȃꍇ́AԂ

	const char* utf_valueName;
	jboolean isCopy;

	jlong value;

	utf_valueName = env->GetStringUTFChars( constValueName, &isCopy);
	

	if ( strcmp(utf_valueName, "AF_INET") == 0)
	{
		value = AF_INET;
	}
	else if ( strcmp(utf_valueName, "AF_UNIX") == 0)
	{
		value = AF_UNIX;
	}

	#if !defined (Linux)
	else if ( strcmp(utf_valueName, "AF_ISO") == 0)
	{
		value = AF_ISO;
	}

	else if ( strcmp(utf_valueName, "AF_NS") == 0)
	{
		value = AF_NS;
	}
	#endif

	#if !defined(Cygwin)
	
	else if ( strcmp(utf_valueName, "AF_NETLINK") == 0)
	{
		value = AF_NETLINK;
	}
	#endif


	else if ( strcmp(utf_valueName, "SOCK_STREAM") == 0)
	{
		value = SOCK_STREAM;
	}
	else if ( strcmp(utf_valueName, "SOCK_DGRAM") == 0)
	{
		value = SOCK_DGRAM;
	}
	else if ( strcmp(utf_valueName, "SOCK_RAW") == 0)
	{
		value = SOCK_RAW;
	}

	else if ( strcmp(utf_valueName, "IPPROTO_TCP") == 0)
	{
		value = IPPROTO_TCP;
	}
	else if ( strcmp(utf_valueName, "IPPROTO_UDP") == 0)
	{
		value = IPPROTO_UDP;
	}
	else if ( strcmp(utf_valueName, "IPPROTO_RAW") == 0)
	{
		value = IPPROTO_RAW;
	}
	else
	{
		//݂Ȃ.ݒ
		value = -1;
	}


	env->ReleaseStringUTFChars(constValueName, utf_valueName);

	return value;
}

#endif
//\Pbĝ߂MS_WIN32O}N








JNIEXPORT void JNICALL _PACKAGE(hogehoge)(JNIEnv *env, jclass jcls)
{
	//eXgp̊֐

	nkprintf("hogehoge() in DLL side\n");

	return ;
}


int nkprintf(const char *format, ...)
{
	// 09/07/05 ǉ.
	// fobOpprintf()@\.
	// o͐ NKPRINT_FP  posixmodule.h Ő錾Ă.

	va_list argptr;

	va_start(argptr, format);

	fprintf(NKPRINT_FP, format, argptr);

	va_end(argptr);

	return 0;
}



JNIEXPORT jlong JNICALL _PACKAGE(getStdIOFILE)(JNIEnv *env, jclass jcls, jstring str)
{

	jboolean isCopy;
	const char* pstr = env->GetStringUTFChars( str, &isCopy);
	jint len = env->GetStringUTFLength( str );

	FILE* fp = (FILE*)-1;
	if ( strcmp( pstr, "stdin" ) == 0 )
	{
		fp = stdin;
	}
	else if ( strcmp( pstr, "stdout" ) == 0 )
	{
		fp = stdout;
	}
	else if ( strcmp( pstr, "stderr" ) == 0 )
	{
		fp = stderr;
	}

	env->ReleaseStringUTFChars( str, pstr );

	return (jlong)fp;
	
}

JNIEXPORT void JNICALL _PACKAGE(print)(JNIEnv *env, jclass jcls, jlong fp_val, jstring str)
// JNIEXPORT void JNICALL Java_jnios_posix_print(JNIEnv *env, jclass cls, jlong fp_val, jstring str)
{
	//fobOp̏o͋@\.
	//fp_valɂ̓lCeBuR[h̃t@C|C^̒lw肷.


	jboolean isCopy;
	const char* p = env->GetStringUTFChars( str, &isCopy);
	jint len = env->GetStringUTFLength( str );
	
	if ( isCopy == 0)
	{
		nkprintf("posix.print() native code side. isCopy== false\n");
		return ;
	}
	else if ( len < 0)
	{
		nkprintf("posix.print() native code side. len < 0 \n");
		return ;
	}
	
	fprintf( (FILE*)fp_val, "%s", p);
	// lCeBuȃbZ[Wo.
	
	fflush( stdout );

	env->ReleaseStringUTFChars( str, p );
	
	return;
}


JNIEXPORT jstring JNICALL _PACKAGE(gets)(JNIEnv *env, jclass jcls)
{

	char	str[4096];
	
	//scanf( "%s", str); //scanf()Ƌ󔒓͕̕s
	
	gets(str);
	
	return env->NewStringUTF( str );
	
}

JNIEXPORT jobjectArray JNICALL Java_jnios_posix_getenvs(JNIEnv *env, jclass cls)
{
	//ϐ̃XgԂ.
	
	// nkprintf("JNI DLL side.(posix.cpp) getenvs() called\n");


	char**	p_env = environ;
	
	int env_num = 0;
	
	for( int i=0; p_env[i] != NULL; i++)
	{
		//ϐ̌擾	
		env_num++;
	}
	
	jclass jstrcls = env->FindClass( "java/lang/String" );
	jobjectArray jenvs = env->NewObjectArray(env_num, jstrcls, NULL);
	
	for(int i=0; i < env_num; i++)
	{
		env->SetObjectArrayElement( jenvs, i, env->NewStringUTF( p_env[i] ) );
		
	}
	

	// nkprintf("JNI DLL side.(posix.cpp) getenvs() returned\n");

	return jenvs;
	
}






JNIEXPORT jlong JNICALL _PACKAGE(malloc)(JNIEnv *env, jclass jcls, jint size)
{
	
	jlong ret = (jlong)malloc( size );
	
	return ret;
}

JNIEXPORT void JNICALL _PACKAGE(free)(JNIEnv *env, jclass jcls, jlong ptr)
{
	free( (void *)ptr);
}


JNIEXPORT jlong JNICALL _PACKAGE(munmap)(JNIEnv *env, jclass jcls, jlong addr, jlong len)
{
	jlong ret = munmap( (void *)addr, (size_t)len);

	nkprintf("posix.cpp munmap() addr=%p, len=%d, ret=%d\n", (void*)addr, (size_t)len, (int)ret );
	
	return ret;
}


JNIEXPORT jint JNICALL _PACKAGE(mprotect)(JNIEnv *env, jclass jcls, jlong addr, jint len, jint prot)
{
	jint ret = mprotect( (void*)addr, len, prot);
	
	return ret;
}


JNIEXPORT jlong JNICALL _PACKAGE(mmap)(JNIEnv *env, jclass jcls, jlong addr, jlong len, jint prot, jint flags, jint fd, jint pgoff)
{

	// mmap2 mmapƂقړ֐. قȂ̂mmap2pgoff4096oCgPʂƂubÑCfbNXޓ_ł.
	
	nkprintf("posix.cpp NativeCode mmap() called\n");
	
	nkprintf("posix.cpp mmap() addr=%p, len=%d, prot=%d, flags=%d, fd=%d, pgoff=%d\n", (void*)addr, (int)len, (int)prot, (int)flags, (int)fd, (int)pgoff );

	void* ret_p = mmap( (void*)addr, (size_t)len, (int)prot, (int)flags, (int)fd, (off_t)pgoff);

	jlong ret = (jlong)ret_p;
	
	nkprintf("posix.cpp NativeCode mmap() ret_p=%p, ret=%p, errno=%d\n", ret_p, (void*)ret, errno);
	
	
	return ret;
}



JNIEXPORT jlong JNICALL _PACKAGE(getMmapConstValue)(JNIEnv *env, jclass jcls, jstring constValueName)
{
	//Ǝ֐.MAP_SHAREDPROT_WRITE Ԃ.

	const char* utf_valueName;
	jboolean isCopy;

	jlong value;

	utf_valueName = env->GetStringUTFChars( constValueName, &isCopy);
	

	if ( strcmp(utf_valueName, "PROT_READ") == 0)
	{
		value = PROT_READ;
	}
	else if ( strcmp(utf_valueName, "PROT_WRITE") == 0)
	{
		value = PROT_WRITE;
	}
	else if ( strcmp(utf_valueName, "PROT_EXEC") == 0)
	{
		value = PROT_EXEC;
	}

	else if ( strcmp(utf_valueName, "MAP_SHARED") == 0)
	{
		value = MAP_SHARED;
	}
	else if ( strcmp(utf_valueName, "MAP_PRIVATE") == 0)
	{
		value = MAP_PRIVATE;
	}
	else if ( strcmp(utf_valueName, "MAP_ANON") == 0)
	{
		value = MAP_ANON;
	}
	else if ( strcmp(utf_valueName, "MAP_ANONYMOUS") == 0)
	{
		value = MAP_ANONYMOUS;
	}

	#if !defined(Cygwin)
	else if ( strcmp(utf_valueName, "MAP_DENYWRITE") == 0)
	{
		value = MAP_DENYWRITE;
	}
	else if ( strcmp(utf_valueName, "MAP_EXECUTABLE") == 0)
	{
		value = MAP_EXECUTABLE;
	}
	#endif

	else if ( strcmp(utf_valueName, "MAP_FILE") == 0)
	{
		value = MAP_FILE;
	}
	else if ( strcmp(utf_valueName, "MAP_FIXED") == 0)
	{
		value = MAP_FIXED;
	}

	#if !defined(Cygwin)
	else if ( strcmp(utf_valueName, "MAP_GROWSDOWN") == 0)
	{
		value = MAP_GROWSDOWN;
	}
	else if ( strcmp(utf_valueName, "MAP_LOCKED") == 0)
	{
		value = MAP_LOCKED;
	}
	else if ( strcmp(utf_valueName, "MAP_NONBLOCK") == 0)
	{
		value = MAP_NONBLOCK;
	}
	else if ( strcmp(utf_valueName, "MAP_NORESERVE") == 0)
	{
		value = MAP_NORESERVE;
	}
	else if ( strcmp(utf_valueName, "MAP_POPULATE") == 0)
	{
		value = MAP_POPULATE;
	}
	#endif

	else
	{
		//݂Ȃ.ݒ
		value = -1;
	}


	env->ReleaseStringUTFChars(constValueName, utf_valueName);

	return value;
}







JNIEXPORT jlong JNICALL Java_jnios_posix_stat64(JNIEnv *env, jclass, jstring fileNameString, jlongArray stat64Arr)
{

	//stat64\̂̃o蓖ĂɂẮAqfstat64()Q

	int	stat64Arr_size = 20;

	jboolean isCopy;

	const char *utf_fileName = env->GetStringUTFChars(fileNameString, &isCopy);

	jlong* cbuf = env->GetLongArrayElements(stat64Arr, NULL);

	memset( cbuf, 0x00, stat64Arr_size );


	#ifdef Linux
		struct stat64 st_stat;

		int ret = stat64( utf_fileName, &st_stat );
	#endif

	#ifdef Cygwin
		struct stat st_stat;
		int ret = stat( utf_fileName, &st_stat );
	#endif //Cygwin

	env->ReleaseStringUTFChars( fileNameString, utf_fileName );


	cbuf[0] = st_stat.st_dev;

	cbuf[3] = st_stat.st_mode;
	cbuf[4] = st_stat.st_nlink;
	cbuf[5] = st_stat.st_uid;
	cbuf[6] = st_stat.st_gid;
	cbuf[7] = st_stat.st_rdev;

	cbuf[9] = st_stat.st_size;
	cbuf[10] = st_stat.st_blksize;
	cbuf[11] = st_stat.st_blocks;

	cbuf[13] = st_stat.st_atime;

	cbuf[15] = st_stat.st_mtime;

	cbuf[17] = st_stat.st_ctime;

	cbuf[19] = st_stat.st_ino;


	#ifdef Linux
	
	//cbuf[1] = *( (int *)st_stat.__pad0 ); // not use these members Caused by GCC Error
	//cbuf[8] = *( (int*)(st_stat.__pad3) );
	//cbuf[12] = *( (int *)(st_stat.__pad4) );

	cbuf[2] = st_stat.__st_ino;


	//cbuf[14] = st_stat.st_atime_nsec;
	//cbuf[16] = st_stat.st_mtime_nsec;
	//cbuf[18] = st_stat.st_ctime_nsec;

	#endif

	env->ReleaseLongArrayElements(stat64Arr, cbuf, 0);
	

	return ret;


}



JNIEXPORT jlong JNICALL Java_jnios_posix_fstat64(JNIEnv *env, jclass, jlong fd, jlongArray stat64Arr)
{
	//stat64\̂̐錾͈ȉ̒ʂ.̏Ԃjlong[]ɑ.
	//AACygwin̏ꍇfstat֐ĂяoA݂p[^̂jlong[]ɑ.

	/*

	http://hira.main.jp/wiki/pukiwiki.php?stat64%2Flinux2.6 
	struct stat64 {

		unsigned long long	st_dev;
		unsigned char	__pad0[4];
		t@CfoCXID
		#define STAT64_HAS_BROKEN_ST_INO 1

		unsigned long	__st_ino;
		unsigned int	st_mode;
		ANZXی
		unsigned int	st_nlink;
		n[hN̐
		unsigned long	st_uid;
		L҂̃[UID
		unsigned long	st_gid;
		L҂̃O[vID
		unsigned long long	st_rdev;
		unsigned char	__pad3[4];
		foCXID (t@C̏ꍇ)
		long long	st_size;
		Ŝ̃TCY (oCgP)
		unsigned long	st_blksize;
		t@CVXe I/O ł̃ubNTCY
		unsigned long	st_blocks;	// Number 512-byte blocks allocated. 
		unsigned long	__pad4;		// future possible st_blocks high bits 
		蓖ĂꂽubN
		unsigned long	st_atime;
		ŏIANZX
		unsigned long	st_atime_nsec;
		ŏIANZXiimbj
		unsigned long	st_mtime;
		ŏIC
		unsigned int	st_mtime_nsec;
		ŏICiimbj
		unsigned long	st_ctime;
		ŏIԕύX
		unsigned long	st_ctime_nsec;
		ŏIԕύXiimbj
		unsigned long long	st_ino;
		inodeԍ
	};
	*/

	int	stat64Arr_size = 20;

	jlong* cbuf = env->GetLongArrayElements(stat64Arr, NULL);

	memset( cbuf, 0x00, stat64Arr_size * sizeof(jlong) );


	#ifdef Linux
		struct stat64 st_stat;

	int ret = fstat64( fd, &st_stat );

	#endif
	#ifdef Cygwin
		struct stat st_stat;
		int ret = fstat( fd, &st_stat );
	#endif Cygwin


	cbuf[0] = st_stat.st_dev;

	cbuf[3] = st_stat.st_mode;

	nkprintf("native code : fstat64() st_mode = %d", st_stat.st_mode );

	cbuf[4] = st_stat.st_nlink;
	cbuf[5] = st_stat.st_uid;
	cbuf[6] = st_stat.st_gid;
	cbuf[7] = st_stat.st_rdev;

	cbuf[9] = st_stat.st_size;
	cbuf[10] = st_stat.st_blksize;
	cbuf[11] = st_stat.st_blocks;

	cbuf[13] = st_stat.st_atime;

	cbuf[15] = st_stat.st_mtime;

	cbuf[17] = st_stat.st_ctime;

	cbuf[19] = st_stat.st_ino;

	#ifdef Linux
	//cbuf[1] = *( (int *)st_stat.pad0 );
	//cbuf[8] = *( (int*)(st_stat.__pad3) );
	//cbuf[12] = *( (int *)(st_stat.__pad4) );

	cbuf[2] = st_stat.__st_ino;


	//cbuf[14] = st_stat.st_atime_nsec;
	//cbuf[16] = st_stat.st_mtime_nsec;
	//cbuf[18] = st_stat.st_ctime_nsec;

	#endif

	env->ReleaseLongArrayElements(stat64Arr, cbuf, 0);
	

	return ret;
}



JNIEXPORT jlong JNICALL Java_jnios_posix_lstat64(JNIEnv *env, jclass, jstring fileNameString, jlongArray stat64Arr)
{
	
	// 09/01/09 .
	//stat64\̂̃o蓖ĂɂẮAqfstat64()Q

	int	stat64Arr_size = 20;

	jboolean isCopy;

	const char *utf_fileName = env->GetStringUTFChars(fileNameString, &isCopy);

	jlong* cbuf = env->GetLongArrayElements(stat64Arr, NULL);

	memset( cbuf, 0x00, stat64Arr_size );


	#ifdef Linux
		struct stat64 st_stat;

		int ret = lstat64( utf_fileName, &st_stat );
	#endif

	#ifdef Cygwin
		struct stat st_stat;
		int ret = lstat( utf_fileName, &st_stat );
	#endif //Cygwin

	env->ReleaseStringUTFChars( fileNameString, utf_fileName );


	cbuf[0] = st_stat.st_dev;

	cbuf[3] = st_stat.st_mode;
	cbuf[4] = st_stat.st_nlink;
	cbuf[5] = st_stat.st_uid;
	cbuf[6] = st_stat.st_gid;
	cbuf[7] = st_stat.st_rdev;

	cbuf[9] = st_stat.st_size;
	cbuf[10] = st_stat.st_blksize;
	cbuf[11] = st_stat.st_blocks;

	cbuf[13] = st_stat.st_atime;

	cbuf[15] = st_stat.st_mtime;

	cbuf[17] = st_stat.st_ctime;

	cbuf[19] = st_stat.st_ino;


	#ifdef Linux
	
	//cbuf[1] = *( (int *)st_stat.__pad0 ); // not use these members Caused by GCC Error
	//cbuf[8] = *( (int*)(st_stat.__pad3) );
	//cbuf[12] = *( (int *)(st_stat.__pad4) );

	cbuf[2] = st_stat.__st_ino;


	//cbuf[14] = st_stat.st_atime_nsec;
	//cbuf[16] = st_stat.st_mtime_nsec;
	//cbuf[18] = st_stat.st_ctime_nsec;

	#endif

	env->ReleaseLongArrayElements(stat64Arr, cbuf, 0);
	
	return ret;
}
















JNIEXPORT jlong JNICALL _PACKAGE(getIoctlConstValue)(JNIEnv *env, jclass jcls, jstring constValueName)
{
	//Ǝ֐.FIONREADȂǂ̒萔lԂ.
	//萔l݂Ȃꍇ́AԂ

	const char* utf_valueName;
	jboolean isCopy;

	jlong value = -1;

	utf_valueName = env->GetStringUTFChars( constValueName, &isCopy);


	if ( strcmp( utf_valueName, "FIONREAD") == 0)
	{
		value = FIONREAD;
	}



	env->ReleaseStringUTFChars(constValueName, utf_valueName);


	return value;
}





JNIEXPORT jlong JNICALL Java_jnios_posix_ioctl(JNIEnv *env, jclass, jlong fd, jlong cmd, jbyteArray jargp)
{
	
	jbyte* argp = env->GetByteArrayElements(jargp, NULL);

	jlong ret = ioctl( fd, cmd, argp);

	env->ReleaseByteArrayElements(jargp, argp, 0);

	return ret;
}



JNIEXPORT jlong JNICALL Java_jnios_posix_fcntl64(JNIEnv *env, jclass jclass, jlong fd, jlong cmd, jlongArray flock_jArr)
{
	//fcntl()Ăяo߂̂.
	
	//flock_jArrɂ,5vf܂łstruct flock\̂̊ep[^,6vfɂ͂̍\̂gpꍇ͕Agpꍇɂ͐.
	//flock_jArȓ7vfɂargsgpꍇɂ͂̒l.

	jint	ret = 0;
	jlong* flock_arr = env->GetLongArrayElements(flock_jArr, NULL);

	if ( flock_arr[5] > 0)
	{
		//3argsł.
		long arg = flock_arr[6];
		ret = fcntl( fd, cmd, arg);
	}

	else
	{
		//3struct flock\̂ւ̃|C^ł.


		//struct flock {
    		//...
    		//short l_type;    /* Type of lock: F_RDLCK,
                //        F_WRLCK, F_UNLCK */
    		//short l_whence;  /* How to interpret l_start:
                //        SEEK_SET, SEEK_CUR, SEEK_END */
    		//off_t l_start;   /* Starting offset for lock */
    		//off_t l_len;     /* Number of bytes to lock */
    		//pid_t l_pid;     /* PID of process blocking our lock
                //        (F_GETLK only) */
    		//...
		//};

		struct flock flk;

		flk.l_type	= flock_arr[0];
		flk.l_whence	= flock_arr[1];
		flk.l_start	= flock_arr[2];
		flk.l_len	= flock_arr[3];
		flk.l_pid	= flock_arr[4];

		ret = fcntl( fd, cmd, &flk);

		flock_arr[0] = flk.l_type;
		flock_arr[1] = flk.l_whence;
		flock_arr[2] = flk.l_start;
		flock_arr[3] = flk.l_len;
		flock_arr[4] = flk.l_pid;

	}


	env->ReleaseLongArrayElements(flock_jArr, flock_arr, 0);

	return ret;
}



















JNIEXPORT jlong JNICALL Java_jnios_posix_gettimeofday(JNIEnv *env, jclass, jlongArray tv_jlarr, jlongArray tz_jlarr)
{

	struct timeval	tv, *ptv;
	struct timezone tz, *ptz;

	jboolean tv_isCopy, tz_isCopy;

	tv_isCopy = tz_isCopy = false;

	ptv = &tv;
	ptz = &tz;

	//nkprintf("native gettimeofday() called\n");


	jlong* tv_arr = NULL;
	if ( env->NewLocalRef( tv_jlarr ) != NULL)
	{	//NULL`FbN
		tv_arr = env->GetLongArrayElements(tv_jlarr, &tv_isCopy);
	}


	// Ή\̂NULL̏ꍇ͂̂܂APIɓn.
	if ( tv_isCopy == false)
	{
		ptv = NULL;
	}
	else
	{
		tv.tv_sec = tv_arr[0];
		tv.tv_usec = tv_arr[1];
	}

	//nkprintf("native gettimeofday() ptv = %p\n", ptv);


	jlong* tz_arr = NULL;
	if ( env->NewLocalRef( tz_jlarr ) != NULL)
	{	//NULL`FbN
		tz_arr = env->GetLongArrayElements(tz_jlarr, &tz_isCopy);
	}

	if ( tz_isCopy == false)
	{
		ptz = NULL;
	}
	else
	{
		tz.tz_minuteswest	= tz_arr[0];
		tz.tz_dsttime		= tz_arr[1];
	}

	//nkprintf("native gettimeofday() ptv = %p , ptz = %p\n", ptv, ptz);

	jlong ret = gettimeofday(ptv, ptz);
	

	// 擾lɔzɐݒBANULL̏ꍇ̓Rs[Ȃ.
	if ( ptv != NULL)
	{
		tv_arr[0] = tv.tv_sec;
		tv_arr[1] = tv.tv_usec;

		unsigned int tv_sec = tv_arr[0];
		unsigned int tv_usec = tv_arr[1];
		nkprintf("nativeDLL gettimeofday() tv_arr[0] = %u, tv_arr[1] = %u\n", (unsigned int)tv_sec, (unsigned int)tv_usec );

		env->ReleaseLongArrayElements( tv_jlarr, tv_arr, 0);
	}
	if ( ptz != NULL)
	{
		tz_arr[0] = tz.tz_minuteswest;
		tz_arr[1] = tz.tz_dsttime;

		env->ReleaseLongArrayElements( tz_jlarr, tz_arr, 0);
	}

	
	
	return ret;
}

JNIEXPORT jlong JNICALL Java_jnios_posix_settimeofday(JNIEnv *env, jclass, jlongArray tv_jlarr, jlongArray tz_jlarr)
{

	struct timeval	tv, *ptv;
	struct timezone tz, *ptz;

	jboolean tv_isCopy, tz_isCopy;

	tv_isCopy = tz_isCopy = false;

	ptv = &tv;
	ptz = &tz;



	jlong* tv_arr = NULL;
	if ( env->NewLocalRef( tv_jlarr ) != NULL)
	{	//NULL`FbN
		tv_arr = env->GetLongArrayElements(tv_jlarr, &tv_isCopy);
	}


	// Ή\̂NULL̏ꍇ͂̂܂APIɓn.
	if ( tv_isCopy == false)
	{
		ptv = NULL;
	}
	else
	{
		tv.tv_sec = tv_arr[0];
		tv.tv_usec = tv_arr[1];
	}



	jlong* tz_arr = NULL;
	if ( env->NewLocalRef( tz_jlarr ) != NULL)
	{	//NULL`FbN
		tz_arr = env->GetLongArrayElements(tz_jlarr, &tz_isCopy);
	}

	if ( tz_isCopy == false)
	{
		ptz = NULL;
	}
	else
	{
		tz.tz_minuteswest	= tz_arr[0];
		tz.tz_dsttime		= tz_arr[1];
	}


	jlong ret = settimeofday(ptv, ptz);
	

	// 擾lɔzɐݒBANULL̏ꍇ̓Rs[Ȃ.
	if ( ptv != NULL)
	{
		tv_arr[0] = tv.tv_sec;
		tv_arr[1] = tv.tv_usec;

		env->ReleaseLongArrayElements( tv_jlarr, tv_arr, 0);
	}
	if ( ptz != NULL)
	{
		tz_arr[0] = tz.tz_minuteswest;
		tz_arr[1] = tz.tz_dsttime;

		env->ReleaseLongArrayElements( tz_jlarr, tz_arr, 0);
	}

	
	return ret;
}




int jlongTo_fd_set(jlong* jfd_set, fd_set* pfd_set)
{
	//jlong[] fd_set\̂ɕϊ.

	//jlong[]z1ɂfds_bits1rbg.
	//āAjfd_set1024vf̔zł.

	int ret = 0;

	if ( jfd_set == NULL)
	{
		return -1;
	}

	memset( pfd_set, 0x00, sizeof( fd_set ) );

	for( int i=0; i < 1024 / 32; i++)
	{
		for( int k=0; k < 32; k++)
		{
			jlong bit_value = jfd_set[ i*32 + k ];
			pfd_set->fds_bits[i] += (  bit_value << ( 31 - (31 - k ) ) );

			if ( bit_value != 0 )
			{
				ret++;
			}
		}

		//pfd_set->fds_bits[i] = ntohl( pfd_set->fds_bits[i] );

	}

	return ret;
}

int fd_setTojlong( jlong* jfd_set, fd_set* pfd_set)
{

	nkprintf("JNI DLL side. posix.cpp fd_setTojlong() called\n" );

	int ret = 0;

	if ( jfd_set == NULL)
	{

		nkprintf("JNI DLL side. posix.cpp fd_setTojlong() fault1\n" );
		
		return -1;
	}

	if ( pfd_set == NULL)
	{
		return -2;
	}


	memset( jfd_set, 0x00, 1024 * sizeof(jlong) );


	for( int i=0; i < 1024 / 32; i++)
	{

		unsigned long val32 = pfd_set->fds_bits[i];


		if ( val32 != 0 )
		{
			nkprintf("JNI DLL side. posix.cpp fd_setTojlong() val32=0x%x\n", val32 );
		}


		for( int k=0; k < 32; k++)
		{
			unsigned long bit_value = ( val32 >> (31 - ( 31 - k ) ) ) & 0x00000001;
			jfd_set[ i*32 + k ] = (unsigned long long )bit_value;
			
			if ( bit_value != 0 )
			{
				ret++;
			}
		}
	}

	nkprintf("JNI DLL side. posix.cpp fd_setTojlong() ret=%d\n", ret );


	return ret;
}




JNIEXPORT jlong JNICALL Java_jnios_posix_select(JNIEnv *env, jclass cls, jlong nfds, jlongArray jreadfds, jlongArray jwritefds, jlongArray jexceptfds, jlongArray jtimeout)
{

	//int select(int nfds, fd_set *readfds, fd_set *writefds, fd_set *exceptfds, struct timeval *timeout);




	//http://labs.gmo.jp/blog/ku/2007/06/select.html 
	//fds_bits̔z񂪑S1024rbgɂȂ悤ɔz̃TCY肳Ă܂

	//#define __NFDBITS   (8 * sizeof (__fd_mask))
	//#define __FD_SETSIZE    1024

	//typedef struct
	//{
    	//	__fd_mask fds_bits[__FD_SETSIZE / __NFDBITS];
	//} fd_set;

	//܂Ahttp://www.cs.ualberta.ca/~paullu/wgetlxr/http/ident?i=__fd_mask@
	//  The fd_set member is required to be an array of longs.
	//  typedef long int __fd_mask;

	//,fds_bits̗vf1024 / 32 ł.


	nkprintf("JNI DLL side. posix.cpp jnios_select() called\n" );


	jlong *pjreadfds, *pjwritefds, *pjexceptfds, *pjtimeout;

	pjreadfds = pjwritefds = pjexceptfds = pjtimeout = NULL;


	if ( env->NewLocalRef( jreadfds ) != NULL)
	{
		pjreadfds	= env->GetLongArrayElements( jreadfds, NULL);
	}
	
	if ( env->NewLocalRef( jwritefds ) != NULL)
	{
		pjwritefds	= env->GetLongArrayElements( jwritefds, NULL);
	}

	if ( env->NewLocalRef( jexceptfds ) != NULL)
	{
		pjexceptfds	= env->GetLongArrayElements( jexceptfds, NULL);
	}



	if ( env->NewLocalRef( jtimeout ) != NULL)
	{
		pjtimeout	= env->GetLongArrayElements( jtimeout, NULL);
	}


	fd_set	readfds, writefds, exceptfds;
	fd_set *p_readfds, *p_writefds, *p_exceptfds;
	p_readfds = p_writefds = p_exceptfds = NULL;

	if ( jlongTo_fd_set( pjreadfds, &readfds ) >= 0)
	{

		nkprintf("JNI DLL side. posix.cpp jnios_select() before native_select() readfds.fds_bits[0]=0x%x\n", readfds.fds_bits[0] );

		p_readfds = &readfds;
	}

	if ( jlongTo_fd_set( pjwritefds, &writefds ) >= 0)
	{
		nkprintf("JNI DLL side. posix.cpp jnios_select() before native_select() writefds.fds_bits[0]=0x%x\n", writefds.fds_bits[0] );

		p_writefds = &writefds;
	}

	if ( jlongTo_fd_set( pjexceptfds, &exceptfds ) >= 0)
	{
		nkprintf("JNI DLL side. posix.cpp jnios_select() before native_select() exceptfds.fds_bits[0]=0x%x\n", exceptfds.fds_bits[0] );

		p_exceptfds = &exceptfds;
	}



	struct timeval	timeout, *p_timeout;
	p_timeout = NULL;

	if ( pjtimeout != NULL)
	{
		timeout.tv_sec	= pjtimeout[0];
		timeout.tv_usec = pjtimeout[1];
		p_timeout = &timeout;


		nkprintf("JNI DLL side. posix.cpp jnios_select() timeout.tv_sec=%u, timeout.tv_usec=%u\n", timeout.tv_sec, timeout.tv_usec );

	}


	nkprintf("JNI DLL side. posix.cpp native select() nfds=%d, p_readfds=%p, p_writefds=%p, p_exceptfds=%p, p_timeout=%p\n",
										nfds, p_readfds, p_writefds, p_exceptfds, p_timeout );

	//nkprintf("JNI DLL side. posix.cpp native select() call\n" );

	jlong ret = select( nfds, p_readfds, p_writefds, p_exceptfds, p_timeout);

	nkprintf("JNI DLL side. posix.cpp native select() returned.ret=%d, errno=%d\n", (int)ret, errno);


	if ( fd_setTojlong( pjreadfds, p_readfds ) >= 0)
	{

		nkprintf("JNI DLL side. posix.cpp after native_select() readfds[0]=%x\n", p_readfds->fds_bits[0]);
		nkprintf("JNI DLL side. posix.cpp after native_select() readfds setBits = %d\n", fd_setTojlong( pjreadfds, p_readfds ) );

		env->ReleaseLongArrayElements( jreadfds, pjreadfds, 0);
	}

	if ( fd_setTojlong( pjwritefds, p_writefds ) >= 0)
	{

		nkprintf("JNI DLL side. posix.cpp after native_select() writefds setBits = %d\n", fd_setTojlong( pjwritefds, p_writefds ) );

		env->ReleaseLongArrayElements( jwritefds, pjwritefds, 0);
	}

	if ( fd_setTojlong( pjexceptfds, p_exceptfds ) >= 0)
	{

		nkprintf("JNI DLL side. posix.cpp after native_select() exceptfds setBits = %d\n", fd_setTojlong( pjexceptfds, p_exceptfds ) );

		env->ReleaseLongArrayElements( jexceptfds, pjexceptfds, 0);
	}

	if ( pjtimeout != NULL)
	{
		pjtimeout[0] = timeout.tv_sec;
		pjtimeout[1] = timeout.tv_usec;

		env->ReleaseLongArrayElements( jtimeout, pjtimeout, 0);
	}


	nkprintf("JNI DLL side. posix.cpp jnios_select() returne.ret=%d\n", (int)ret);


	return ret;

}



JNIEXPORT jlong JNICALL _PACKAGE(getSignalConstValue)(JNIEnv *env, jclass jcls, jstring constValueName)
{
	//Ǝ֐.SIG_BLOCKȂǂ̒萔lԂ.
	//萔l݂Ȃꍇ́AԂ

	const char* utf_valueName;
	jboolean isCopy;

	jlong value = -1;

	utf_valueName = env->GetStringUTFChars( constValueName, &isCopy);

	if ( strcmp( utf_valueName, "SIG_BLOCK") == 0)
	{
		value = SIG_BLOCK;
	}
	else if ( strcmp( utf_valueName, "SIG_UNBLOCK") == 0)
	{
		value = SIG_UNBLOCK;
	}
	else if ( strcmp( utf_valueName, "SIG_SETMASK") == 0)
	{
		value = SIG_SETMASK;
	}


	// ȉVOiԍ.
	else if ( strcmp(utf_valueName, "SIGHUP" ) == 0)
	{
		value = SIGHUP;
	}
	else if ( strcmp(utf_valueName, "SIGINT" ) == 0)
	{
		value = SIGINT;
	}
	else if ( strcmp(utf_valueName, "SIGQUIT" ) == 0)
	{
		value = SIGQUIT;
	}
	else if ( strcmp(utf_valueName, "SIGILL" ) == 0)
	{
		value = SIGILL;
	}
	else if ( strcmp(utf_valueName, "SIGTRAP" ) == 0)
	{
		value = SIGTRAP;
	}
	else if ( strcmp(utf_valueName, "SIGABRT" ) == 0)
	{
		value = SIGABRT;
	}
	else if ( strcmp(utf_valueName, "SIGEMT" ) == 0)
	{
		#if !defined(Linux)
		value = SIGEMT;
		#endif
	}
	else if ( strcmp(utf_valueName, "SIGFPE" ) == 0)
	{
		value = SIGFPE;
	}
	else if ( strcmp(utf_valueName, "SIGBUS" ) == 0)
	{
		value = SIGBUS;
	}
	else if ( strcmp(utf_valueName, "SIGSEGV" ) == 0)
	{
		value = SIGSEGV;
	}
	else if ( strcmp(utf_valueName, "SIGSYS" ) == 0)
	{
		value = SIGSYS;
	}
	else if ( strcmp(utf_valueName, "SIGPIPE" ) == 0)
	{
		value = SIGPIPE;
	}
	else if ( strcmp(utf_valueName, "SIGALRM" ) == 0)
	{
		value = SIGALRM;
	}
	else if ( strcmp(utf_valueName, "SIGTERM" ) == 0)
	{
		value = SIGTERM;
	}
	else if ( strcmp(utf_valueName, "SIGPOLL" ) == 0)
	{
		value = SIGTERM;
	}
	else if ( strcmp(utf_valueName, "SIGSTOP" ) == 0)
	{
		value = SIGSTOP;
	}
	else if ( strcmp(utf_valueName, "SIGTSTP" ) == 0)
	{
		value = SIGTSTP;
	}
	else if ( strcmp(utf_valueName, "SIGTSTP" ) == 0)
	{
		value = SIGTSTP;
	}
	else if ( strcmp(utf_valueName, "SIGTTIN" ) == 0)
	{
		value = SIGTTIN;
	}
	else if ( strcmp(utf_valueName, "SIGTTOU" ) == 0)
	{
		value = SIGTTOU;
	}
	else if ( strcmp(utf_valueName, "SIGVTALRM" ) == 0)
	{
		value = SIGVTALRM;
	}
	else if ( strcmp(utf_valueName, "SIGPROF" ) == 0)
	{
		value = SIGPROF;
	}
	else if ( strcmp(utf_valueName, "SIGXCPU" ) == 0)
	{
		value = SIGXCPU;
	}
	else if ( strcmp(utf_valueName, "SIGXFSZ" ) == 0)
	{
		value = SIGXFSZ;
	}

	// ȉ sa_flags̓eɊւ.
	else if ( strcmp(utf_valueName, "SA_NOCLDSTOP" ) == 0)
	{
		value = SA_NOCLDSTOP;
	}
	else if ( strcmp(utf_valueName, "SA_NOCLDWAIT" ) == 0)
	{
		#if !defined(Cygwin)
		value = SA_NOCLDWAIT;
		#endif
	}
	else if ( strcmp(utf_valueName, "SA_NODEFER" ) == 0)
	{
		value = SA_NODEFER;
	}
	else if ( strcmp(utf_valueName, "SA_RESETHAND" ) == 0)
	{
		value = SA_RESETHAND;
	}
	else if ( strcmp(utf_valueName, "SA_RESTART" ) == 0)
	{
		value = SA_RESTART;
	}

	else if ( strcmp(utf_valueName, "SA_SIGINFO" ) == 0)
	{
		#if !defined(Cygwin)
		value = SA_SIGINFO;
		#endif
	}




	env->ReleaseStringUTFChars(constValueName, utf_valueName);


	return value;
}



void changeBytesEndian( unsigned char* bytes_arr, int size)
{
	// ̃GfBAɊ֌WȂAbyte_arr̃GfBAϊ.

	//gGfBA.
	unsigned char tmp_byte = 0x00;
	for( int i=0; i < size / 2; i++)
	{
		tmp_byte = bytes_arr[i];
		bytes_arr[i] = bytes_arr[ size - i - 1];
		bytes_arr[ size - i - 1] = tmp_byte;

		tmp_byte = 0;
	}

	return ;
}



int sigset_t_ToLongArr(jlong *long_arr, int arr_length, sigset_t* sigset)
{
	// sigset_tlong^zɕϊ.
	// long^z̃TCY͎Oɒm炳̂Ƃ.

	//߂l͊̃VOiXgɊi[ꂽ.

	int signal_size = 64;	//A[LeN`ɂĈقȂ.


	int list_elems = 0;
	for( int i=0; i < signal_size; i++)
	{
		if ( sigismember( sigset, i ) == 1)
		{
			if ( list_elems < arr_length )
			{
				long_arr[ list_elems ] = i;
				list_elems++;
			}
		}
	}



	return list_elems;
}



int longArrTo_sigset_t(jlong *long_arr, int arr_length, sigset_t* sigset)
{
	//bool^z1vfi[ꂽVOĩrbgtO sigset_t\̂ɕϊ.

	//arr_lengthbool_arr̒Asigset͊mۍς݂sigset_t\̂̃ւ̃|C^.

	// bool_arr͗LȃVOĩrbg}XNł.index=0\̍őO(AhX)ł.

	// arr_lengthsizeof(sigset_t) * 8 傫ꍇbool_arr̍Ōsigset_t̍Ōɍ悤ɒ.
	// ܂AgGfBȀꍇÃ\bhŃGfBAϊs.


	//	typedef struct
	//	{
	//		unsigned long sig[_NSIG_WORDS];
	//			VOĩ}XNێrbg}bv 
	//			`\ȃVOi64Ȃ̂long x 2̃TCY΂悢
	//			_NSIG_WORDS(_NSIG / _NSIG_BPW)ƒ`B܂2łB 
	//			_NSIG64ƒ` 
	//			_NSIG͒`\ȃVOi̐Ӗ
	//			_NSIG_BPW32ƒ` 
	//			_NSIG_BPW1[hɓĂbit̐
	//	} sigset_t;



	sigemptyset(sigset);

	for( int i=0; i < arr_length; i++)
	{
		int signum = long_arr[i];

		sigaddset( sigset, signum );
		

		//nkprintf("posix.cpp longArrTo_sigset_t() signum=%d\n", signum );

	}



	return 0;
}


#if defined(Cygwin)
//Cygwinsigwait()G~[V邽߂̃\bh.
//sigaction()ŌĂяonhƂċ@\.





struct sigwait_emulation_t
{

	// Z}tH̎g
	// http://www.syuhitu.org/other/mth/mht.html

	int exit_flag;

	int signum;

	sigset_t mask;

	sigset_t old_blocking_mask, old_unblocking_mask, change_blocking_mask;

	pthread_t threadID;

};

vector<struct sigwait_emulation_t*> sigwait_emulation_v;


void sigwaitHandler(int no )
{
	(void)no;

	sigwait_emulation_t *p_sigwait_emu;


	nkprintf("posix.cpp sigwaitHandler() called\n");

	for( int i=0; i < sigwait_emulation_v.size(); i++)
	{

		p_sigwait_emu = sigwait_emulation_v.at(i);

		if ( p_sigwait_emu->threadID == pthread_self() &&
			sigismember( &p_sigwait_emu->mask, no ) == 1)
		{
			break;
		}
	}

	p_sigwait_emu->signum = no;


	p_sigwait_emu->exit_flag = 1;






	return ;
}

#endif


//#if !defined(Cygwin)

//sigsuspend()sigpause()őւł̂ł͂Ȃ.sigwait()ɂ͑̃VOiAPIɑ΂D揇ʂubNȂǂ̋@\.
JNIEXPORT jlong JNICALL Java_jnios_posix_sigwait(JNIEnv *env, jclass cls, jlongArray jsigset_t, jlongArray jptr_sig)
{


	// jsigset_t̓}XNׂVOïꗗzł.
	// jptr_sig͊̃VOiLɂȂԂ߂ɂ,vf1long^z̃CX^Xn.
	// jsigset_t̓rbOGfBAł̃rbg̕тƂ.(lCeBug̏ꍇ,posix.cppŃGfBAϊs)

	// @sigwaint()Cygwin 1.5.6-1Õo[Wł͖炵....
	// http://slashdot.jp/~snowy/journal/198964

	// ,Cygwin1.5.5܂łJNIł͎gps.1.5.6ȍ~JavaVMnO.]āAGaVXes̎GɎ^Ă1.5.5-1fullłgp邱.
	// sigwait()1.5.5ł͖Ȃ̂cygwinłsigpause()őւ.



	jlong ret = 0;
	int sig = 0;

	jlong* clong_arr = env->GetLongArrayElements( jsigset_t, NULL );

	int clong_arr_size = env->GetArrayLength( jsigset_t );

	jlong*	cptr_sig = env->GetLongArrayElements( jptr_sig, NULL );


	sigset_t sigset;
	longArrTo_sigset_t( clong_arr, clong_arr_size, &sigset );


	
	#if !defined(Cygwin)
		ret = sigwait( &sigset, &sig );
	#else
		
		struct sigwait_emulation_t *p_sigwait_emu = (struct sigwait_emulation_t*)malloc(sizeof(struct sigwait_emulation_t) );

		sigwait_emulation_v.push_back( p_sigwait_emu );

		p_sigwait_emu->threadID = pthread_self();
		

		p_sigwait_emu->exit_flag = -1;

		sigprocmask( SIG_BLOCK, NULL, &p_sigwait_emu->old_blocking_mask );
		sigprocmask( SIG_UNBLOCK, NULL, &p_sigwait_emu->old_unblocking_mask );
		sigemptyset( &p_sigwait_emu->change_blocking_mask );

		for( int i=0; i < clong_arr_size; i++)
		{
			if ( sigismember( &p_sigwait_emu->old_blocking_mask, clong_arr[i] ) == 1)
			{
				//ubLOԂɃ}XNĂVOi.
				//UubLOĂAēxubLOԂɎw肷.
				sigaddset( &p_sigwait_emu->change_blocking_mask, clong_arr[i] );
			}
		}
		sigprocmask( SIG_UNBLOCK, &p_sigwait_emu->change_blocking_mask, NULL );





		struct sigaction	act;
		longArrTo_sigset_t( clong_arr, clong_arr_size, &act.sa_mask );
		act.sa_handler = sigwaitHandler;
		//act.sa_flags = SA_SIGINFO;

		p_sigwait_emu->mask	= act.sa_mask;


		


		for( int i=0; i < clong_arr_size; i++)
		{
		
			sigaction( clong_arr[i], &act, NULL );
		}
			


		
		while( 1 )
		{
			//sleep(1);
			pause();
			if ( p_sigwait_emu->exit_flag > 0)
			{
				break;
			}
		}
		


		sig = p_sigwait_emu->signum;



		for( int i=0; i < sigwait_emulation_v.size(); i++)
		{
			struct sigwait_emulation_t* p = sigwait_emulation_v.at(i);

			if ( p->threadID == pthread_self() && p->mask == act.sa_mask)
			{
				vector<struct sigwait_emulation_t*>::iterator itr = sigwait_emulation_v.begin();
				itr+=i;
				sigwait_emulation_v.erase(itr);

				break;
			}
		}




		sigprocmask( SIG_BLOCK, &p_sigwait_emu->change_blocking_mask, NULL );
		//ubLOԂɂVOi}XNɖ߂.


		free( p_sigwait_emu );
		


		//cygwinłsigwait()Ȃ.

		ret = 0;

	#endif

	cptr_sig[0] = sig;
	

	nkprintf("posix.cpp sigwait() ret=%d sig=%d\n", (int)ret, (int)sig );


	nkprintf("posix.cpp sigwait() ReleaseBooleanArrayElements call\n");

	env->ReleaseLongArrayElements( jsigset_t, clong_arr, 0 );

	env->ReleaseLongArrayElements( jptr_sig, cptr_sig, 0 );


	nkprintf("posix.cpp sigwait() return\n");

	return ret;

	
}

//#endif


JNIEXPORT jlong JNICALL Java_jnios_posix_sigsuspend(JNIEnv *env, jclass cls, jlongArray jsigset_t )
{

	sigset_t sigset;

	jlong* clong_arr = env->GetLongArrayElements( jsigset_t, NULL );

	int clong_arr_size = env->GetArrayLength( jsigset_t );
	longArrTo_sigset_t( clong_arr, clong_arr_size, &sigset );

	long ret = sigsuspend( &sigset );

	env->ReleaseLongArrayElements( jsigset_t, clong_arr, 0 );

	return ret;

}


JNIEXPORT jlong JNICALL Java_jnios_posix_sigpause(JNIEnv *env, jclass cls, jlongArray jsigset_t )
{

	sigset_t sigset;

	jlong* clong_arr = env->GetLongArrayElements( jsigset_t, NULL );
	int clong_arr_size = env->GetArrayLength( jsigset_t );

	longArrTo_sigset_t( clong_arr, clong_arr_size, &sigset );


	int sig = ( (int*)(&sigset) )[0];	//sigset_t\̂̐擪vfgp.

	jlong ret = sigpause( sig );


	env->ReleaseLongArrayElements( jsigset_t, clong_arr,  0);

	return ret;


}

JNIEXPORT jlong JNICALL Java_jnios_posix_sigprocmaskNative(JNIEnv *env, jclass cls, jlong how, jlongArray mask, jobjectArray ptr_old_mask)
{


	jlong*	cmask_arr	= env->GetLongArrayElements( mask, NULL);
	int		cmask_size	= env->GetArrayLength( mask );

	sigset_t mask_t, old_mask_t;

	longArrTo_sigset_t( cmask_arr, cmask_size, &mask_t );


	jlong ret = sigprocmask( how, &mask_t, &old_mask_t);


	env->ReleaseLongArrayElements( mask, cmask_arr, 0);

	jlong tmp_mask_arr[1024];
	int old_mask_size = sigset_t_ToLongArr( tmp_mask_arr, 1024, &old_mask_t );
	
	jlongArray old_mask	= 	env->NewLongArray( old_mask_size );
	jlong* cold_mask_arr	=	env->GetLongArrayElements( old_mask, NULL );

	memcpy( cold_mask_arr, tmp_mask_arr, sizeof(jlong) * old_mask_size );

	env->ReleaseLongArrayElements( old_mask, cold_mask_arr, 0);

	env->SetObjectArrayElement( ptr_old_mask, 0, old_mask ); 
	


	return ret;
}



/*
void signal_handler( int no ) {
    ( void )no;

	nkprintf("Hi! this is signal_handler\n");

    char *mes1 = "signal_handler start!!\n";
    char *mes2 = "signal_handler end...\n";
    write( 1, mes1, strlen( mes1 ));
    sleep( 5 );                  // Ԃ̂鏈
    write( 1, mes2, strlen( mes2 ));
}


JNIEXPORT jlong JNICALL Java_jnios_posix_sigaction(JNIEnv *env, jclass cls)
{


	nkprintf("posix.cpp sigaction() called\n");

	// sigaction()̃eXgp
    char buf[256];
    int ret;
    struct sigaction sa;

    sa.sa_handler = signal_handler;
    sa.sa_flags = SA_RESTART;
    sigemptyset( &sa.sa_mask );
    sigaddset( &sa.sa_mask, SIGTSTP );   // VOi}XN̐ݒ 
    sigaction( SIGINT, &sa, 0 );



//    while( 1 ) {
//        nkprintf( "read wait..\n" );
//        ret = read( 0, buf, sizeof( buf ));
//        write( 1, buf, ret );
//    }


    return 0;

}
*/







	








char nativeSignatureToArray( char* signature, char* paramArray, int* paramSize)
{
	//@Java\bh̃VOl`\񂩂,\bh̖߂lƈ̃^CvƂ̌Ԃ.
	//  ) (Ljava/lang/String;D)V @߂l:V paramArray[0]=L, paramArray[1]=D paramSize=2

	char str[1024], paramStrData[1024], typeStrData[1024];
	char* paramStr	= paramStrData;
	char* typeStr	= typeStrData;
	
	memset( paramStrData, '\0', 1024);
	memset( typeStrData, '\0', 1024);

	strcpy( str, signature );

	//strcpy( paramStr, str );
	strncpy( paramStr, str , strchr(str, ')') - str + sizeof(char));
	paramStr[ strchr(str, ')') - str + sizeof(char) ] = '\0';
	*paramSize = 0;

	paramStr += sizeof(char);
	while(paramStr[0] != ')' )
	{

		nkprintf("paramStr=%s, *paramSize=%d\n", paramStr, *paramSize );

		if ( paramStr[0] == 'L' )
		{
			paramArray[ *paramSize ] = 'L';
			paramStr =  strchr( paramStr, ';') + sizeof(char);
			*paramSize += 1;

			continue;
		}
		else if ( paramStr[0] == '[' )
		{
			paramArray[ *paramSize ] = '[';
			*paramSize += 1;

			paramStr += sizeof(char);
			while(1)
			{
				if ( paramStr[0] == 'L' )
				{
					paramStr = strchr( paramStr, ';' ) + sizeof(char);
					break;
				}
				else if ( paramStr[0] == '[' )
				{
					paramStr += sizeof(char);
					continue;
				}
				else
				{
					paramStr += sizeof(char);
					break;
				}
			}
		}
		else
		{
			paramArray[0] = paramStr[0];
			paramStr += sizeof(char);
			*paramSize += 1;
		}
	}


	paramArray[ *paramSize ] = '\0';

	strcpy( typeStr, strchr( str, ')') + sizeof(char) );
	

	return typeStr[0];
}
	


int getMethodNativeSignature(JNIEnv* env, jclass cls, jobject method, char* methodName, char* signature)
{
	// w肳ꂽ\bh̖OƃlCeBuŗp\L@̃VOl`Ԃ.

	// VOl`̈ꗗ http://java.sun.com/j2se/1.5.0/ja/docs/ja/guide/jni/spec/types.html#wp276
	// lCeBuɂVOl`\Ĺ@http://www.ne.jp/asahi/hishidama/home/tech/java/jni_code.html#\bh̃VOj`[


	//Ujnios̃\bhĂяoāAJavaVMŃVOl`肵ĕԂ.
	char* jnios_cls_name = "Ljnios/posix;";
	char* jnios_method_name = "getMethodNativeSignature";
	char* jnios_method_signature = "(Ljava/lang/reflect/Method;)Ljava/lang/String;";


	nkprintf("posix.cpp getMethodNativeSignature() called\n");


	jclass jnios_cls = env->FindClass( jnios_cls_name );
	
	nkprintf("posix.cpp getMethodNativeSignature() jnios_cls is %s\n", (jnios_cls==NULL) ? "NULL" : "not NULL" );


	jmethodID jnios_mid = env->GetStaticMethodID( jnios_cls, jnios_method_name, jnios_method_signature );

	nkprintf("posix.cpp getMethodNativeSignature() GetMethodID() returned. jnios_mid is %s\n", (jnios_mid==NULL) ? "NULL": "not NULL");

	jstring jstring_signature = (jstring)env->CallStaticObjectMethod( jnios_cls, jnios_mid, method );

	nkprintf("posix.cpp getMethodNativeSignature() callBack method returned\n");

	const char *char_signature = env->GetStringUTFChars(jstring_signature, NULL);
	strcpy( signature, char_signature );
	env->ReleaseStringUTFChars(jstring_signature, char_signature);
	//܂ŃVOl`̎擾.


	nkprintf("posix.cpp getMethodNativeSignature() signature=%s\n", signature);



	//烁\bh̎擾.
	char* method_cls_name		= "Ljava/lang/reflect/Method;";
	char* method_getName_name	= "getName";
	char* method_getName_signature  = "()Ljava/lang/String;";

	jclass		method_cls = env->FindClass( method_cls_name );
	jmethodID 	getName_mid= env->GetMethodID( method_cls, method_getName_name, method_getName_signature );

	jstring jstring_methodName = (jstring)env->CallObjectMethod( method, getName_mid );
	const char* char_methodName= env->GetStringUTFChars( jstring_methodName, NULL );
	strcpy( methodName, char_methodName );
	env->ReleaseStringUTFChars( jstring_methodName, char_methodName );
	// ܂Ń\bh̎擾.

	return 0;
}
	


int jobjectToPrimitiveJValue( JNIEnv* env, jobject jobj, jvalue* jval, char primitiveType)
{
	// JavãIuWFNgQƂjvalue^̋p̂ɕϊ.
	// AIuWFNgv~eBu^̊NX(Integer,LongȂ)̏ꍇő3ɕϊv~eBu^ȉ̕\Lœnꍇ
	// v~eBu^ɕϊŁAjvalue^Ɋi[
	// v~eBu^ւ̕ϊ]܂ȂꍇprimitiveTypeLn.

	// 2jval͊ɃɊmۂĂjvalue^̋p̂ւ̃|C^Ƃ.

	char* baseClassName;
	char* baseClassMethodName;
	char* baseClassMethodSignature;

	if ( primitiveType == 'L')
	{
		jval->l = jobj;
	}
	else if ( primitiveType == '[' )
	{
		jval->l = jobj;
	}
	else 
	{

		if ( primitiveType == 'Z')
		{	
			baseClassName			= "Ljava/lang/Boolean;";
			baseClassMethodName		= "booleanValue";
			baseClassMethodSignature	= "()Z";

			jclass		method_cls = env->FindClass( baseClassName );
			jmethodID 	mid= env->GetMethodID( method_cls, baseClassMethodName, baseClassMethodSignature );
			jval->z = env->CallBooleanMethod( jobj, mid );

		}
		else if ( primitiveType == 'B' )
		{
			baseClassName			= "Ljava/lang/Byte;";
			baseClassMethodName		= "byteValue";
			baseClassMethodSignature	= "()B";

			jclass		method_cls = env->FindClass( baseClassName );
			jmethodID 	mid= env->GetMethodID( method_cls, baseClassMethodName, baseClassMethodSignature );
			jval->b = env->CallByteMethod( jobj, mid );
		}
		else if ( primitiveType == 'C' )
		{
			baseClassName			= "Ljava/lang/Char;";
			baseClassMethodName		= "charValue";
			baseClassMethodSignature	= "()C";

			jclass		method_cls = env->FindClass( baseClassName );
			jmethodID 	mid= env->GetMethodID( method_cls, baseClassMethodName, baseClassMethodSignature );
			jval->c = env->CallCharMethod( jobj, mid );

		}
		else if ( primitiveType == 'S' )
		{
			baseClassName			= "Ljava/lang/Short;";
			baseClassMethodName		= "shortValue";
			baseClassMethodSignature	= "()S";

			jclass		method_cls = env->FindClass( baseClassName );
			jmethodID 	mid= env->GetMethodID( method_cls, baseClassMethodName, baseClassMethodSignature );
			jval->s = env->CallShortMethod( jobj, mid );


		}
		else if ( primitiveType == 'I' )
		{
			baseClassName			= "Ljava/lang/Integer;";
			baseClassMethodName		= "intValue";
			baseClassMethodSignature	= "()I";

			jclass		method_cls = env->FindClass( baseClassName );
			jmethodID 	mid= env->GetMethodID( method_cls, baseClassMethodName, baseClassMethodSignature );
			jval->i = env->CallIntMethod( jobj, mid );


		}
		else if ( primitiveType == 'J' )
		{
			baseClassName			= "Ljava/lang/Long;";
			baseClassMethodName		= "longValue";
			baseClassMethodSignature	= "()J";

			jclass		method_cls = env->FindClass( baseClassName );
			jmethodID 	mid= env->GetMethodID( method_cls, baseClassMethodName, baseClassMethodSignature );


			jval->j = env->CallLongMethod( jobj, mid );


		}
		else if ( primitiveType == 'F' )
		{
			baseClassName			= "Ljava/lang/Float;";
			baseClassMethodName		= "floatValue";
			baseClassMethodSignature	= "()F";

			jclass		method_cls = env->FindClass( baseClassName );
			jmethodID 	mid= env->GetMethodID( method_cls, baseClassMethodName, baseClassMethodSignature );
			jval->f = env->CallFloatMethod( jobj, mid );


		}
		else if ( primitiveType == 'D' )
		{
			baseClassName			= "Ljava/lang/Double;";
			baseClassMethodName		= "doubleValue";
			baseClassMethodSignature	= "()D";

			jclass		method_cls = env->FindClass( baseClassName );
			jmethodID 	mid= env->GetMethodID( method_cls, baseClassMethodName, baseClassMethodSignature );
			jval->d = env->CallDoubleMethod( jobj, mid );


		}

	}


		return 0;
}



jobject primitiveJValueToJObject( JNIEnv* env, jvalue jval, char primitiveType)
{
	// v~eBu^i[ꂽjvaluep̂,̒lNX̃CX^XVɐĕԂ.

	// 09/01/09 eNXvalueOf()\bhstatic\bhȂ̂ŁAenv->GetMethodID()ł͂ȂAenv->GetStaticMethodID()gp邱.
	// \bh̃VOl`𒲂ׂƂ, javap -s "NX" R}h֗B) javap -s java.lang.Long 

	jobject ret = NULL;
	char *baseClassName, *baseClassMethodName, *baseClassMethodSignature;

	
	if ( primitiveType == 'Z')
	{	
		baseClassName			= "Ljava/lang/Boolean;";
		baseClassMethodName		= "valueOf";
		baseClassMethodSignature	= "(Z)Ljava/lang/Boolean;";

		jclass		method_cls = env->FindClass( baseClassName );
		jmethodID 	mid= env->GetStaticMethodID( method_cls, baseClassMethodName, baseClassMethodSignature );
		ret = env->CallStaticObjectMethod( method_cls, mid, jval.z);

	}
	else if ( primitiveType == 'B')
	{	
		baseClassName			= "Ljava/lang/Byte;";
		baseClassMethodName		= "valueOf";
		baseClassMethodSignature	= "(B)Ljava/lang/Byte;";

		jclass		method_cls = env->FindClass( baseClassName );
		jmethodID 	mid= env->GetStaticMethodID( method_cls, baseClassMethodName, baseClassMethodSignature );
		ret = env->CallStaticObjectMethod( method_cls, mid, jval.b);

	}
	else if ( primitiveType == 'C')
	{	
		baseClassName			= "Ljava/lang/Char;";
		baseClassMethodName		= "valueOf";
		baseClassMethodSignature	= "(C)Ljava/lang/Char;";

		jclass		method_cls = env->FindClass( baseClassName );
		jmethodID 	mid= env->GetStaticMethodID( method_cls, baseClassMethodName, baseClassMethodSignature );
		ret = env->CallStaticObjectMethod( method_cls, mid, jval.c);

	}
	else if ( primitiveType == 'S')
	{	
		baseClassName			= "Ljava/lang/Short;";
		baseClassMethodName		= "valueOf";
		baseClassMethodSignature	= "(S)Ljava/lang/Char;";

		jclass		method_cls = env->FindClass( baseClassName );
		jmethodID 	mid= env->GetStaticMethodID( method_cls, baseClassMethodName, baseClassMethodSignature );
		ret = env->CallStaticObjectMethod( method_cls, mid, jval.s);
	}
	else if ( primitiveType == 'I')
	{	
		baseClassName			= "Ljava/lang/Integer;";
		baseClassMethodName		= "valueOf";
		baseClassMethodSignature	= "(I)Ljava/lang/Integer;";

		jclass		method_cls = env->FindClass( baseClassName );
		jmethodID 	mid= env->GetStaticMethodID( method_cls, baseClassMethodName, baseClassMethodSignature );
		ret = env->CallStaticObjectMethod( method_cls, mid, jval.i);

	}
	else if ( primitiveType == 'J')
	{	

		baseClassName			= "Ljava/lang/Long;";
		baseClassMethodName		= "valueOf";
		baseClassMethodSignature	= "(J)Ljava/lang/Long;";

		jclass		method_cls = env->FindClass( baseClassName );
		
		jmethodID 	mid= env->GetStaticMethodID( method_cls, baseClassMethodName, baseClassMethodSignature );

		ret = env->CallStaticObjectMethod( method_cls, mid, jval.j);



	}
	else if ( primitiveType == 'F')
	{	
		baseClassName			= "Ljava/lang/Float;";
		baseClassMethodName		= "valueOf";
		baseClassMethodSignature	= "(F)Ljava/lang/Float;";

		jclass		method_cls = env->FindClass( baseClassName );
		jmethodID 	mid= env->GetStaticMethodID( method_cls, baseClassMethodName, baseClassMethodSignature );
		ret = env->CallStaticObjectMethod( method_cls, mid, jval.f);
	}
	else if ( primitiveType == 'D')
	{	
		baseClassName			= "Ljava/lang/Double;";
		baseClassMethodName		= "valueOf";
		baseClassMethodSignature	= "(D)Ljava/lang/Double;";

		jclass		method_cls = env->FindClass( baseClassName );
		jmethodID 	mid= env->GetStaticMethodID( method_cls, baseClassMethodName, baseClassMethodSignature );
		ret = env->CallStaticObjectMethod( method_cls, mid, jval.d);
	}

	return ret;
}








struct pthread_triger_t
{

	JavaVM* vm;


	jclass target_cls;
	jobject method;
	jobject this_ptr;
	jobjectArray args;

};



pthread_mutex_t JNI_attachMentMutex = PTHREAD_MUTEX_INITIALIZER;


void* pthread_triger_func( void* arg )
{
	// pthread_createɂJavã\bhN邽߂̃gK\bh.
	// pthread_triger_t\̂Ɏ.

	//NJava\bh́A͔CӒACӃ^Cv(void^,ev~eBu^܂)ƂA߂lCӂ̌^Ƃ.
	//@AN鑤JavaVMlCeBuւ̈nɍۂAv~eBu^͈UNXŃbsOKv.( Ώۃ\bh̋N܂łɂ̃R[hœIɕϊ )
	// lɁA߂lv~eBu^̏ꍇ͊NX֕ϊA͖{R[hɂčĕϊȂ(ĂяoōēxϊKv)
	//܂static\bh̏ꍇ́Athis|C^ɑObject^̃p[^NULLƂĂ.


	nkprintf("posix.cpp pthread_triger_func() called\n");

	struct pthread_triger_t* p_triger_t = (struct pthread_triger_t*)arg;

	JNIEnv* env;


	// JVMɃA^b`/f^b`Ƃ܂ȂŁAr䂵Ă݂.
	pthread_mutex_lock( &JNI_attachMentMutex );
	{
		p_triger_t->vm->AttachCurrentThread( (void**)&env, NULL );
	}
	pthread_mutex_unlock( &JNI_attachMentMutex );


	int target_arg_size = env->GetArrayLength( p_triger_t->args );

	nkprintf("posix.cpp pthread_triger_func() target_arg_size=%d\n", target_arg_size);

	jobject* target_args = (jobject*)malloc(sizeof(jobject) * target_arg_size );
	for( int i=0; i < target_arg_size; i++)
	{
		target_args[i] = env->GetObjectArrayElement( p_triger_t->args, i );
	}



	char methodName[1024], methodSignature[1024];
	getMethodNativeSignature( env, p_triger_t->target_cls, p_triger_t->method, methodName, methodSignature );



	nkprintf("posix.cpp pthread_triger_func() methodName=%s, methodSignature=%s\n", methodName, methodSignature);

	jmethodID mid = NULL;



	char methodType, methodParamArray[1024];
	int methodParamSize = 0;
	methodType = nativeSignatureToArray( methodSignature, methodParamArray, &methodParamSize );
	nkprintf("posix.cpp pthread_triger_func() methodType=%c methodParamArray=%s methodParamSize=%d\n", methodType, methodParamArray, methodParamSize );

	jvalue* args_array = (jvalue*)malloc(sizeof(jvalue) * methodParamSize);
	for( int i=0; i < methodParamSize; i++)
	{
		// ̃IuWFNgjvaluezɕϊBKvɉăv~eBu^̊NX̕ϊs.
		jobjectToPrimitiveJValue( env, target_args[i], &args_array[i], methodParamArray[i] );
		
	}
	

	jvalue ret;
	memset( &ret, 0x00, sizeof(jvalue) );
	
	if ( p_triger_t->this_ptr == NULL)
	{

		nkprintf("posix.cpp pthread_triger_func() static method\n");

		mid = env->GetStaticMethodID( p_triger_t->target_cls, methodName, methodSignature );

		nkprintf("posix.cpp pthread_triger_func() mid is %p\n", mid);

		// this|C^(CX^X)NULLł.static\bhł.

		//R[fBOQl) http://www.ne.jp/asahi/hishidama/home/tech/java/jni_code.html#NX̎擾

		if ( methodType == 'V' )
		{
			env->CallStaticVoidMethodA( p_triger_t->target_cls, mid, args_array );
		}
		else if ( methodType == 'Z' )
		{
			ret.z = env->CallStaticBooleanMethodA( p_triger_t->target_cls, mid, args_array );
		}
		else if ( methodType == 'B' )
		{
			ret.b = env->CallStaticByteMethodA( p_triger_t->target_cls, mid, args_array );
		}
		else if ( methodType == 'C' )
		{
			ret.c = env->CallStaticCharMethodA( p_triger_t->target_cls, mid, args_array );
		}
		else if ( methodType == 'S' )
		{
			ret.s = env->CallStaticShortMethodA( p_triger_t->target_cls, mid, args_array );
		}
		else if ( methodType == 'I' )
		{
			ret.i = env->CallStaticIntMethodA( p_triger_t->target_cls, mid, args_array );
		}
		else if ( methodType == 'J' )
		{
			ret.j = env->CallStaticLongMethodA( p_triger_t->target_cls, mid, args_array );
		}
		else if ( methodType == 'F' )
		{
			ret.f = env->CallStaticFloatMethodA( p_triger_t->target_cls, mid, args_array );
		}
		else if ( methodType == 'D' )
		{
			ret.d = env->CallStaticDoubleMethodA( p_triger_t->target_cls, mid, args_array );
		}
		else
		{
			ret.l = env->CallStaticObjectMethodA( p_triger_t->target_cls, mid, args_array );
		}


	}
	else
	{

		mid = env->GetMethodID( p_triger_t->target_cls, methodName, methodSignature );


		if ( methodType == 'V' )
		{
			env->CallVoidMethodA( p_triger_t->this_ptr, mid, args_array );
		}
		else if ( methodType == 'Z' )
		{
			ret.z = env->CallBooleanMethodA( p_triger_t->this_ptr, mid, args_array );
		}
		else if ( methodType == 'B' )
		{
			ret.b = env->CallByteMethodA( p_triger_t->this_ptr, mid, args_array );
		}
		else if ( methodType == 'C' )
		{
			ret.c = env->CallCharMethodA( p_triger_t->this_ptr, mid, args_array );
		}
		else if ( methodType == 'S' )
		{
			ret.s = env->CallShortMethodA( p_triger_t->this_ptr, mid, args_array );
		}
		else if ( methodType == 'I' )
		{
			ret.i = env->CallIntMethodA( p_triger_t->this_ptr, mid, args_array );
		}
		else if ( methodType == 'J' )
		{
			ret.j = env->CallLongMethodA( p_triger_t->this_ptr, mid, args_array );
		}
		else if ( methodType == 'F' )
		{
			ret.f = env->CallFloatMethodA( p_triger_t->this_ptr, mid, args_array );
		}
		else if ( methodType == 'D' )
		{
			ret.d = env->CallDoubleMethodA( p_triger_t->this_ptr, mid, args_array );
		}
		else
		{
			ret.l = env->CallObjectMethodA( p_triger_t->this_ptr, mid, args_array );
		}


	}


	nkprintf("posix.cpp pthread_triger_func() Call<Type>MethodA() returned\n");


	jobject* ptr_ret_obj = NULL;

	/*
	// lCeBupthread_join()ŉ߂lAG~[^̎ł͕svȂ߃[N𗈂Ă̂ō폜
	// ܂ pthread_creatěĂяopthread_detach()ĂԎdlƂ߁AXbhI㎑͑ɉ.
	ptr_ret_obj = (jobject*)malloc(sizeof(jobject));
	if ( methodType == 'L' || methodType == '[' )
	{
		*ptr_ret_obj = ret.l;
	}
	else
	{
		*ptr_ret_obj = primitiveJValueToJObject( env, ret, methodType );
	}

	*ptr_ret_obj = env->NewGlobalRef( *ptr_ret_obj );
	*/



	/*
	if ( methodType == 'L' || methodType == '[' )
	{	//Xbh̖߂lłObject^Ԃ폜.pthread_join()ȂƂO
		env->DeleteLocalRef( ret.l );
	}
	*/




	pthread_mutex_lock( &JNI_attachMentMutex );
	{	


		nkprintf("posix.cpp pthread_triger_func() env->DeleteGlobalRef() call\n");

		env->DeleteGlobalRef( (jobject)p_triger_t->target_cls );
		env->DeleteGlobalRef( (jobject)p_triger_t->this_ptr );
		env->DeleteGlobalRef( (jobject)p_triger_t->method );
		env->DeleteGlobalRef( (jobject)p_triger_t->args );


		// Kx[WRNVɍ쓮Ȃ߁A[JQƂ폜Ă݂.
		nkprintf("posix.cpp pthread_triger_func() env->DeleteLocalRef() call\n");
	
		env->DeleteLocalRef( (jobject)p_triger_t->target_cls );
		env->DeleteLocalRef( (jobject)p_triger_t->this_ptr );
		env->DeleteLocalRef( (jobject)p_triger_t->method );
		env->DeleteLocalRef( (jobject)p_triger_t->args );


		// DetachCurrentThread()WinJVMł́ÃXbh瓯ɌĂяoƉ̂fbhbN.

		nkprintf("posix.cpp pthread_triger_func() vm->DetachCurrentThread() call\n");

		jint detachVMret = p_triger_t->vm->DetachCurrentThread();

		nkprintf("posix.cpp pthread_triger_func() vm->DetachCurrentThread() returned. ret=%d\n", detachVMret);
	}
	pthread_mutex_unlock( &JNI_attachMentMutex );


	free( target_args );	//̕ϐ̓lCeBumalloc()̂ŉ.
	free( p_triger_t );	//̍\̂sv.

	nkprintf("posix.cpp pthread_triger_func() return\n");

	return (void*)ptr_ret_obj;
}




JNIEXPORT jlong JNICALL _PACKAGE(getPthreadConstValue)(JNIEnv *env, jclass jcls, jstring constValueName)
{
	// pthread֌W̒萔lԂ.

	const char* utf_valueName;
	jboolean isCopy;

	jlong value;

	utf_valueName = env->GetStringUTFChars( constValueName, &isCopy);
	

	if ( strcmp(utf_valueName, "PTHREAD_CREATE_JOINABLE") == 0)
	{
		value = PTHREAD_CREATE_JOINABLE;
	}
	else if ( strcmp(utf_valueName, "PTHREAD_CREATE_DETACHED") == 0)
	{
		value = PTHREAD_CREATE_DETACHED;
	}
	else if ( strcmp(utf_valueName, "SCHED_OTHER") == 0)
	{
		value = SCHED_OTHER;
	}
	else if ( strcmp(utf_valueName, "SCHED_RR") == 0)
	{
		value = SCHED_RR;
	}
	else if ( strcmp(utf_valueName, "SCHED_FIFO") == 0)
	{
		value = SCHED_FIFO;
	}
	else if ( strcmp(utf_valueName, "PTHREAD_EXPLICIT_SCHED") == 0)
	{
		value = PTHREAD_EXPLICIT_SCHED;
	}
	else if ( strcmp(utf_valueName, "PTHREAD_INHERIT_SCHED") == 0)
	{
		value = PTHREAD_INHERIT_SCHED;
	}
	else if ( strcmp(utf_valueName, "PTHREAD_SCOPE_SYSTEM") == 0)
	{
		value = PTHREAD_SCOPE_SYSTEM;
	}
	else if ( strcmp(utf_valueName, "PTHREAD_SCOPE_PROCESS") == 0)
	{
		value = PTHREAD_SCOPE_PROCESS;
	}


	env->ReleaseStringUTFChars(constValueName, utf_valueName);

	return value;
}





JNIEXPORT jlong JNICALL Java_jnios_posix_pthreadCreate(JNIEnv *env, jclass cls, jlongArray pthread_t_jlong_arr, jlongArray pthread_attr_t_jlong_arr, jclass target_cls, jobject method, jobject this_obj, jobjectArray args_obj_arr)
{

	//lCeBupthread_creatẽbp[.

	//Ƃ肠eXgƂēKȃlCeBu\bhNĂ݂.


	/*
		http://java.sun.com/javase/ja/6/docs/ja/technotes/guides/jni/spec/invocation.html

		JNI C^tF[X|C^ (JNIEnv) ́Ã݂Xbhł̂ݗLłB
		ʂ̃Xbh Java VM ɃANZXKvꍇA͍ŏ AttachCurrentThread() ĂяoA
		ꎩ̂ VM ɐڑ JNI C^tF[X|C^擾Kv܂B
	*/



	nkprintf("posix.cpp pthreadCreate() called\n");



	pthread_t thread_id;


	struct pthread_triger_t* p_triger_t = (struct pthread_triger_t*)malloc(sizeof(struct pthread_triger_t) );
	

	pthread_mutex_lock( &JNI_attachMentMutex );
	{

		/*
			Cygwinł̃rhɕKvƂȂlibjvm.dll.a̍
			http://www.inonit.com/cygwin/jni/invocationApi/archive.html Ql
			
			Here are the contents of the file: 

			EXPORTS
			JNI_CreateJavaVM@12
			JNI_GetDefaultJavaVMInitArgs@4
			JNI_GetCreatedJavaVMs@12

			By convention, DLL exports files are given the extension .def, so we'll save this file in our directory with the name jvm.def. 

			Now, we need to generate our import library. We can do that with dlltool, as follows: 

			dlltool --input-def jvm.def --kill-at --dllname jvm.dll --output-lib libjvm.dll.a

		*/


		JavaVM *vm;
		jsize ct;
		jint ret = JNI_GetCreatedJavaVMs( &vm, 1, &ct);
		p_triger_t->vm = vm;
	}
	pthread_mutex_unlock( &JNI_attachMentMutex );


	p_triger_t->target_cls	= (jclass)env->NewGlobalRef( (jobject)target_cls );
	p_triger_t->method	= env->NewGlobalRef( method );
	p_triger_t->this_ptr	= env->NewGlobalRef( this_obj );
	p_triger_t->args		= (jobjectArray)env->NewGlobalRef( (jobject)args_obj_arr );



	/*
		pthread_attr ̐錾 http://www.sint.nl/mysql/mysql-3.22.27/mit-pthreads/include/pthread/pthread_attr.h


		enum schedparam_policy {
			SCHED_RR,
			SCHED_IO,
			SCHED_FIFO,
			SCHED_OTHER
		};

		struct pthread_attr {
			enum schedparam_policy	schedparam_policy;
			int						sched_priority;

			int						flags;
			void *					arg_attr;
			void 					(*cleanup_attr)();
			void *					stackaddr_attr;
			size_t					stacksize_attr;
		};
	*/


	pthread_attr_t attr_t;
	pthread_attr_t *p_attr = &attr_t;
	pthread_attr_init( p_attr );

	struct sched_param sched_prm;


	if ( pthread_attr_t_jlong_arr != NULL)
	{
		jlong* cattr		= env->GetLongArrayElements( pthread_attr_t_jlong_arr, NULL);
		int attr_arr_len	= env->GetArrayLength( pthread_attr_t_jlong_arr );

		if ( attr_arr_len >= 1)
		{
			//detachstate
			pthread_attr_setdetachstate( p_attr, (int)cattr[0] );
		}
		if ( attr_arr_len >= 2)
		{
			// schedpolicy
			pthread_attr_setschedpolicy( p_attr, (int)cattr[1] );
		}
		if ( attr_arr_len >= 3)
		{
			// schedparam

			sched_prm.sched_priority = (int)cattr[2];

			pthread_attr_setschedparam( p_attr, &sched_prm );
		}
		if ( attr_arr_len >= 4)
		{
			// inheritsched
			pthread_attr_setinheritsched( p_attr, (int)cattr[3] );
		}
		if ( attr_arr_len >= 5)
		{
			// scope
			pthread_attr_setscope( p_attr, (int)cattr[4] );
		}

		if ( attr_arr_len >= 6)
		{
			// stackaddr
			// NULL̏ꍇ̓ZbgȂ.
			if ( cattr[5] != NULL)
			{
				#if !defined (Cygwin)
					pthread_attr_setstackaddr( p_attr, (void*)cattr[5] );
				#endif
			}
		}

		if ( attr_arr_len >= 7)
		{
			// stacksize
			// 0̏ꍇ̓ZbgȂ.
			if ( cattr[6] != 0 )
			{
				pthread_attr_setstacksize( p_attr, (size_t)cattr[6] );
			}
		}

		if ( attr_arr_len >= 8)
		{
			// guardsize.(X^bNI[o[t[o邽߂̗̈̃TCY.
			// 0̏ꍇ̓ZbgȂ.
			if ( cattr[7] != 0 )
			{
				#if !defined(Cygwin)
					pthread_attr_setguardsize( p_attr, (size_t)cattr[7] );
				#endif
			}
		}


		env->ReleaseLongArrayElements( pthread_attr_t_jlong_arr, cattr, 0 );

	}






	jlong ret = pthread_create( &thread_id, p_attr, pthread_triger_func, p_triger_t );


	nkprintf("posix.cpp pthread_create() returned. ret=%d\n", (int)ret);

	if ( ret == 0)
	{
		//Xbh̐ɐ͗l.
		// G~[^ł̓Xbh̖߂lgpȂ̂ŁApthread_detach()Ăł.
		pthread_detach( thread_id );

		if ( pthread_t_jlong_arr != NULL)
		{
			jlong* pthread_t_clong_arr = env->GetLongArrayElements( pthread_t_jlong_arr, NULL );
			if ( env->GetArrayLength( pthread_t_jlong_arr ) > 0)
			{
				pthread_t_clong_arr[0] = (jlong)thread_id;
			}
			env->ReleaseLongArrayElements( pthread_t_jlong_arr, pthread_t_clong_arr, 0 );
		}
	}
	else
	{
		//Xbh̐Ɏs.
		
		//e펑̉.

		nkprintf("posix.cpp pthread_create() pthread_create failed\n");

		env->DeleteGlobalRef( (jobject)target_cls );
		env->DeleteGlobalRef( (jobject)method );
		env->DeleteGlobalRef( (jobject)this_obj );
		env->DeleteGlobalRef( (jobject)args_obj_arr );

		free( p_triger_t);
		
		ret = -1;
	}

		
	


	return ret;

}



JNIEXPORT jlong JNICALL Java_jnios_posix_pthreadJoin(JNIEnv *env, jclass cls, jlong th, jobjectArray thread_return_arr)
{


	nkprintf("posix.cpp pthreadJoin() called\n");

	void*	thread_return;
	jlong ret = pthread_join( (pthread_t)th, &thread_return);

	jobject* ptr_ret_obj = (jobject*)thread_return;


	env->SetObjectArrayElement( thread_return_arr, 0, *ptr_ret_obj );

	env->DeleteGlobalRef( *ptr_ret_obj );

	free( ptr_ret_obj );
	
	return ret;
}


JNIEXPORT void JNICALL Java_jnios_posix_pthreadExit(JNIEnv *env, jclass cls, jlong retval)
{
	// 08/11/05 .

	nkprintf("posix.cpp pthreadExit() called\n");

	JavaVM *vm;
	jsize ct;
	jint ret = JNI_GetCreatedJavaVMs(&vm, 1, &ct);


	if (env->ExceptionOccurred() )
	{
		// http://www.javakb.com/Uwe/Forum.aspx/java-jvm/166/JNI-DetachCurrentThread-leads-to-Signal-11-SIGSEGV-on-Linux 
		env->ExceptionDescribe();
		env->ExceptionClear();
 	}


	vm->DetachCurrentThread();	//XbhJavaVM̐؂藣.


	nkprintf("posix.cpp pthreadExit() JavaVm is Detached form current thread! ct=%d\n", ct);

	pthread_exit( (void *)retval );


	nkprintf("posix.cpp pthreadExit() return\n");
}





JNIEXPORT jlong JNICALL Java_jnios_posix_gettid(JNIEnv *env, jclass cls )
{
	//XbhID̎擾.
	return (jlong)pthread_self();
}
	






struct sigaction_triger_t
{
	int signum;

	// JNIEnv* env;@// 2010/02/07 JNIEnv*lCeBuR[hŃLbV̂͂܂B
			 //	vm->AttachCurrentThread()𗘗p邱.

	JavaVM* vm;
	jclass target_cls;
	jobject method;
	jobject this_ptr;

	jobject sa_flags;
	jlongArray sa_mask;

};

vector<struct sigaction_triger_t*> sigaction_triger_v;

pthread_mutex_t  sigaction_triger_mutex = PTHREAD_MUTEX_INITIALIZER;	//sigaction_triger_vւ̑rIɍs.

/*
void sigaction_handler( int no ) {
    ( void )no;

	nkprintf("Hi! this is sigaction_handler\n");

    char *mes1 = "signal_handler start!!\n";
    char *mes2 = "signal_handler end...\n";
    write( 1, mes1, strlen( mes1 ));
    sleep( 5 );                  // Ԃ̂鏈
    write( 1, mes2, strlen( mes2 ));
}
*/

void sigaction_handler( int no )
{
    ( void )no;

	nkprintf("posix.cpp Hi! this is sigaction_handler. no=0x%x\n", no);


	JNIEnv* env;
	jclass target_cls;
	jobject method, this_ptr;

	struct sigaction_triger_t* p_triger_t = NULL;


	pthread_mutex_lock( &sigaction_triger_mutex );

	for( int i=0; i < sigaction_triger_v.size(); i++)
	{
		p_triger_t = sigaction_triger_v.at(i);
		if ( p_triger_t->signum == no )
		{
			break;
		}
		p_triger_t = NULL;
	}

	pthread_mutex_unlock( &sigaction_triger_mutex );


	// env		= p_triger_t->env;	//2010/02/07 JNIEnv*lCeBuR[hŕێ̂͂܂.
						// VMCX^XĎ擾邱.

	// JVMɃA^b`/f^b`Ƃ܂ȂŁAr䂵Ă݂.
	pthread_mutex_lock( &JNI_attachMentMutex );
	{
		p_triger_t->vm->AttachCurrentThread( (void**)&env, NULL );
	}
	pthread_mutex_unlock( &JNI_attachMentMutex );
	



	target_cls	= p_triger_t->target_cls;
	method		= p_triger_t->method;
	this_ptr	= p_triger_t->this_ptr;

	char methodName[1024], methodSignature[1024];
	getMethodNativeSignature( env, target_cls, method, methodName, methodSignature );

	nkprintf("posix.cpp signaction_handler() methodName=%s, methodSignature=%s\n", methodName, methodSignature );
	
	if ( this_ptr != NULL)
	{
		jmethodID mid = env->GetMethodID( target_cls, methodName, methodSignature );
		env->CallVoidMethod( this_ptr, mid, (jint)no );
	}
	else
	{
		jmethodID mid = env->GetStaticMethodID( target_cls, methodName, methodSignature );
		env->CallStaticVoidMethod( target_cls, mid, (jint)no );
	}
	

}


JNIEXPORT jlong JNICALL Java_jnios_posix_sigaction(JNIEnv *env, jclass cls, jlong signum, jobjectArray jobjArr_new_act, jobjectArray jobjArr_old_act)
{
	// 



	nkprintf("posix.cpp sigaction() called\n");


	jclass	new_target_cls, old_target_cls;
	jobject new_handler_method, old_handler_method;
	jobject new_this_ptr, old_this_ptr;		
	jobject new_sa_flags, old_sa_flags;		//Long^CX^X.
	jlongArray new_sa_mask, old_sa_mask;		//long[]z.



	if ( jobjArr_new_act == NULL && jobjArr_old_act == NULL )
	{
		//VKݒAÂݒ̃Rs[sȂreturn.

		nkprintf("posix.cpp sigaction() act is NULL && old_act is NULL \n");

		return -1;
	}

	if ( jobjArr_new_act == NULL && jobjArr_old_act != NULL)
	{
		nkprintf("posix.cpp sigaction() set old_act return\n");

		//old_actւ̐ݒ݂̂sreturn.
		struct sigaction_triger_t* p_old_triger_t = NULL;


		pthread_mutex_lock( &sigaction_triger_mutex );

		for(int i=0; i < sigaction_triger_v.size(); i++)
		{
			p_old_triger_t = sigaction_triger_v.at(i);
			if ( p_old_triger_t->signum == (int)signum )
			{
				break;
			}
		
			p_old_triger_t = NULL;
		}


		pthread_mutex_unlock( &sigaction_triger_mutex );


		if ( p_old_triger_t != NULL)
		{

			nkprintf("posix.cpp sigaction() find p_old_triger_t\n");

			old_target_cls		= p_old_triger_t->target_cls;
			old_handler_method	= p_old_triger_t->method;
			old_this_ptr		= p_old_triger_t->this_ptr;
			old_sa_mask		= p_old_triger_t->sa_mask;
			old_sa_flags		= p_old_triger_t->sa_flags;

			env->SetObjectArrayElement( jobjArr_old_act, 0,  old_target_cls );
			env->SetObjectArrayElement( jobjArr_old_act, 1,  old_handler_method );
			env->SetObjectArrayElement( jobjArr_old_act, 2,  old_this_ptr );
			env->SetObjectArrayElement( jobjArr_old_act, 3,  old_sa_mask );
			env->SetObjectArrayElement( jobjArr_old_act, 4,  old_sa_flags );

			nkprintf("posix.cpp sigaction() SetObjectArrayElement() returned\n");


		}


		return 0;
	}

	

	new_target_cls		= (jclass)env->GetObjectArrayElement(jobjArr_new_act, 0);
	new_handler_method	= env->GetObjectArrayElement(jobjArr_new_act, 1);
	new_this_ptr		= env->GetObjectArrayElement(jobjArr_new_act, 2);
	new_sa_mask			= (jlongArray)env->GetObjectArrayElement(jobjArr_new_act, 3);
	new_sa_flags		= env->GetObjectArrayElement(jobjArr_new_act, 4);


	nkprintf("posix.cpp sigaction() new_act parameters are instanced\n");

	new_target_cls		=(jclass)env->NewGlobalRef( new_target_cls );
	new_handler_method 	=env->NewGlobalRef( new_handler_method );
	new_this_ptr		=env->NewGlobalRef( new_this_ptr );
	new_sa_mask			=(jlongArray)env->NewGlobalRef( new_sa_mask );
	new_sa_flags		=env->NewGlobalRef( new_sa_flags );


	nkprintf("posix.cpp sigaction() NewGlobalRef returned\n");


	jvalue sa_flags_val;
	jobjectToPrimitiveJValue( env, new_sa_flags, &sa_flags_val, 'J' );


	nkprintf("posix.cpp sigaction() jobjectToPrimitiveJValue returned\n");

	jlong* clong_arr = env->GetLongArrayElements( new_sa_mask, NULL);
	int copy_size = env->GetArrayLength( new_sa_mask );
	sigset_t sigset;
	sigemptyset( &sigset );
	longArrTo_sigset_t( clong_arr, copy_size, &sigset );



	nkprintf("posix.cpp sigaction() boolArrTo_sigset_t() returned\n");


	struct sigaction new_act, old_act;

	

	new_act.sa_handler	= sigaction_handler;
	new_act.sa_flags	= (int)sa_flags_val.j;
	new_act.sa_mask		= sigset;

	

	/*
	{
		//eXgp.
		new_act.sa_flags = SA_RESTART;
		sigaddset( &new_act.sa_mask, SIGTSTP );   // VOi}XN̐ݒ 
	}
	*/


	nkprintf("posix.cpp sigaction() new_act.sa_flags = %d\n", new_act.sa_flags );



	struct sigaction_triger_t *p_new_triger_t, *p_old_triger_t;
	p_new_triger_t = p_old_triger_t = NULL;

	p_new_triger_t = (struct sigaction_triger_t *)malloc(sizeof(struct sigaction_triger_t ) );

	p_new_triger_t->signum		= signum;
	{
		JavaVM *vm;
		jsize ct;
		jint ret = JNI_GetCreatedJavaVMs( &vm, 1, &ct);
		p_new_triger_t->vm	= vm;

	}
	p_new_triger_t->target_cls	= new_target_cls;
	p_new_triger_t->method		= new_handler_method;
	p_new_triger_t->this_ptr	= new_this_ptr;

	p_new_triger_t->sa_flags	= new_sa_flags;
	p_new_triger_t->sa_mask		= new_sa_mask;


	// p_new_triger_t->env = env;	// 2010/02/07ύX. JNIEnv*lCeBuR[hŃLbV̂͂܂.ւVMCX^Xێ邱.

	nkprintf("posix.cpp sigaction() p_new_triger_t is seted\n");




	pthread_mutex_lock( &sigaction_triger_mutex );

	for(int i=0; i < sigaction_triger_v.size(); i++)
	{
		p_old_triger_t = sigaction_triger_v.at(i);
		if ( p_old_triger_t->signum == (int)signum )
		{
			vector<struct sigaction_triger_t*>::iterator itr = sigaction_triger_v.begin();
			itr+=i;
			sigaction_triger_v.erase(itr);

			break;
		}
		
		p_old_triger_t = NULL;
	}


	sigaction_triger_v.push_back( p_new_triger_t );



	pthread_mutex_unlock( &sigaction_triger_mutex );




	if ( p_old_triger_t != NULL)
	{
		old_target_cls		= p_old_triger_t->target_cls;
		old_handler_method	= p_old_triger_t->method;
		old_this_ptr		= p_old_triger_t->this_ptr;
		old_sa_mask			= p_old_triger_t->sa_mask;
		old_sa_flags		= p_old_triger_t->sa_flags;


		if ( jobjArr_old_act != NULL )
		{
			env->SetObjectArrayElement( jobjArr_old_act, 0,  old_target_cls );
			env->SetObjectArrayElement( jobjArr_old_act, 1,  old_handler_method );
			env->SetObjectArrayElement( jobjArr_old_act, 2,  old_this_ptr );
			env->SetObjectArrayElement( jobjArr_old_act, 3,  old_sa_mask );
			env->SetObjectArrayElement( jobjArr_old_act, 4,  old_sa_flags );
		}


		env->DeleteGlobalRef( old_target_cls );
		env->DeleteGlobalRef( old_handler_method );
		env->DeleteGlobalRef( old_this_ptr );
		env->DeleteGlobalRef( old_sa_mask );
		env->DeleteGlobalRef( old_sa_flags );

		free( p_old_triger_t );
	}

	



	jlong ret = sigaction( (int)signum, &new_act, &old_act);
	


	return ret;
}




JNIEXPORT jlong JNICALL _PACKAGE(nanosleep)(JNIEnv *env, jclass jcls, jlong sec, jlong nsec, jlongArray rem_jarr)
{
	// c莞Ԃi[rem_jarŕAvf2long^zł.rem_jarrnullw肷邱Ƃo.

	nkprintf("posix.cpp nanosleep() called\n");

	struct timespec req, rem;

	req.tv_sec = sec;
	req.tv_nsec= nsec;
	
	memset( &rem, 0x00, sizeof(timespec) );
	

	jlong ret = nanosleep( &req, &rem );

	if ( rem_jarr != NULL )
	{
		if ( env->GetArrayLength( rem_jarr ) >= 2 )
		{
			jlong* rem_carr = env->GetLongArrayElements( rem_jarr, NULL );
			rem_carr[0] = rem.tv_sec;
			rem_carr[1] = rem.tv_nsec;
			env->ReleaseLongArrayElements( rem_jarr, rem_carr, 0 );
		}
	}


	return ret;
}


JNIEXPORT jlong JNICALL _PACKAGE(schedYield)(JNIEnv *env, jclass jcls )
{
	// sched_yield()Ăяo.
	// Xbh̃vCIeBꎞIɉʂ.

	jlong ret = 0;

	ret = sched_yield();

	return ret;
}


JNIEXPORT jlong JNICALL _PACKAGE(schedSetAffinity)(JNIEnv *env, jclass jcls, jlong pid, jbooleanArray mask_jbarr)
{
	int mask_len = env->GetArrayLength( mask_jbarr );
	jboolean* mask_cbarr = env->GetBooleanArrayElements( mask_jbarr, NULL );

	jlong ret = 0;
	#if defined(Linux)
		cpu_set_t cpu;
		CPU_ZERO( &cpu);
		for( int i=0; i < mask_len; i++)
		{
			if ( mask_cbarr[i] == true )
			{
				CPU_SET( i, &cpu );
			}
		}
		ret = sched_setaffinity( pid, sizeof(cpu_set_t), &cpu );

	#else if defined(Cygwin)
		// CygwinAPIɂ͖̂Win32gp http://msdn.microsoft.com/ja-jp/library/cc429334.aspx

		HANDLE hProcess = NULL;
		if ( pid != 0)
		{
			hProcess = OpenProcess(PROCESS_ALL_ACCESS, FALSE, pid);
			// vZX̃nh擾.
		}
		else
		{
			hProcess = GetCurrentProcess();
		}

		DWORD dw_mask = 0;
		for( int i=0; i < mask_len; i++)
		{
			if ( mask_cbarr[i] == true )
			{
				dw_mask |= 1 << i;
			}
		}

		ret = SetProcessAffinityMask(hProcess, dw_mask );

		CloseHandle( hProcess );
		
	#endif

	env->ReleaseBooleanArrayElements( mask_jbarr, mask_cbarr, 0);
	
	return ret;
}


JNIEXPORT jlong JNICALL _PACKAGE(schedGetAffinity)(JNIEnv *env, jclass jcls, jlong pid, jbooleanArray mask_jbarr)
{
	int mask_len = env->GetArrayLength( mask_jbarr );
	jboolean* mask_cbarr = env->GetBooleanArrayElements( mask_jbarr, NULL );

	jlong ret = 0;
	#if defined(Linux)
		cpu_set_t cpu;
		CPU_ZERO( &cpu);

		ret = sched_getaffinity( pid, sizeof(cpu_set_t), &cpu );

		for( int i=0; i < mask_len; i++)
		{
			//.
			mask_cbarr[i] = false;
			if ( CPU_ISSET( i , &cpu) == 1 )
			{
				mask_cbarr[i] = true;
			}
		}

	#else if defined(Cygwin)
		// CygwinAPIɂ͖̂Win32gp http://msdn.microsoft.com/ja-jp/library/cc429334.aspx

		HANDLE hProcess = NULL;
		if ( pid != 0)
		{
			hProcess = OpenProcess(PROCESS_ALL_ACCESS, FALSE, pid);
			// vZX̃nh擾.
		}
		else
		{
			hProcess = GetCurrentProcess();
		}

		DWORD dw_process_mask, dw_system_mask;
		ret = GetProcessAffinityMask(hProcess, &dw_process_mask, &dw_system_mask );

		for( int i=0; i < sizeof(dw_process_mask) * 8; i++)
		{
			mask_cbarr[i] = false;
			if ( ( dw_process_mask & ( 1 << ( sizeof(dw_process_mask) * 8 - i - 1) ) ) == 1 )
			{
				mask_cbarr[i] = true;
			}
		}

		CloseHandle( hProcess );
		
	#endif

	env->ReleaseBooleanArrayElements( mask_jbarr, mask_cbarr, 0);
	
	return ret;
}











JNIEXPORT jlong JNICALL _PACKAGE(readNativeMemcpy)(JNIEnv *env, jclass jcls, jbyteArray j_bytes, jlong nativePtr, jlong size)
{
	// lCeBuȃԂJavabyte^zփ].

	// nkprintf("posix.cpp readNativeMemcpy(native2emu) called. nativePtr=%p, size=%d\n", (void*)nativePtr, size );
	
	jbyte* j_bytes_ptr = env->GetByteArrayElements( j_bytes, NULL );

	memcpy( (void*)j_bytes_ptr, (void*)nativePtr, size );

	env->ReleaseByteArrayElements( j_bytes, j_bytes_ptr, 0 );

	return size;
}


JNIEXPORT jlong JNICALL _PACKAGE(writeNativeMemcpy)(JNIEnv *env, jclass jcls, jlong nativePtr, jbyteArray j_bytes, jlong size)
{
	// Javabyte^z񂩂lCeBuԂփ]

	// nkprintf("posix.cpp writeNativeMemcpy() called. nativePtr=%p, size=%d\n", (void*)nativePtr, size );
	
	jbyte* j_bytes_ptr = env->GetByteArrayElements( j_bytes, NULL );

	memcpy( (void*)nativePtr, (void*)j_bytes_ptr, size );

	env->ReleaseByteArrayElements( j_bytes, j_bytes_ptr, 0 );

	return size;
}




void statfsToArray( struct statfs fs, jlong* array)
{
	// statfs\̂ jlong^zɕϊ.

	/*
		struct statfs
		{
		   long    f_type;      t@CVXě^ (LQ) 
		   long    f_bsize;     œKȃubNTCY 
		   long    f_blocks;    t@CVXȇf[^ubN 
 	           long    f_bfree;     t@CVXe̋󂫃ubN 
		   long    f_bavail;    X[p[[Ugp\ȋ󂫃ubN 
		   long    f_files;     t@CVXȇt@Cm[h 
 		   long    f_ffree;     t@CVXe̋󂫃t@Cm[h 
		   fsid_t  f_fsid;      t@CVXe ID 
		   long    f_namelen;   t@C̍ő咷 
		};
	*/

	array[0] = fs.f_type;
	array[1] = fs.f_bsize;
	array[2] = fs.f_blocks;
	array[3] = fs.f_bfree;
	array[4] = fs.f_bavail;
	array[5] = fs.f_files;

	/*
	#if !defined (Cygwin)
		array[6] = fs.f_ffree;
	#else
		array[6] = 0;
	#endif
	*/
	array[6] = fs.f_ffree;

	// array[7] = fs.f_fsid;
	memcpy( &array[7], &fs.f_fsid, sizeof( fs.f_fsid ) );
	// fsid_t  struct { int val[2]; } ƒ`.
	// http://www.linux.or.jp/JM/html/LDP_man-pages/man2/statfs.2.html 

	array[8] = fs.f_namelen;

	return ;
}


JNIEXPORT jlong JNICALL _PACKAGE(statfs)(JNIEnv *env, jclass jcls, jstring jstr_path, jlongArray jlarr_statfs)
{
	// }Egꂽt@CEVXeɂĂ̏Ԃ.
	const char* utf_path;
	jboolean isCopy;

	utf_path = env->GetStringUTFChars( jstr_path, &isCopy);
	

	struct statfs nativefs;

	jlong ret = statfs( utf_path, &nativefs );


	env->ReleaseStringUTFChars( jstr_path, utf_path);


	jlong* clarr_statfs = env->GetLongArrayElements( jlarr_statfs, NULL );

	statfsToArray( nativefs, clarr_statfs );

	env->ReleaseLongArrayElements( jlarr_statfs, clarr_statfs, 0);
	
	return ret;
	
}


JNIEXPORT jlong JNICALL _PACKAGE(fstatfs)(JNIEnv *env, jclass jcls, jlong fd, jlongArray jlarr_statfs)
{
	// fBXNv^[ fd ɂĎQƂI[vꂽt@Cɂ statfs()ƓԂ.

	struct statfs nativefs;

	jlong ret = fstatfs( fd, &nativefs );

	jlong* clarr_statfs = env->GetLongArrayElements( jlarr_statfs, NULL );

	statfsToArray( nativefs, clarr_statfs );

	env->ReleaseLongArrayElements( jlarr_statfs, clarr_statfs, 0);
	
	return ret;
	
}


/*
JNIEXPORT jlong JNICALL _PACKAGE(getStatfsFTypeValue)(JNIEnv *env, jclass jcls, jstring constValueName)
{
	// f_typẽlCeBu̒萔lԂ.
	// Cygwinmagic.hɑ`t@C݂Ȃ߁Agp͕s.

	const char* utf_valueName;
	jboolean isCopy;

	jlong value = -1;

	utf_valueName = env->GetStringUTFChars( constValueName, &isCopy);
	

	if ( strcmp(utf_valueName, "ADFS_SUPER_MAGIC") == 0)
	{
		value = ADFS_SUPER_MAGIC;
	}
	else if ( strcmp(utf_valueName, "AFFS_SUPER_MAGIC") == 0)
	{
		value = AFFS_SUPER_MAGIC;
	}
	else if ( strcmp(utf_valueName, "BEFS_SUPER_MAGIC") == 0)
	{
		value = BEFS_SUPER_MAGIC;
	}
	else if ( strcmp(utf_valueName, "BFS_MAGIC") == 0)
	{
		value = BFS_MAGIC;
	}
	else if ( strcmp(utf_valueName, "CIFS_MAGIC_NUMBER") == 0)
	{
		value = CIFS_MAGIC_NUMBER;
	}
	else if ( strcmp(utf_valueName, "CODA_SUPER_MAGIC") == 0)
	{
		value = CODA_SUPER_MAGIC;
	}
	else if ( strcmp(utf_valueName, "COH_SUPER_MAGIC") == 0)
	{
		value = COH_SUPER_MAGIC;
	}
	else if ( strcmp(utf_valueName, "CRAMFS_MAGIC") == 0)
	{
		value = CRAMFS_MAGIC;
	}
	else if ( strcmp(utf_valueName, "DEVFS_SUPER_MAGIC") == 0)
	{
		value = DEVFS_SUPER_MAGIC;
	}
	else if ( strcmp(utf_valueName, "EFS_SUPER_MAGIC") == 0)
	{
		value = EFS_SUPER_MAGIC;
	}
	else if ( strcmp(utf_valueName, "EXT_SUPER_MAGIC") == 0)
	{
		value = EXT_SUPER_MAGIC;
	}
	else if ( strcmp(utf_valueName, "EXT2_OLD_SUPER_MAGIC") == 0)
	{
		value = EXT2_OLD_SUPER_MAGIC;
	}
	else if ( strcmp(utf_valueName, "EXT2_SUPER_MAGIC") == 0)
	{
		value = EXT2_SUPER_MAGIC;
	}
	else if ( strcmp(utf_valueName, "EXT3_SUPER_MAGIC") == 0)
	{
		value = EXT3_SUPER_MAGIC;
	}
	else if ( strcmp(utf_valueName, "HFS_SUPER_MAGIC") == 0)
	{
		value = HFS_SUPER_MAGIC;
	}
	else if ( strcmp(utf_valueName, "HPFS_SUPER_MAGIC") == 0)
	{
		value = HPFS_SUPER_MAGIC;
	}
	else if ( strcmp(utf_valueName, "HUGETLBFS_MAGIC") == 0)
	{
		value = HUGETLBFS_MAGIC;
	}
	else if ( strcmp(utf_valueName, "ISOFS_SUPER_MAGIC") == 0)
	{
		value = ISOFS_SUPER_MAGIC;
	}
	else if ( strcmp(utf_valueName, "JFFS2_SUPER_MAGIC") == 0)
	{
		value = JFFS2_SUPER_MAGIC;
	}
	else if ( strcmp(utf_valueName, "JFS_SUPER_MAGIC") == 0)
	{
		value = JFS_SUPER_MAGIC;
	}
	else if ( strcmp(utf_valueName, "MINIX_SUPER_MAGIC") == 0)
	{
		value = MINIX_SUPER_MAGIC;
	}
	else if ( strcmp(utf_valueName, "MINIX_SUPER_MAGIC2") == 0)
	{
		value = MINIX_SUPER_MAGIC2;
	}
	else if ( strcmp(utf_valueName, "MINIX2_SUPER_MAGIC") == 0)
	{
		value = MINIX2_SUPER_MAGIC;
	}
	else if ( strcmp(utf_valueName, "MINIX2_SUPER_MAGIC2") == 0)
	{
		value = MINIX2_SUPER_MAGIC2;
	}
	else if ( strcmp(utf_valueName, "MSDOS_SUPER_MAGIC") == 0)
	{
		value = MSDOS_SUPER_MAGIC;
	}
	else if ( strcmp(utf_valueName, "NCP_SUPER_MAGIC") == 0)
	{
		value = NCP_SUPER_MAGIC;
	}
	else if ( strcmp(utf_valueName, "NFS_SUPER_MAGIC") == 0)
	{
		value = NFS_SUPER_MAGIC;
	}
	else if ( strcmp(utf_valueName, "NTFS_SB_MAGIC") == 0)
	{
		value = NTFS_SB_MAGIC;
	}
	else if ( strcmp(utf_valueName, "OPENPROM_SUPER_MAGIC") == 0)
	{
		value = OPENPROM_SUPER_MAGIC;
	}
	else if ( strcmp(utf_valueName, "PROC_SUPER_MAGIC") == 0)
	{
		value = PROC_SUPER_MAGIC;
	}
	else if ( strcmp(utf_valueName, "QNX4_SUPER_MAGIC") == 0)
	{
		value = QNX4_SUPER_MAGIC;
	}
	else if ( strcmp(utf_valueName, "REISERFS_SUPER_MAGIC") == 0)
	{
		value = REISERFS_SUPER_MAGIC;
	}
	else if ( strcmp(utf_valueName, "ROMFS_MAGIC") == 0)
	{
		value = ROMFS_MAGIC;
	}
	else if ( strcmp(utf_valueName, "SMB_SUPER_MAGIC") == 0)
	{
		value = SMB_SUPER_MAGIC;
	}
	else if ( strcmp(utf_valueName, "SYSV2_SUPER_MAGIC") == 0)
	{
		value = SYSV2_SUPER_MAGIC;
	}
	else if ( strcmp(utf_valueName, "SYSV4_SUPER_MAGIC") == 0)
	{
		value = SYSV4_SUPER_MAGIC;
	}
	else if ( strcmp(utf_valueName, "TMPFS_MAGIC") == 0)
	{
		value = TMPFS_MAGIC;
	}
	else if ( strcmp(utf_valueName, "UDF_SUPER_MAGIC") == 0)
	{
		value = UDF_SUPER_MAGIC;
	}
	else if ( strcmp(utf_valueName, "UFS_MAGIC") == 0)
	{
		value = UFS_MAGIC;
	}
	else if ( strcmp(utf_valueName, "USBDEVICE_SUPER_MAGIC") == 0)
	{
		value = USBDEVICE_SUPER_MAGIC;
	}
	else if ( strcmp(utf_valueName, "VXFS_SUPER_MAGIC") == 0)
	{
		value = VXFS_SUPER_MAGIC;
	}
	else if ( strcmp(utf_valueName, "XENIX_SUPER_MAGIC") == 0)
	{
		value = XENIX_SUPER_MAGIC;
	}
	else if ( strcmp(utf_valueName, "XFS_SUPER_MAGIC") == 0)
	{
		value = XFS_SUPER_MAGIC;
	}
	else if ( strcmp(utf_valueName, "_XIAFS_SUPER_MAGIC") == 0)
	{
		value = _XIAFS_SUPER_MAGIC;
	}
	else
	{
		value = -1;
	}

	env->ReleaseStringUTFChars( constValueName, utf_valueName);

	return value;
}
*/





JNIEXPORT jlong JNICALL _PACKAGE(opendir)(JNIEnv *env, jclass jcls, jstring jpath)
{

	const char* utf_path;
	jboolean isCopy;

	utf_path = env->GetStringUTFChars( jpath, &isCopy);

	DIR* dirp = opendir( utf_path );

	env->ReleaseStringUTFChars( jpath, utf_path );

	return (jlong)dirp;
}

JNIEXPORT jlong JNICALL _PACKAGE(closedir)(JNIEnv *env, jclass jcls, jlong dirp)
{

	jlong ret = closedir( (DIR*)dirp );

	return ret;
}

JNIEXPORT jobjectArray JNICALL _PACKAGE(readdir)(JNIEnv *env, jclass jcls, jlong dirp)
{
	// dirp wfBNgXg[̒ŁÃfBNgGg\ dirent \̂ɏObject^zԂ.
	// zvf { Long d_ino, Long d_off, Long d_reclen, Long d_type, String d_name }; ł.
	// G[邩AfBNgXg[̖ɒBꍇA null Ԃ.

	int array_size = 5;

	jobjectArray jdirent = NULL;

	// nkprintf("posix.cpp readdir() called\n");


	struct dirent* dentp = readdir( (DIR*)dirp );
	

	// nkprintf("posix.cpp readdir() dentp=%p\n", dentp);
	
	if ( dentp != NULL )
	{
		jclass jobjcls = env->FindClass("java/lang/Object");
		jdirent = env->NewObjectArray( array_size, jobjcls, NULL);


		jvalue	jvd_ino, jvd_off, jvd_reclen, jvd_type;
		

		
		#if defined (Cygwin)
			// http://www.coins.tsukuba.ac.jp/~yas/classes/syspro1-1997/1997-05-13/ Q.
			jvd_ino.j	= (jlong)dentp->d_ino;
			jvd_off.j	= 0;	//݂Ȃ.
			jvd_reclen.j	= 0;	//݂Ȃ.
			jvd_type.j	= 0;	//݂Ȃ.
		#else
			jvd_ino.j	= dentp->d_ino;
			jvd_off.j	= dentp->d_off;
			jvd_reclen.j	= dentp->d_reclen;
			jvd_type.j	= dentp->d_type;
		#endif



		// nkprintf("posix.cpp readdir() primitiveJValueToJObject() call\n");

		jobject jod_ino		= primitiveJValueToJObject( env, jvd_ino, 'J' );
		jobject jod_off		= primitiveJValueToJObject( env, jvd_off, 'J' );
		jobject jod_reclen	= primitiveJValueToJObject( env, jvd_reclen, 'J' );
		jobject jod_type	= primitiveJValueToJObject( env, jvd_type, 'J' );


		// nkprintf("posix.cpp readdir() dentp->d_name=%s\n", dentp->d_name );

		jstring jstrd_name	= env->NewStringUTF( dentp->d_name );


		env->SetObjectArrayElement( jdirent, 0,  jod_ino );
		env->SetObjectArrayElement( jdirent, 1,  jod_off );
		env->SetObjectArrayElement( jdirent, 2,  jod_reclen );
		env->SetObjectArrayElement( jdirent, 3,  jod_type );
		env->SetObjectArrayElement( jdirent, 4,  jstrd_name );

	}
	

	return jdirent;
}




jobject* getObjectArrayElements( JNIEnv *env, jclass jcls, jobjectArray jobj_arr )
{
	// Ȃ GetObjectArrayElements()݂Ȃߍ쐬.

	int arr_size = env->GetArrayLength( jobj_arr );

	jobject* cobj_arr = (jobject*)malloc(sizeof(jobject) * arr_size );
	for( int i=0; i < arr_size; i++)
	{
		cobj_arr[i] = env->GetObjectArrayElement( jobj_arr, i );
	}

	return cobj_arr;
}

void releaseObjectArrayElements( JNIEnv *env, jclass jcls, jobjectArray jobj_arr, jobject* cobj_arr)
{
	// Ȃ ReleaseObjectArrayElements()݂Ȃߍ쐬.

	nkprintf("posix.cpp releaseObjectArrayElements() called\n");


	int arr_size = env->GetArrayLength( jobj_arr );

	nkprintf("posix.cpp releaseObjectArrayElements() arr_size=%d\n", arr_size );

	for( int i=0; i < arr_size; i++)
	{

		nkprintf("posix.cpp releaseObjectArrayElements() i=%d\n", i );


		env->SetObjectArrayElement( jobj_arr, i, cobj_arr[i] );
	}

	free( cobj_arr );


	nkprintf("posix.cpp releaseObjectArrayElements() return. arr_size=%d\n", arr_size );

}










JNIEXPORT jlong JNICALL _PACKAGE(getPollConstValue)(JNIEnv *env, jclass jcls, jstring constValueName)
{

	// poll(), ppoll()Ŏgp events, revents ̒萔lԂ.

	//nkprintf("posix.cpp getPollConstValue() called\n");


	jboolean isCopy;
	const char* cstr = env->GetStringUTFChars( constValueName, &isCopy);

	jlong ret = -1;

	
	if ( strcmp( cstr, "POLLIN") == 0 )
	{
		ret = POLLIN;
	}
	else if ( strcmp( cstr, "POLLPRI") == 0 )
	{
		ret = POLLPRI;
	}
	else if ( strcmp( cstr, "POLLOUT" ) == 0 )
	{
		ret = POLLOUT;
	}

	#if !defined(Cygwin)
	else if ( strcmp( cstr, "POLLRDHUP" ) == 0 )
	{
		ret = POLLRDHUP;
	}
	#endif

	else if ( strcmp( cstr, "POLLERR" ) == 0 )
	{
		ret = POLLERR;
	}
	else if ( strcmp( cstr, "POLLHUP" ) == 0 )
	{
		ret = POLLHUP;
	}
	else if ( strcmp( cstr, "POLLNVAL" ) == 0 )
	{
		ret = POLLNVAL;
	}
	else if ( strcmp( cstr, "POLLRDNORM" ) == 0 )
	{
		ret = POLLRDNORM;
	}
	else if ( strcmp( cstr, "POLLRDBAND" ) == 0 )
	{
		ret = POLLRDBAND;
	}
	else if ( strcmp( cstr, "POLLWRNORM" ) == 0 )
	{
		ret = POLLWRNORM;
	}
	else if ( strcmp( cstr, "POLLWRBAND" ) == 0 )
	{
		ret = POLLWRBAND;
	}

	#if !defined(Cygwin)
	else if ( strcmp( cstr, "POLLMSG" ) == 0 )
	{
		ret = POLLMSG;
	}
	#endif
	else
	{
		ret = -1;
	}
	


	env->ReleaseStringUTFChars( constValueName, cstr );


	//nkprintf("posix.cpp getPollConstValue() return:%d\n", ret);

	return ret;
}



JNIEXPORT jlong JNICALL _PACKAGE(poll)(JNIEnv *env, jclass jcls, jlongArray jlong_fds, jobjectArray warrayString_events, jobjectArray warrayString_revents, jlong timeout_millis)
{
	// 09/06/17 .
	// fdsz̗vf́Aeventsreventsw肷.
	// warrayString_events, warrayString_revents  String[][] Ȃ2zł.

	char *revents_reference[] = { "POLLIN", "POLLPRI", "POLLOUT", "POLLRDHUP", "POLLERR", "POLLHUP", "POLLNVAL", "POLLRDNORM", "POLLRDBAND", "POLLWRNORM", "POLLWRBAND" };
	int revents_reference_size = 11;

	int fds_size = 0;

	jlong *pfds, *ptimeout;

	pfds = ptimeout = NULL;

	jstring* events_string_arr = NULL;
	jstring* revents_string_arr= NULL;

	struct pollfd *fds = NULL;



	nkprintf("posix.cpp poll() called\n");
	


	if ( env->NewLocalRef( jlong_fds ) != NULL)
	{
		fds_size	= env->GetArrayLength( jlong_fds );
		pfds		= env->GetLongArrayElements( jlong_fds, NULL);

		fds		= (struct pollfd*)malloc( sizeof(struct pollfd) * fds_size );
		memset( fds, 0x00, sizeof( struct pollfd ) * fds_size );

		for( int i=0; i < fds_size; i++)
		{
			fds[i].fd = pfds[i];
		}

		env->ReleaseLongArrayElements( jlong_fds, pfds, 0);
	}

	nkprintf("posix.cpp poll() fds_size=%d\n", fds_size);


	if ( env->NewLocalRef( warrayString_events ) != NULL )
	{
		jobject* pwarr_string_events = getObjectArrayElements( env, jcls, warrayString_events );

		int warr_events_size = env->GetArrayLength( warrayString_events );

		nkprintf("posix.cpp poll() warr_events_size=%d\n", warr_events_size );

		for( int i=0; i < warr_events_size; i++)
		{
			jobject* parr_string_events = getObjectArrayElements( env, jcls, (jobjectArray)pwarr_string_events[i] );
			//^LXgĂPz𓾂.
			int arr_events_size = env->GetArrayLength( (jobjectArray)pwarr_string_events[i] );

			nkprintf("posix.cpp poll() arr_events_size=%d\n", arr_events_size );

			for( int k=0; k < arr_events_size; k++)
			{
				jstring string_event = (jstring)parr_string_events[k];
				
				jlong event_val = _PACKAGE(getPollConstValue)( env, jcls, string_event );

				fds[i].events |= event_val;

			}

			nkprintf("posix.cpp poll() fds[%d].events=%d\n", i, (int)fds[i].events );


			releaseObjectArrayElements( env, jcls, (jobjectArray)pwarr_string_events[i], parr_string_events );

		}

		releaseObjectArrayElements( env, jcls, warrayString_events, pwarr_string_events );
	}



	nkprintf("posix.cpp fds_size=%d, timeout_millis=%d\n", (int)fds_size, timeout_millis );

	jlong ret = poll( fds, fds_size, timeout_millis );


	if ( env->NewLocalRef( warrayString_revents ) != NULL )
	{

		jobject* pwarr_string_revents = getObjectArrayElements( env, jcls, warrayString_revents );
		int warr_revents_size = env->GetArrayLength( warrayString_revents );
		
		for( int i = 0; i < warr_revents_size; i++)
		{
			jobjectArray jrevents = (jobjectArray)pwarr_string_revents[i];

			int revents_hit_size = 0;
			char **hit_revents_chars = (char**)malloc( sizeof(char*) * revents_reference_size );

			for( int k=0; k < revents_reference_size; k++)
			{
				jstring jstr_refer = env->NewStringUTF( revents_reference[k] );

				if ( ( fds[i].revents & _PACKAGE(getPollConstValue)( env, jcls, jstr_refer ) ) ==
								_PACKAGE(getPollConstValue)( env, jcls, jstr_refer ) )
				{

					if ( _PACKAGE(getPollConstValue)( env, jcls, jstr_refer ) > 0 )
					{
						hit_revents_chars[ revents_hit_size ] = revents_reference[k];
						revents_hit_size++;
					}
					
				}
				env->DeleteLocalRef( jstr_refer );
			}



			nkprintf("posix.cpp poll() revents_hit_size=%d\n", revents_hit_size );


			
			jstring* hit_revents_jstrings	= (jstring*)malloc( sizeof(jstring) * revents_hit_size );


			nkprintf("posix.cpp poll() hit_revents_jstrings=%p\n", hit_revents_jstrings );


			jclass javaStringClass		= env->FindClass( "Ljava/lang/String;" );


			nkprintf("posix.cpp poll() javaStringClass=%p\n", javaStringClass );

			jobjectArray hit_revents_objarr = env->NewObjectArray( revents_hit_size, javaStringClass, NULL);


			nkprintf("posix.cpp poll() hit_revents_objarr=%p\n", hit_revents_objarr );


			for( int k =0; k < revents_hit_size; k++)
			{
				hit_revents_jstrings[k] = env->NewStringUTF( hit_revents_chars[k] );
			}

			for( int k=0; k < revents_hit_size; k++)
			{
				env->SetObjectArrayElement( hit_revents_objarr, k, hit_revents_jstrings[k] );
			}
			
			pwarr_string_revents[i] = hit_revents_objarr;

			free( hit_revents_jstrings );
			free( hit_revents_chars );
			
		}

		releaseObjectArrayElements( env, jcls, warrayString_revents, pwarr_string_revents );

	}

	free( fds );


	nkprintf("JNI DLL side posix.cpp poll() return ret=%d\n", ret);

	return ret;
}




JNIEXPORT jlong JNICALL _PACKAGE(getWaitConstValue)(JNIEnv *env, jclass jcls, jstring constValueName)
{
	// waitpid()ŗpIvVȂǂ̒萔lԂ.

	jboolean isCopy;
	const char* cstr = env->GetStringUTFChars( constValueName, &isCopy);

	jlong ret = -1;

	
	if ( strcmp( cstr, "WNOHANG") == 0 )
	{
		ret = WNOHANG;
	}
	else if ( strcmp( cstr, "WUNTRACED") == 0 )
	{
		ret = WUNTRACED;
	}

	
	#ifdef WCONTINUED
	else if ( strcmp( cstr, "WCONTINUED") == 0 )
	{
		ret = WCONTINUED;
	}
	#endif
	


	/*
	// status邽߂̃}NłA萔lł͂Ȃ.
	#ifdef WIFEXITED
	else if ( strcmp( cstr, "WIFEXITED") == 0 )
	{
		ret = WIFEXITED;
	}
	#endif

	#ifdef WEXITSTATUS
	else if ( strcmp( cstr, "WEXITSTATUS") == 0 )
	{
		ret = WEXITSTATUS;
	}
	#endif

	#ifdef WIFSIGNALED
	else if ( strcmp( cstr, "WIFSIGNALED") == 0 )
	{
		ret = WIFSIGNALED;
	}
	#endif

	#ifdef WTERMSIG
	else if ( strcmp( cstr, "WTERMSIG") == 0 )
	{
		ret = WTERMSIG;
	}
	#endif


	#ifdef WCOREDUMP
	else if ( strcmp( cstr, "WCOREDUMP") == 0 )
	{
		ret = WCOREDUMP;
	}
	#endif

	// }NłA萔lł͂Ȃ.
	#ifdef WIFSTOPPED
	else if ( strcmp( cstr, "WIFSTOPPED") == 0 )
	{
		ret = WIFSTOPPED;
	}
	#endif
	
	#ifdef WSTOPSIG
	else if ( strcmp( cstr, "WSTOPSIG") == 0 )
	{
		ret = WSTOPSIG;
	}
	#endif

	#ifdef WIFCONTINUED
	else if ( strcmp( cstr, "WIFCONTINUED") == 0 )
	{
		ret = WIFCONTINUED;
	}
	#endif
	*/



	#ifdef WEXITED
	else if ( strcmp( cstr, "WEXITED") == 0 )
	{
		ret = WEXITED;
	}
	#endif

	#ifdef WSTOPPED
	else if ( strcmp( cstr, "WSTOPPED") == 0 )
	{
		ret = WSTOPPED;
	}
	#endif

	#ifdef WCONTINUED
	else if ( strcmp( cstr, "WCONTINUED") == 0 )
	{
		ret = WCONTINUED;
	}
	#endif

	else if ( strcmp( cstr, "WNOHANG") == 0 )
	{
		ret = WNOHANG;
	}

	#ifdef WNOWAIT
	else if ( strcmp( cstr, "WNOWAIT") == 0 )
	{
		ret = WNOWAIT;
	}
	#endif
	
	else
	{
		ret = -1;
	}

	env->ReleaseStringUTFChars( constValueName, cstr );

	return ret;
}


JNIEXPORT jlong JNICALL _PACKAGE(waitpidT)(JNIEnv *env, jclass jcls, jlong pid, jlongArray status_jarr, jlong options)
{

	nkprintf("posix.cpp waitpidT() called. pid=%d, options=%d\n", (int)pid, (int)options );

	jlong* p_status_jarr = env->GetLongArrayElements( status_jarr, NULL );

	int status = 0;

	jlong ret = waitpid( pid, &status, options );
	
	p_status_jarr[0] = status;
	
	env->ReleaseLongArrayElements( status_jarr, p_status_jarr, 0 );


	nkprintf("posix.cpp waitpidT() return. ret=%d, errno=%d\n", (int)ret, errno);


	return ret;
}



JNIEXPORT jlong JNICALL _PACKAGE(getitimer)(JNIEnv *env, jclass jcls, jlong which, jlongArray curr_value_arr )
{
	nkprintf("posix.cpp gettimer() called. which=%lld \n", which );

	jlong* p_curr_value = env->GetLongArrayElements( curr_value_arr, NULL);

	struct itimerval curr_value;

	curr_value.it_interval.tv_sec	= p_curr_value[0];
	curr_value.it_interval.tv_usec	= p_curr_value[1];
	curr_value.it_value.tv_sec	= p_curr_value[2];
	curr_value.it_value.tv_usec	= p_curr_value[3];

	jlong ret = getitimer( which, &curr_value );

	p_curr_value[0]		= curr_value.it_interval.tv_sec;
	p_curr_value[1]		= curr_value.it_interval.tv_usec;
	p_curr_value[2]		= curr_value.it_value.tv_sec;
	p_curr_value[3]		= curr_value.it_value.tv_usec;

	env->ReleaseLongArrayElements( curr_value_arr, p_curr_value, 0 );

	return ret;
}


JNIEXPORT jlong JNICALL _PACKAGE(setitimer)(JNIEnv *env, jclass jcls, jlong which, jlongArray new_value_arr, jlongArray old_value_arr )
{
	nkprintf("posix.cpp settimer() called. which=%lld \n", which );

	jlong* p_new_value = env->GetLongArrayElements( new_value_arr, NULL );
	jlong* p_old_value = env->GetLongArrayElements( old_value_arr, NULL );

	struct itimerval new_value, old_value;

	new_value.it_interval.tv_sec	= p_new_value[0];
	new_value.it_interval.tv_usec	= p_new_value[1];
	new_value.it_value.tv_sec	= p_new_value[2];
	new_value.it_value.tv_usec	= p_new_value[3];

	old_value.it_interval.tv_sec	= p_old_value[0];
	old_value.it_interval.tv_usec	= p_old_value[1];
	old_value.it_value.tv_sec	= p_old_value[2];
	old_value.it_value.tv_usec	= p_old_value[3];



	jlong ret = setitimer( which, &new_value, &old_value );

	p_new_value[0]		= new_value.it_interval.tv_sec;
	p_new_value[1]		= new_value.it_interval.tv_usec;
	p_new_value[2]		= new_value.it_value.tv_sec;
	p_new_value[3]		= new_value.it_value.tv_usec;

	p_old_value[0]		= old_value.it_interval.tv_sec;
	p_old_value[1]		= old_value.it_interval.tv_usec;
	p_old_value[2]		= old_value.it_value.tv_sec;
	p_old_value[3]		= old_value.it_value.tv_usec;


	env->ReleaseLongArrayElements( new_value_arr, p_new_value, 0 );
	env->ReleaseLongArrayElements( old_value_arr, p_old_value, 0 );

	return ret;
}



JNIEXPORT jlong JNICALL _PACKAGE(getrusage)(JNIEnv *env, jclass jcls, jlong who, jlongArray rusage_arr)
{
	// 10/01/27.
	// int getrusage(int who, struct rusage *usage);
	/*
	struct rusage
	{
		struct timeval ru_utime;	// gpꂽ[U[ 
		struct timeval ru_stime; 	// gpꂽVXe 

		long   ru_maxrss;		// RAM ɑ݂鉼zy[W̃TCY
   						//	(resident set size) ̍ől 
		long   ru_ixrss;		// L̍vTCY 
		long   ru_idrss;		// 񋤗Lf[^̍vTCY 
		long   ru_isrss;		// 񋤗LX^bN̍vTCY 
		long   ru_minflt;		// pꂽy[W 
		long   ru_majflt;		// y[WtH[g 
		long   ru_nswap;		// Xbv 
		long   ru_inblock;		// ubN͑ 
		long   ru_oublock;		// ubNo͑ 
		long   ru_msgsnd;		// MꂽbZ[W 
		long   ru_msgrcv;		// MꂽbZ[W 
		long   ru_nsignals;		// MꂽVOi 
		long   ru_nvcsw;		// Ӑ}ReLXg؂ւ 
		long   ru_nivcsw;		// Ӑ}ȂReLXg؂ւ 
	};
	*/


	nkprintf("posix.cpp getrusage() called. who=%lld \n", who );

	jlong* p_rusage_arr = env->GetLongArrayElements( rusage_arr, NULL );

	struct rusage usage;

	jlong ret = getrusage( who, &usage );

	p_rusage_arr[0]		=	usage.ru_utime.tv_sec;
	p_rusage_arr[1]		=	usage.ru_utime.tv_usec;
	p_rusage_arr[2]		=	usage.ru_stime.tv_sec;
	p_rusage_arr[3]		=	usage.ru_stime.tv_usec;

	p_rusage_arr[4]		=	usage.ru_maxrss;

	p_rusage_arr[5]		=	usage.ru_ixrss;
	p_rusage_arr[6]		=	usage.ru_idrss;
	p_rusage_arr[7]		=	usage.ru_isrss;
	p_rusage_arr[8]		=	usage.ru_minflt;
	p_rusage_arr[9]		=	usage.ru_majflt;
	p_rusage_arr[10]	=	usage.ru_nswap;
	p_rusage_arr[11]	=	usage.ru_inblock;
	p_rusage_arr[12]	=	usage.ru_oublock;
	p_rusage_arr[13]	=	usage.ru_msgsnd;
	p_rusage_arr[14]	=	usage.ru_msgrcv;
	p_rusage_arr[15]	=	usage.ru_nsignals;

	
	p_rusage_arr[16]	=	usage.ru_nvcsw;
	p_rusage_arr[17]	=	usage.ru_nivcsw;
	

	env->ReleaseLongArrayElements( rusage_arr, p_rusage_arr, 0 );


	nkprintf("posix.cpp getrusage() ret=%lld \n", ret );

	return ret;

}

















